import { d as defineComponent, r as ref, i as inject, o as onMounted, c as computed, x as openBlock, Q as createBlock, B as withCtx, Z as createTextVNode, z as createBaseVNode, ax as withDirectives, aF as vModelSelect, y as createElementBlock, O as Fragment, P as renderList, C as normalizeClass, D as unref, aS as getDiskIDName, A as createVNode, F as render, G as createCommentVNode, E as toDisplayString, aT as truncateName, aH as _sfc_main$1, b2 as attachDisk, p as pushNotification, N as Notification, aW as convertSizeToBytes, l as loadDisksThenPools, a as loadDatasets, b as loadScanObjectGroup, e as loadScanActivities, f as loadDiskStats, h as loadTrimActivities } from "./index.6d4442b8.js";
import { l as loadImportablePools } from "./loadImportables.89a51a80.js";
import { r as render$1 } from "./ExclamationTriangleIcon.be4eb01d.js";
import { u as ue } from "./switch.bba63450.js";
const _hoisted_1 = ["for"];
const _hoisted_2 = ["id"];
const _hoisted_3 = ["for"];
const _hoisted_4 = ["id"];
const _hoisted_5 = ["title"];
const _hoisted_6 = ["for"];
const _hoisted_7 = { class: "flex flex-row flex-grow w-full justify-between" };
const _hoisted_8 = ["id", "value", "name", "checked", "onChange"];
const _hoisted_9 = {
  key: 0,
  title: "Disk already has partitions. Proceed with caution.",
  class: "flex items-center justify-center h-6 w-6 bg-default rounded-full ml-2"
};
const _hoisted_10 = {
  key: 1,
  title: "This disk belongs to an exported pool. Force Add to override.",
  class: "flex items-center justify-center h-6 w-6 bg-default rounded-full ml-2"
};
const _hoisted_11 = { class: "truncate text-sm font-medium text-default" };
const _hoisted_12 = { class: "mt-1 truncate text-sm text-default" };
const _hoisted_13 = { class: "mt-1 truncate text-sm text-default" };
const _hoisted_14 = { key: 1 };
const _hoisted_15 = { class: "w-full grid grid-rows-2" };
const _hoisted_16 = { class: "w-full row-start-1 justify-center items-center" };
const _hoisted_17 = { class: "justify-self-start mt-2" };
const _hoisted_18 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_19 = {
  key: 1,
  class: "text-danger"
};
const _hoisted_20 = { class: "button-group-row w-full justify-between row-start-2" };
const _hoisted_21 = { class: "button-group-row mt-2" };
const _hoisted_22 = ["id"];
const _hoisted_23 = { class: "flex flex-row" };
const _hoisted_24 = ["for"];
const _hoisted_25 = { class: "button-group-row mt-2" };
const _hoisted_26 = {
  key: 1,
  disabled: "",
  id: "finish",
  type: "button",
  class: "btn btn-primary object-right justify-end"
};
const phyPathPrefix = "/dev/disk/by-path/";
const sdPathPrefix = "/dev/";
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "AttachDiskModal",
  props: {
    idKey: {},
    pool: {},
    vDev: {},
    showFlag: { type: Boolean }
  },
  emits: ["close"],
  setup(__props, { emit: __emit }) {
    const props = __props;
    const showFlag = ref(props.showFlag);
    inject("style-truncate-text");
    const emit = __emit;
    const closeModal = () => {
      emit("close");
    };
    onMounted(() => {
    });
    const showAttachDiskModal = inject("show-attach-modal");
    const selectedDisk = ref("");
    function selectSingleDisk(diskName) {
      selectedDisk.value = selectedDisk.value === diskName ? "" : diskName;
    }
    const pools = inject("pools");
    const allDisks = inject("disks");
    const datasets = inject("datasets");
    const diskIdentifier = ref("vdev_path");
    const diskSizeFeedback = ref("");
    const newDisk = ref();
    const oldDisk = ref();
    const diskNewName = ref("");
    const diskNewPath = ref("");
    const diskExistPath = ref("");
    const diskExistName = ref("");
    const diskBelongsFeedback = ref("");
    const adding = ref(false);
    inject("pools");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    const diskVDevPoolData = ref({
      existingDiskName: "",
      newDiskName: "",
      vDevName: props.vDev.name,
      poolName: props.pool.name,
      forceAttach: false
    });
    const availableDisks = computed(() => {
      return allDisks.value.filter((disk) => disk.guid === "");
    });
    const diskCardClass = (diskName) => {
      return selectedDisk.value === diskName ? "bg-green-300 dark:bg-green-700" : "";
    };
    function setDiskNamePath() {
      const oldDisks = props.vDev.disks;
      console.log("setting oldDisks:", oldDisks);
      oldDisk.value = oldDisks.pop();
      console.log("setting oldDisk.value:", oldDisk.value);
      console.log("getting selectedDisk.value:", selectedDisk.value);
      newDisk.value = allDisks.value.find((disk) => disk.name === selectedDisk.value);
      console.log("setting newDisk.value:", newDisk.value);
      switch (diskIdentifier.value) {
        case "vdev_path":
          diskNewPath.value = newDisk.value.vdev_path;
          diskNewName.value = selectedDisk.value;
          diskExistPath.value = oldDisk.value.path;
          diskExistName.value = oldDisk.value.name;
          console.log("diskNewPath:", diskNewPath.value, "diskNewName:", diskNewName.value);
          console.log("diskExistPath:", diskExistPath.value, "diskExistName:", diskExistName.value);
          break;
        case "phy_path":
          diskNewPath.value = newDisk.value.phy_path;
          diskNewName.value = diskNewPath.value.replace(phyPathPrefix, "");
          diskExistPath.value = oldDisk.value.path;
          diskExistName.value = diskExistPath.value.replace(phyPathPrefix, "");
          console.log("diskNewPath:", diskNewPath.value, "diskNewName:", diskNewName.value);
          console.log("diskExistPath:", diskExistPath.value, "diskExistName:", diskExistName.value);
          break;
        case "sd_path":
          diskNewPath.value = newDisk.value.sd_path;
          diskNewName.value = diskNewPath.value.replace(sdPathPrefix, "");
          diskExistPath.value = oldDisk.value.path;
          diskExistName.value = diskExistPath.value.replace(sdPathPrefix, "");
          console.log("diskNewPath:", diskNewPath.value, "diskNewName:", diskNewName.value);
          console.log("diskExistPath:", diskExistPath.value, "diskExistName:", diskExistName.value);
          break;
        default:
          console.log("error with set diskName/paths");
          break;
      }
    }
    async function attachDiskBtn() {
      if (diskSizeMatch()) {
        if (!diskBelongsToImportablePool() || diskVDevPoolData.value.forceAttach) {
          setDiskNamePath();
          diskVDevPoolData.value.newDiskName = diskNewName.value;
          diskVDevPoolData.value.existingDiskName = diskExistName.value;
          console.log("all data of disk being attached:", diskVDevPoolData.value);
          adding.value = true;
          try {
            const output = await attachDisk(diskVDevPoolData.value);
            if (output == null || output.error) {
              const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
              adding.value = false;
              pushNotification(new Notification("Disk Attach Failed", `There was an error attaching this disk: ${errorMessage}`, "error", 5e3));
            } else {
              showAttachDiskModal.value = false;
              adding.value = false;
              await refreshAllData();
              pushNotification(new Notification("Disk Attached", `Attached disk to virtual device successfully.`, "success", 5e3));
            }
          } catch (error) {
            console.error(error);
          }
        }
      }
    }
    const diskSizeMatch = () => {
      let result = true;
      diskSizeFeedback.value = "";
      console.log("Checking disk:", selectedDisk.value);
      if (selectedDisk.value == "") {
        diskSizeFeedback.value = "At least one disk is required.";
        return false;
      }
      const newDiskData = allDisks.value.find((fullDisk) => fullDisk.name === selectedDisk.value);
      if (newDiskData) {
        const newCapacity = convertSizeToBytes(newDiskData.capacity);
        console.log("newCapacity:", newCapacity);
        const oldDisks = props.vDev.disks;
        console.log("oldDisks:", oldDisks);
        for (const oldDisk2 of oldDisks) {
          const currentCapacity = convertSizeToBytes(oldDisk2.capacity);
          console.log("currentCapacity:", currentCapacity);
          if (newCapacity < currentCapacity) {
            diskSizeFeedback.value = "Cannot Attach. Please select a disk that has capacity greater than or equal to current disks.";
            result = false;
            break;
          }
        }
      }
      return result;
    };
    const importablePools = inject("importable-pools");
    const diskBelongsToImportablePool = () => {
      let result = false;
      diskBelongsFeedback.value = "";
      if (diskVDevPoolData.value.forceAttach) {
        return false;
      }
      const selectedNewDisk = allDisks.value.find((fullDisk) => fullDisk.name == selectedDisk.value);
      console.log("selectedDisk:", selectedDisk);
      importablePools.value.forEach((pool) => {
        console.log("importablePool:", pool);
        pool.vdevs.forEach((importableVDev) => {
          console.log("importableVDev:", importableVDev);
          importableVDev.disks.forEach((disk) => {
            console.log("importableDisk:", disk);
            if (selectedNewDisk.name == disk.name) {
              result = true;
              diskBelongsFeedback.value = `This disk was used in exported pool '${pool.name}'.
 Use Force Add to override and use disk in new Vdev.`;
              console.log(`Disk belongs to importable pool: ${pool.name}`);
            }
          });
        });
      });
      console.log("diskBelongsFeedback:", diskBelongsFeedback.value);
      return result;
    };
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      allDisks.value = [];
      pools.value = [];
      datasets.value = [];
      await loadDisksThenPools(allDisks, pools);
      await loadDatasets(datasets);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(pools, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(pools, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
    }
    onMounted(() => {
      loadImportablePools(importablePools.value);
    });
    const getIdKey = (name) => `${props.idKey}-${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: showFlag.value,
        onClose: _cache[2] || (_cache[2] = ($event) => closeModal()),
        marginTop: "mt-28",
        width: "w-3/5",
        minWidth: "min-w-3/5",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[3] || (_cache[3] = [
          createTextVNode(" Attach Disk ")
        ])),
        content: withCtx(() => [
          createBaseVNode("div", null, [
            createBaseVNode("div", null, [
              createBaseVNode("label", {
                for: getIdKey("disk-identifier"),
                class: "block text-sm font-medium leading-6 text-default"
              }, "Disk Identifier", 8, _hoisted_1),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("disk-identifier"),
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => diskIdentifier.value = $event),
                name: "disk-identifier",
                class: "text-default bg-default mt-1 block w-full input-textlike sm:text-sm sm:leading-6"
              }, _cache[4] || (_cache[4] = [
                createBaseVNode("option", { value: "sd_path" }, "Block Device", -1),
                createBaseVNode("option", { value: "phy_path" }, "Hardware Path", -1),
                createBaseVNode("option", { value: "vdev_path" }, "Device Alias", -1)
              ]), 8, _hoisted_2), [
                [vModelSelect, diskIdentifier.value]
              ])
            ]),
            createBaseVNode("label", {
              for: getIdKey("available-disk-list"),
              class: "my-1 block text-sm font-medium leading-6 text-default"
            }, "Select Disks", 8, _hoisted_3),
            availableDisks.value.length > 0 ? (openBlock(), createElementBlock("ul", {
              key: 0,
              id: getIdKey("available-disk-list"),
              role: "list",
              class: "flex flex-row flex-wrap gap-2"
            }, [
              (openBlock(true), createElementBlock(Fragment, null, renderList(availableDisks.value, (disk, diskIdx) => {
                return openBlock(), createElementBlock("li", {
                  key: diskIdx,
                  class: "my-2"
                }, [
                  createBaseVNode("button", {
                    class: normalizeClass(["flex min-w-fit w-full h-full border border-default rounded-lg", diskCardClass(disk.name)]),
                    title: disk.hasPartitions ? "Disk already has partitions. Proceed with caution." : unref(getDiskIDName)(unref(allDisks), diskIdentifier.value, disk.name)
                  }, [
                    createBaseVNode("label", {
                      for: getIdKey(`disk-${diskIdx}`),
                      class: "flex flex-col w-full py-4 mx-2 text-sm gap-0.5 justify-start"
                    }, [
                      createBaseVNode("span", _hoisted_7, [
                        createBaseVNode("input", {
                          id: getIdKey(`disk-${diskIdx}`),
                          type: "checkbox",
                          value: disk.name,
                          name: `disk-${disk.name}`,
                          checked: selectedDisk.value === disk.name,
                          onChange: ($event) => selectSingleDisk(disk.name),
                          class: "justify-start w-4 h-4 text-success bg-well border-default rounded focus:ring-green-500 dark:focus:ring-green-600 dark:ring-offset-gray-800 focus:ring-2"
                        }, null, 40, _hoisted_8),
                        disk.hasPartitions ? (openBlock(), createElementBlock("div", _hoisted_9, [
                          createVNode(unref(render), { class: "h-6 text-orange-700" })
                        ])) : createCommentVNode("", true),
                        disk.errors && disk.errors.length > 0 ? (openBlock(), createElementBlock("div", _hoisted_10, [
                          createVNode(unref(render$1), { class: "h-6 text-danger" })
                        ])) : createCommentVNode("", true)
                      ]),
                      createBaseVNode("h3", _hoisted_11, toDisplayString(unref(truncateName)(unref(getDiskIDName)(unref(allDisks), diskIdentifier.value, disk.name), 8)), 1),
                      createBaseVNode("p", _hoisted_12, toDisplayString(disk.type), 1),
                      createBaseVNode("p", _hoisted_13, "Capacity: " + toDisplayString(disk.capacity), 1)
                    ], 8, _hoisted_6)
                  ], 10, _hoisted_5)
                ]);
              }), 128))
            ], 8, _hoisted_4)) : createCommentVNode("", true),
            availableDisks.value.length == 0 ? (openBlock(), createElementBlock("div", _hoisted_14, " No Disks Available ")) : createCommentVNode("", true)
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_15, [
            createBaseVNode("div", _hoisted_16, [
              createBaseVNode("div", _hoisted_17, [
                diskSizeFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_18, toDisplayString(diskSizeFeedback.value), 1)) : createCommentVNode("", true),
                diskBelongsFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_19, toDisplayString(diskBelongsFeedback.value), 1)) : createCommentVNode("", true)
              ])
            ]),
            createBaseVNode("div", _hoisted_20, [
              createBaseVNode("div", _hoisted_21, [
                createBaseVNode("button", {
                  onClick: closeModal,
                  id: getIdKey("close-attach-disk-btn"),
                  name: "close-attach-disk-btn",
                  class: "btn btn-danger"
                }, "Close", 8, _hoisted_22),
                createBaseVNode("div", _hoisted_23, [
                  createBaseVNode("label", {
                    for: getIdKey("force-add-vdev"),
                    class: "mt-2 mr-2 block text-sm font-medium leading-6 text-default"
                  }, "Forcefully Attach Disk", 8, _hoisted_24),
                  createVNode(unref(ue), {
                    modelValue: diskVDevPoolData.value.forceAttach,
                    "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => diskVDevPoolData.value.forceAttach = $event),
                    id: getIdKey("force-add-vdev"),
                    class: normalizeClass([diskVDevPoolData.value.forceAttach ? "bg-primary" : "bg-accent", "mt-2 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[7] || (_cache[7] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([diskVDevPoolData.value.forceAttach ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([diskVDevPoolData.value.forceAttach ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[5] || (_cache[5] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([diskVDevPoolData.value.forceAttach ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[6] || (_cache[6] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ])
              ]),
              createBaseVNode("div", _hoisted_25, [
                !adding.value ? (openBlock(), createElementBlock("button", {
                  key: 0,
                  id: "attach-disk-btn",
                  class: "btn btn-primary object-right justify-end mr-4 h-fit w-full",
                  onClick: attachDiskBtn
                }, "Attach Disk")) : createCommentVNode("", true),
                adding.value ? (openBlock(), createElementBlock("button", _hoisted_26, _cache[8] || (_cache[8] = [
                  createBaseVNode("svg", {
                    "aria-hidden": "true",
                    role: "status",
                    class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                    viewBox: "0 0 100 101",
                    fill: "none",
                    xmlns: "http://www.w3.org/2000/svg"
                  }, [
                    createBaseVNode("path", {
                      d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                      fill: "currentColor"
                    }),
                    createBaseVNode("path", {
                      d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                      fill: "text-success"
                    })
                  ], -1),
                  createTextVNode(" Attaching... ")
                ]))) : createCommentVNode("", true)
              ])
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
