import { d as defineComponent, i as inject, r as ref, c as computed, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, C as normalizeClass, D as unref, E as toDisplayString, ax as withDirectives, y as createElementBlock, O as Fragment, P as renderList, aF as vModelSelect, aG as vModelText, A as createVNode, G as createCommentVNode, Z as createTextVNode, aH as _sfc_main$1, bh as cloneSnapshot, p as pushNotification, N as Notification } from "./index.6d4442b8.js";
import { u as ue } from "./switch.bba63450.js";
const _hoisted_1 = { class: "grid grid-cols-1" };
const _hoisted_2 = { class: "mt-2 col-span-1" };
const _hoisted_3 = ["for"];
const _hoisted_4 = ["title"];
const _hoisted_5 = { class: "mt-2 col-span-1" };
const _hoisted_6 = ["for"];
const _hoisted_7 = ["id"];
const _hoisted_8 = ["title"];
const _hoisted_9 = { class: "mt-2 col-span-1" };
const _hoisted_10 = ["for"];
const _hoisted_11 = ["id"];
const _hoisted_12 = { class: "mt-2 col-span-1" };
const _hoisted_13 = { class: "flex flex-row justify-between" };
const _hoisted_14 = ["for"];
const _hoisted_15 = { class: "w-full grid grid-rows-2" };
const _hoisted_16 = { class: "w-full row-start-1" };
const _hoisted_17 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_18 = { class: "button-group-row justify-between" };
const _hoisted_19 = ["id"];
const _hoisted_20 = { class: "button-group-row" };
const _hoisted_21 = {
  key: 1,
  disabled: "",
  id: "finish",
  type: "button",
  class: "btn btn-primary object-right justify-end"
};
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "CloneSnapshot",
  props: {
    idKey: {},
    snapshot: {}
  },
  setup(__props) {
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const showCloneSnapModal = inject("show-clone-modal");
    const datasets = inject("datasets");
    const fileSystemsLoaded = inject("datasets-loaded");
    const cloning = inject("cloning");
    const confirmCloneSnap = inject("confirm-clone-snap");
    const nameFeedback = ref("");
    const parentFS = ref(props.snapshot.dataset);
    const newName = ref("");
    const createNonExistParent = ref(false);
    function getChildDatasetIds(dataset, allDatasets) {
      let childIds = [];
      const children = allDatasets.filter((child) => child.parentFS === dataset.id);
      for (const child of children) {
        childIds.push(child.id);
        childIds = childIds.concat(getChildDatasetIds(child, allDatasets));
      }
      return childIds;
    }
    const datasetsInSamePool = computed(() => {
      const currentDataset = props.snapshot.dataset;
      const childDatasetIds = getChildDatasetIds(currentDataset, datasets.value);
      return datasets.value.filter((dataset) => {
        return dataset.pool === props.snapshot.pool && dataset.id !== props.snapshot.id && !childDatasetIds.includes(dataset.id);
      });
    });
    async function cloneBtn() {
      if (nameCheck(newName.value, parentFS.value)) {
        cloning.value = true;
        try {
          const output = await cloneSnapshot(props.snapshot.name, parentFS.value, newName.value, createNonExistParent.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Snapshot Clone Failed", `There was an error cloning this snapshot: ${errorMessage}`, "error", 5e3));
            confirmCloneSnap.value = true;
          } else {
            confirmCloneSnap.value = true;
            fileSystemsLoaded.value = false;
            fileSystemsLoaded.value = true;
            pushNotification(new Notification("Snapshot Cloned", `Cloned snapshot ${props.snapshot.name} to ${newName.value} successfully.`, "success", 5e3));
            showCloneSnapModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        cloning.value = false;
      }
    }
    const nameCheck = (fileSystemName, fileSystemParent) => {
      let result = true;
      nameFeedback.value = "";
      if (fileSystemName == "") {
        result = false;
        nameFeedback.value = "Name cannot be empty.";
      } else if (!fileSystemName.match(/^[a-zA-Z0-9]/)) {
        result = false;
        nameFeedback.value = "Name must begin with alphanumeric characters.";
      } else if (fileSystemName.match(/^[ ]/)) {
        result = false;
        nameFeedback.value = "Name cannot begin with whitespace.";
      } else if (fileSystemName.match(/[ ]$/)) {
        result = false;
        nameFeedback.value = "Name cannot end with whitespace.";
      } else if (!fileSystemName.match(/^[a-zA-Z0-9_.:-]*$/)) {
        result = false;
        nameFeedback.value = "Name contains invalid characters.";
      } else if (fileSystemNameExists(fileSystemName, fileSystemParent, datasets.value)) {
        result = false;
        nameFeedback.value = `Name already exists in this location: ${fileSystemParent}.`;
      }
      return result;
    };
    function fileSystemNameExists(filesystemName, fileSystemParent, datasets2) {
      const newParentPath = fileSystemParent;
      for (const dataset of datasets2) {
        const existingParentPath = dataset.parentFS;
        const existingDatasetName = dataset.name.split("/").pop();
        if (existingParentPath === newParentPath && existingDatasetName === filesystemName) {
          return true;
        }
      }
      return false;
    }
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: unref(showCloneSnapModal),
        onClose: _cache[5] || (_cache[5] = ($event) => showCloneSnapModal.value = false),
        marginTop: "mt-28",
        width: "w-4/12",
        minWidth: "min-w-4/12",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[6] || (_cache[6] = [
          createBaseVNode("legend", { class: "flex justify-center" }, "Clone Snapshot", -1)
        ])),
        content: withCtx(() => [
          createBaseVNode("div", _hoisted_1, [
            createBaseVNode("div", _hoisted_2, [
              createBaseVNode("label", {
                for: getIdKey("snap-name"),
                class: "mt-1 block text-sm font-medium leading-6 text-default"
              }, "Snapshot Name", 8, _hoisted_3),
              createBaseVNode("p", {
                class: normalizeClass(unref(truncateText)),
                title: props.snapshot.name
              }, toDisplayString(props.snapshot.name), 11, _hoisted_4)
            ]),
            createBaseVNode("div", _hoisted_5, [
              createBaseVNode("label", {
                for: getIdKey("parent-filesystem"),
                class: "block text-sm font-medium leading-6 text-default"
              }, "Parent File System", 8, _hoisted_6),
              withDirectives(createBaseVNode("select", {
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => parentFS.value = $event),
                id: getIdKey("parent-filesystem"),
                class: "text-default bg-default mt-1 block w-full input-textlike sm:text-sm sm:leading-6"
              }, [
                (openBlock(true), createElementBlock(Fragment, null, renderList(datasetsInSamePool.value, (dataset, datasetIdx) => {
                  return openBlock(), createElementBlock("option", {
                    key: datasetIdx,
                    class: normalizeClass(unref(truncateText)),
                    title: dataset.name
                  }, toDisplayString(dataset.name), 11, _hoisted_8);
                }), 128))
              ], 8, _hoisted_7), [
                [vModelSelect, parentFS.value]
              ])
            ]),
            createBaseVNode("div", _hoisted_9, [
              createBaseVNode("label", {
                for: getIdKey("new-name"),
                class: "mt-1 block text-sm font-medium leading-6 text-default"
              }, "Clone Name", 8, _hoisted_10),
              withDirectives(createBaseVNode("input", {
                id: getIdKey("new-name"),
                type: "text",
                "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => newName.value = $event),
                class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default placeholder:text-muted sm:text-sm sm:leading-6",
                placeholder: "Enter Name Here"
              }, null, 8, _hoisted_11), [
                [vModelText, newName.value]
              ])
            ]),
            createBaseVNode("div", _hoisted_12, [
              createBaseVNode("div", _hoisted_13, [
                createBaseVNode("label", {
                  for: getIdKey("create-parent-filesystems"),
                  class: "mt-2 mr-2 block text-sm font-medium leading-6 text-default"
                }, "Create Non-Existent Parent File Systems", 8, _hoisted_14),
                createVNode(unref(ue), {
                  modelValue: createNonExistParent.value,
                  "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => createNonExistParent.value = $event),
                  id: getIdKey("create-parent-filesystems"),
                  class: normalizeClass([createNonExistParent.value ? "bg-primary" : "bg-accent", "mt-2 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[9] || (_cache[9] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([createNonExistParent.value ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([createNonExistParent.value ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[7] || (_cache[7] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([createNonExistParent.value ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[8] || (_cache[8] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ])
            ])
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_15, [
            createBaseVNode("div", _hoisted_16, [
              nameFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_17, toDisplayString(nameFeedback.value), 1)) : createCommentVNode("", true)
            ]),
            createBaseVNode("div", _hoisted_18, [
              createBaseVNode("button", {
                onClick: _cache[3] || (_cache[3] = ($event) => showCloneSnapModal.value = false),
                id: getIdKey("confirm-clone-no"),
                name: "clone-button-no",
                class: "btn btn-secondary object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_19),
              createBaseVNode("div", _hoisted_20, [
                !unref(cloning) ? (openBlock(), createElementBlock("button", {
                  key: 0,
                  id: "clone-snapshot-btn",
                  class: "btn btn-primary object-right justify-end h-fit w-full",
                  onClick: _cache[4] || (_cache[4] = ($event) => cloneBtn())
                }, "Clone")) : createCommentVNode("", true),
                unref(cloning) ? (openBlock(), createElementBlock("button", _hoisted_21, _cache[10] || (_cache[10] = [
                  createBaseVNode("svg", {
                    "aria-hidden": "true",
                    role: "status",
                    class: "inline w-4 h-4 text-gray-200 animate-spin text-default",
                    viewBox: "0 0 100 101",
                    fill: "none",
                    xmlns: "http://www.w3.org/2000/svg"
                  }, [
                    createBaseVNode("path", {
                      d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                      fill: "currentColor"
                    }),
                    createBaseVNode("path", {
                      d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                      fill: "text-success"
                    })
                  ], -1),
                  createTextVNode(" Cloning... ")
                ]))) : createCommentVNode("", true)
              ])
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
