import { d as defineComponent, i as inject, c as computed, r as ref, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, ax as withDirectives, y as createElementBlock, C as normalizeClass, D as unref, O as Fragment, P as renderList, E as toDisplayString, aF as vModelSelect, G as createCommentVNode, A as createVNode, aG as vModelText, aZ as withKeys, Z as createTextVNode, aH as _sfc_main$1, bb as getSnapshotTimestamp, bc as createSnapshot, p as pushNotification, N as Notification, at as loadSnapshotsInPool, au as loadSnapshotsInDataset } from "./index.6d4442b8.js";
import { u as ue } from "./switch.bba63450.js";
const _hoisted_1 = ["for"];
const _hoisted_2 = ["value", "title"];
const _hoisted_3 = ["value", "title"];
const _hoisted_4 = ["for"];
const _hoisted_5 = ["for"];
const _hoisted_6 = ["id"];
const _hoisted_7 = ["id"];
const _hoisted_8 = ["for"];
const _hoisted_9 = { class: "w-full grid grid-rows-2" };
const _hoisted_10 = { class: "w-full" };
const _hoisted_11 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_12 = {
  key: 1,
  class: "text-danger"
};
const _hoisted_13 = { class: "button-group-row mt-2 justify-between" };
const _hoisted_14 = ["id"];
const _hoisted_15 = ["id"];
const _hoisted_16 = ["id"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "CreateSnapshotModal",
  props: {
    item: {},
    poolName: {}
  },
  setup(__props) {
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const datasets = inject("datasets");
    const datasetsInSamePool = computed(() => {
      return datasets.value.filter((dataset) => dataset.pool === props.poolName);
    });
    const defaultFileSystem = ref();
    const selectedDataset = inject("selected-dataset");
    const snapshots = inject("snapshots");
    const showSnapshotModal = inject("create-snap-modal");
    const creating = inject("creating");
    initialize();
    function refreshSnapshots() {
      clearSnapshots();
      loadTheseSnapshots();
    }
    function clearSnapshots() {
      snapshots.value = [];
    }
    function loadTheseSnapshots() {
      if (props.item == "pool") {
        loadSnapshotsInPool(snapshots, props.poolName);
      } else if (props.item == "filesystem") {
        loadSnapshotsInDataset(snapshots, selectedDataset.value.name, null, null);
      }
    }
    function initialize() {
      if (props.item == "pool") {
        defaultFileSystem.value = datasetsInSamePool.value[0];
      } else if (props.item == "filesystem") {
        defaultFileSystem.value = selectedDataset.value;
      }
    }
    const newSnapshot = ref({
      name: "",
      filesystem: defaultFileSystem.value.name,
      isCustomName: false,
      snapChildren: false
    });
    const nameFeedback = ref("");
    const filesystemFeedback = ref("");
    const confirmCreate = inject("confirm-create-snap");
    const filesystemCheck = (newSnapshot2) => {
      let result = true;
      filesystemFeedback.value = "";
      if (newSnapshot2.filesystem == "") {
        result = false;
        filesystemFeedback.value = "Please select a File System.";
      }
      return result;
    };
    const nameCheck = (newSnapshot2) => {
      let result = true;
      nameFeedback.value = "";
      if (newSnapshot2.name == "") {
        result = false;
        nameFeedback.value = "Name cannot be empty.";
      } else if (!newSnapshot2.name.match(/^[a-zA-Z0-9]/)) {
        result = false;
        nameFeedback.value = "Name must begin with alphanumeric characters.";
      } else if (newSnapshot2.name.match(/^[ ]/)) {
        result = false;
        nameFeedback.value = "Name cannot begin with whitespace.";
      } else if (newSnapshot2.name.match(/[ ]$/)) {
        result = false;
        nameFeedback.value = "Name cannot end with whitespace.";
      } else if (!newSnapshot2.name.match(/^[a-zA-Z0-9_.:-]*$/)) {
        result = false;
        nameFeedback.value = "Name contains invalid characters.";
      } else if (nameExists(newSnapshot2, snapshots.value)) {
        result = false;
        nameFeedback.value = "A snapshot with that name already exists.";
      }
      return result;
    };
    function nameExists(newSnapshot2, snapshots2) {
      const newSnapName = newSnapshot2.name;
      for (const snapshot of snapshots2) {
        const existingSnapName = snapshot.name;
        if (existingSnapName === newSnapName) {
          return true;
        }
      }
      return false;
    }
    function createSnapButton(newSnapshot2) {
      if (newSnapshot2.isCustomName) {
        if (nameCheck(newSnapshot2)) {
          if (filesystemCheck(newSnapshot2)) {
            create(newSnapshot2);
          }
        }
      } else if (!newSnapshot2.isCustomName) {
        newSnapshot2.name = getSnapshotTimestamp();
        if (filesystemCheck(newSnapshot2)) {
          create(newSnapshot2);
        }
      }
    }
    async function create(newSnapshot2) {
      creating.value = true;
      try {
        const output = await createSnapshot(newSnapshot2);
        if (output == null || output.error) {
          const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
          pushNotification(new Notification("Create Snapshot Failed", `There was an error creating this snapshot: ${errorMessage}`, "error", 5e3));
          confirmCreate.value = false;
        } else {
          confirmCreate.value = true;
          newSnapshot2.isCustomName = false;
          newSnapshot2.snapChildren = false;
          pushNotification(new Notification("Snapshot Created", `Created new snapshot.`, "success", 5e3));
          refreshSnapshots();
          showSnapshotModal.value = false;
        }
      } catch (error) {
        console.error(error);
      }
      creating.value = false;
    }
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: unref(showSnapshotModal),
        marginTop: "mt-48",
        width: "w-4/12",
        minWidth: "min-w-4/12",
        class: "z-20",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[9] || (_cache[9] = [
          createBaseVNode("legend", { class: "flex justify-center" }, "Create Snapshot", -1)
        ])),
        content: withCtx(() => [
          createBaseVNode("div", null, [
            createBaseVNode("div", null, [
              createBaseVNode("label", {
                for: getIdKey("file-system"),
                class: "block text-sm font-medium leading-6 text-default"
              }, "File System", 8, _hoisted_1),
              props.item == "pool" ? withDirectives((openBlock(), createElementBlock("select", {
                key: 0,
                id: "file-system",
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => newSnapshot.value.filesystem = $event),
                name: "file-system",
                class: normalizeClass([unref(truncateText), "text-default bg-default mt-1 block w-full rounded-md border-0 py-1.5 pl-3 pr-10 ring-1 ring-inset ring-gray-300 focus:ring-2 focus:ring-slate-600 sm:text-sm sm:leading-6"])
              }, [
                (openBlock(true), createElementBlock(Fragment, null, renderList(datasetsInSamePool.value, (dataset) => {
                  return openBlock(), createElementBlock("option", {
                    value: dataset.name,
                    class: normalizeClass(unref(truncateText)),
                    title: dataset.name
                  }, toDisplayString(dataset.name), 11, _hoisted_2);
                }), 256))
              ], 2)), [
                [vModelSelect, newSnapshot.value.filesystem]
              ]) : createCommentVNode("", true),
              props.item == "filesystem" ? withDirectives((openBlock(), createElementBlock("select", {
                key: 1,
                id: "file-system",
                "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => newSnapshot.value.filesystem = $event),
                name: "file-system",
                class: normalizeClass([unref(truncateText), "text-default bg-default mt-1 block w-full rounded-md border-0 py-1.5 pl-3 pr-10 ring-1 ring-inset ring-gray-300 focus:ring-2 focus:ring-slate-600 sm:text-sm sm:leading-6"])
              }, [
                (openBlock(true), createElementBlock(Fragment, null, renderList(unref(datasets), (dataset) => {
                  return openBlock(), createElementBlock("option", {
                    value: dataset.name,
                    class: normalizeClass(unref(truncateText)),
                    title: dataset.name
                  }, toDisplayString(dataset.name), 11, _hoisted_3);
                }), 256))
              ], 2)), [
                [vModelSelect, newSnapshot.value.filesystem]
              ]) : createCommentVNode("", true)
            ]),
            createBaseVNode("div", null, [
              createBaseVNode("label", {
                for: getIdKey("custom-name"),
                class: "mt-1 block text-sm font-medium leading-6 text-default"
              }, "Custom Name", 8, _hoisted_4),
              createVNode(unref(ue), {
                id: getIdKey("custom-name"),
                modelValue: newSnapshot.value.isCustomName,
                "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => newSnapshot.value.isCustomName = $event),
                class: normalizeClass([newSnapshot.value.isCustomName ? "bg-primary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
              }, {
                default: withCtx(() => [
                  _cache[12] || (_cache[12] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                  createBaseVNode("span", {
                    class: normalizeClass([newSnapshot.value.isCustomName ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                  }, [
                    createBaseVNode("span", {
                      class: normalizeClass([newSnapshot.value.isCustomName ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[10] || (_cache[10] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-muted",
                        fill: "none",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", {
                          d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                          stroke: "currentColor",
                          "stroke-width": "2",
                          "stroke-linecap": "round",
                          "stroke-linejoin": "round"
                        })
                      ], -1)
                    ]), 2),
                    createBaseVNode("span", {
                      class: normalizeClass([newSnapshot.value.isCustomName ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[11] || (_cache[11] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-primary",
                        fill: "currentColor",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                      ], -1)
                    ]), 2)
                  ], 2)
                ]),
                _: 1
              }, 8, ["id", "modelValue", "class"])
            ]),
            createBaseVNode("div", null, [
              createBaseVNode("label", {
                for: getIdKey("snapshot-name"),
                class: "block text-sm font-medium leading-6 text-default"
              }, "Snapshot Name", 8, _hoisted_5),
              !newSnapshot.value.isCustomName ? withDirectives((openBlock(), createElementBlock("input", {
                key: 0,
                type: "text",
                "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => newSnapshot.value.name = $event),
                name: "snapshot-name",
                id: getIdKey("snapshot-name"),
                class: "mt-1 block w-full input-textlike bg-default",
                placeholder: "YYYY.MM.DD-HH.MM.SS",
                disabled: ""
              }, null, 8, _hoisted_6)), [
                [vModelText, newSnapshot.value.name]
              ]) : createCommentVNode("", true),
              newSnapshot.value.isCustomName ? withDirectives((openBlock(), createElementBlock("input", {
                key: 1,
                onKeydown: _cache[4] || (_cache[4] = withKeys(($event) => createSnapButton(newSnapshot.value), ["enter"])),
                type: "text",
                "onUpdate:modelValue": _cache[5] || (_cache[5] = ($event) => newSnapshot.value.name = $event),
                name: "snapshot-name",
                id: getIdKey("snapshot-name"),
                class: "mt-1 block w-full input-textlike bg-default",
                placeholder: "Enter Name Here"
              }, null, 40, _hoisted_7)), [
                [vModelText, newSnapshot.value.name]
              ]) : createCommentVNode("", true)
            ]),
            createBaseVNode("div", null, [
              createBaseVNode("label", {
                for: getIdKey("snap-children"),
                class: "mt-1 block text-sm font-medium leading-6 text-default"
              }, "Create snapshots of child file systems", 8, _hoisted_8),
              createVNode(unref(ue), {
                id: getIdKey("snap-children"),
                modelValue: newSnapshot.value.snapChildren,
                "onUpdate:modelValue": _cache[6] || (_cache[6] = ($event) => newSnapshot.value.snapChildren = $event),
                class: normalizeClass([newSnapshot.value.snapChildren ? "bg-primary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
              }, {
                default: withCtx(() => [
                  _cache[15] || (_cache[15] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                  createBaseVNode("span", {
                    class: normalizeClass([newSnapshot.value.snapChildren ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                  }, [
                    createBaseVNode("span", {
                      class: normalizeClass([newSnapshot.value.snapChildren ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[13] || (_cache[13] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-muted",
                        fill: "none",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", {
                          d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                          stroke: "currentColor",
                          "stroke-width": "2",
                          "stroke-linecap": "round",
                          "stroke-linejoin": "round"
                        })
                      ], -1)
                    ]), 2),
                    createBaseVNode("span", {
                      class: normalizeClass([newSnapshot.value.snapChildren ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[14] || (_cache[14] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-primary",
                        fill: "currentColor",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                      ], -1)
                    ]), 2)
                  ], 2)
                ]),
                _: 1
              }, 8, ["id", "modelValue", "class"])
            ])
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_9, [
            createBaseVNode("div", _hoisted_10, [
              nameFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_11, toDisplayString(nameFeedback.value), 1)) : createCommentVNode("", true),
              filesystemFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_12, toDisplayString(filesystemFeedback.value), 1)) : createCommentVNode("", true)
            ]),
            createBaseVNode("div", _hoisted_13, [
              createBaseVNode("button", {
                onClick: _cache[7] || (_cache[7] = ($event) => showSnapshotModal.value = false),
                id: getIdKey("confirm-no"),
                name: "button-no",
                class: "mt-1 btn btn-danger object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_14),
              !unref(creating) ? (openBlock(), createElementBlock("button", {
                key: 0,
                onClick: _cache[8] || (_cache[8] = ($event) => createSnapButton(newSnapshot.value)),
                id: getIdKey("create-snapshot-btn"),
                name: "create-snapshot-btn",
                class: "mt-1 btn btn-primary"
              }, "Create", 8, _hoisted_15)) : createCommentVNode("", true),
              unref(creating) ? (openBlock(), createElementBlock("button", {
                key: 1,
                disabled: "",
                id: getIdKey("create-snapshot-spinner"),
                type: "button",
                class: "btn btn-danger object-right justify-end h-fit"
              }, _cache[16] || (_cache[16] = [
                createBaseVNode("svg", {
                  "aria-hidden": "true",
                  role: "status",
                  class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                  viewBox: "0 0 100 101",
                  fill: "none",
                  xmlns: "http://www.w3.org/2000/svg"
                }, [
                  createBaseVNode("path", {
                    d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                    fill: "currentColor"
                  }),
                  createBaseVNode("path", {
                    d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                    fill: "text-success"
                  })
                ], -1),
                createTextVNode(" Creating... ")
              ]), 8, _hoisted_16)) : createCommentVNode("", true)
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
