import { d as defineComponent, i as inject, r as ref, c as computed, g as getCapacityColor, o as onMounted, w as watch, p as pushNotification, N as Notification, l as loadDisksThenPools, a as loadDatasets, b as loadScanObjectGroup, e as loadScanActivities, f as loadDiskStats, h as loadTrimActivities, j as destroyPool, k as labelClear, m as resilverPool, n as isPoolUpgradable, u as upgradePool, s as scrubPool, t as trimPool, q as exportPool, v as provide, x as openBlock, y as createElementBlock, z as createBaseVNode, A as createVNode, B as withCtx, C as normalizeClass, D as unref, E as toDisplayString, F as render, G as createCommentVNode, H as ge, S as Se, T as Transition, M as Me, I as be, J as formatStatus, K as render$2, L as normalizeStyle, O as Fragment, P as renderList, Q as createBlock, R as resolveDynamicComponent, U as clearErrors, _ as __vitePreload, V as convertBytesToSize } from "./index.6d4442b8.js";
import { _ as _sfc_main$4 } from "./Card.vue_vue_type_script_setup_true_lang.ad07e235.js";
import { _ as _sfc_main$3 } from "./Status.vue_vue_type_script_setup_true_lang.6c19da9d.js";
import { r as render$1, a as render$3, _ as _sfc_main$5 } from "./LoadingSpinner.vue_vue_type_script_setup_true_lang.0b36469d.js";
const _hoisted_1$2 = { class: "flex flex-row justify-between items-center" };
const _hoisted_2$1 = { class: "flex flex-row flex-grow" };
const _hoisted_3$1 = {
  key: 0,
  title: "Pool was made with a legacy version of ZFS. Upgrade available.",
  class: "flex flex-row justify-between w-fit bg-default rounded-full text-xs items-center"
};
const _hoisted_4$1 = { class: "py-1" };
const _hoisted_5$1 = { class: "flex flex-row justify-between" };
const _hoisted_6$1 = { key: 0 };
const _hoisted_7$1 = { key: 0 };
const _hoisted_8$1 = { class: "w-full bg-well rounded-full mt-2 relative flex h-6 overflow-hidden" };
const _hoisted_9$1 = { class: "absolute inset-0 flex items-center justify-center text-s font-medium text-default text-center p-0.5 leading-none" };
const _hoisted_10$1 = { key: 1 };
const _hoisted_11$1 = { class: "w-full bg-well rounded-full mt-2 relative flex h-6 overflow-hidden" };
const _hoisted_12$1 = { class: "absolute inset-0 flex items-center justify-center text-s font-medium text-default text-center p-0.5 leading-none" };
const _hoisted_13$1 = { class: "grid grid-rows-5" };
const _hoisted_14 = { class: "row-start-1" };
const _hoisted_15 = { class: "row-start-2" };
const _hoisted_16 = { class: "row-start-3" };
const _hoisted_17 = { class: "row-start-4" };
const _hoisted_18 = { class: "row-start-5" };
const _hoisted_19 = { class: "flex flex-col text-center justify-center items-center" };
const _hoisted_20 = { class: "mb-2" };
const _hoisted_21 = { class: "font-medium text-default" };
const _hoisted_22 = { class: "text-sm text-muted" };
const _hoisted_23 = { class: "flex flex-row items-center text-center justify-center" };
const _hoisted_24 = { class: "grid grid-cols-4 gap-1 min-h-full w-full h-max rounded-sm justify-center" };
const _hoisted_25 = { class: "grid grid-cols-4 gap-1 min-h-full w-full h-max rounded-sm justify-center" };
const _hoisted_26 = { key: 0 };
const _hoisted_27 = { key: 1 };
const _hoisted_28 = { key: 2 };
const _hoisted_29 = { key: 3 };
const _hoisted_30 = { key: 4 };
const _hoisted_31 = { key: 5 };
const _hoisted_32 = { key: 6 };
const _hoisted_33 = { key: 7 };
const _hoisted_34 = { key: 8 };
const _hoisted_35 = { key: 9 };
const _hoisted_36 = { key: 10 };
const _hoisted_37 = { key: 11 };
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "DashPoolCard",
  props: {
    pool: {}
  },
  setup(__props) {
    const truncateText = inject("style-truncate-text");
    const props = __props;
    const selectedPool = ref();
    const poolConfig = ref({
      name: props.pool.name,
      status: props.pool.status,
      guid: props.pool.guid,
      properties: {
        rawsize: props.pool.properties.rawsize,
        size: props.pool.properties.size,
        allocated: props.pool.properties.allocated,
        capacity: props.pool.properties.capacity,
        free: props.pool.properties.free,
        sector: props.pool.properties.sector,
        record: props.pool.properties.record,
        compression: props.pool.properties.compression,
        deduplication: props.pool.properties.deduplication,
        refreservationPercent: props.pool.properties.refreservationPercent,
        autoExpand: props.pool.properties.autoExpand,
        autoReplace: props.pool.properties.autoReplace,
        autoTrim: props.pool.properties.autoTrim,
        forceCreate: props.pool.properties.forceCreate,
        delegation: props.pool.properties.delegation,
        listSnapshots: props.pool.properties.listSnapshots,
        readOnly: props.pool.properties.readOnly,
        available: props.pool.properties.available
      },
      vdevs: props.pool.vdevs,
      failMode: props.pool.failMode,
      comment: props.pool.comment,
      statusCode: props.pool.statusCode,
      statusDetail: props.pool.statusDetail,
      errorCount: props.pool.errorCount
    });
    const capacityColor = computed(
      () => getCapacityColor("bg", props.pool.properties.capacity, props.pool.properties.refreservationPercent)
    );
    function getIsTrimmable() {
      selectedPool.value = props.pool;
      if (selectedPool.value.vdevs.some((vdev) => vdev.type == "data" || vdev.type == "log" || vdev.type == "special" || vdev.type == "dedup")) {
        return true;
      } else {
        return false;
      }
    }
    onMounted(() => {
      getIsTrimmable();
      canUpgradePool(props.pool.name);
    });
    const operationRunning = ref(false);
    const firstOptionToggle = ref(false);
    const secondOptionToggle = ref(false);
    const thirdOptionToggle = ref(false);
    const fourthOptionToggle = ref(false);
    const showPoolDetails = ref(false);
    const confirmSavePool = ref(false);
    const poolDetailsComponent = ref();
    const loadShowPoolComponent = async () => {
      const module = await __vitePreload(() => import("./PoolDetail.99a3ebbd.js"), true ? ["./PoolDetail.99a3ebbd.js","./index.6d4442b8.js","./index.4bb2164e.css","./Card.vue_vue_type_script_setup_true_lang.ad07e235.js","./switch.bba63450.js"] : void 0, import.meta.url);
      poolDetailsComponent.value = module.default;
    };
    async function showDetails(pool) {
      selectedPool.value = pool;
      console.log("loading:", selectedPool.value);
      await loadShowPoolComponent();
      showPoolDetails.value = true;
    }
    const confirmSavePoolDetails = () => {
      confirmSavePool.value = true;
    };
    const updateShowPoolDetails = (newVal) => {
      showPoolDetails.value = newVal;
    };
    watch(confirmSavePool, async (newVal, oldVal) => {
      if (confirmSavePool.value == true) {
        pushNotification(new Notification("Pool Config Saved", `Successfully saved this pool's configuration`, "success", 5e3));
        await refreshAllData();
      }
    });
    const poolData = inject("pools");
    const diskData = inject("disks");
    const filesystemData = inject("datasets");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const scanOperation = computed(() => {
      return scanObjectGroup.value[props.pool.name].function;
    });
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      diskData.value = [];
      poolData.value = [];
      filesystemData.value = [];
      await loadDisksThenPools(diskData, poolData);
      await loadDatasets(filesystemData);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(poolData, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(poolData, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
    }
    const confirmDelete = ref(false);
    const showDeletePoolConfirm = ref(false);
    const clearLabels = inject("clear-labels");
    const selectedDisk = ref();
    const deleteConfirmComponent = ref();
    const loadDeleteConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      deleteConfirmComponent.value = module.default;
    };
    async function destroyPoolAndUpdate(pool) {
      operationRunning.value = false;
      selectedPool.value = pool;
      clearLabels.value = false;
      await loadDeleteConfirmComponent();
      showDeletePoolConfirm.value = true;
      console.log("preparing to delete:", selectedPool.value);
    }
    const confirmThisDestroy = () => {
      confirmDelete.value = true;
    };
    const updateShowDestroyPool = (newVal) => {
      showDeletePoolConfirm.value = newVal;
    };
    watch(confirmDelete, async (newValue, oldValue) => {
      const poolName = selectedPool.value.name;
      if (confirmDelete.value == true) {
        operationRunning.value = true;
        console.log("Now deleting:", selectedPool.value);
        try {
          const output = await destroyPool(selectedPool.value, firstOptionToggle.value);
          console.log("Destroy Pool Output:", output);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            operationRunning.value = false;
            confirmDelete.value = false;
            if (errorMessage.includes("is busy")) {
              pushNotification(new Notification("Destroy Pool Failed", `Pool ${poolName} is busy. Close any active processes using it and try again.`, "warning", 5e3));
            } else {
              pushNotification(new Notification("Destroy Pool Failed", `${poolName} was not destroyed: ${errorMessage}`, "error", 5e3));
            }
          } else {
            if (secondOptionToggle.value == true) {
              selectedPool.value.vdevs.forEach((vDev) => {
                vDev.disks.forEach(async (disk) => {
                  selectedDisk.value = disk;
                  await labelClear(selectedDisk.value);
                });
              });
            }
            await refreshAllData();
            confirmDelete.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Pool Destroyed", `${poolName} destroyed.`, "success", 5e3));
            showDeletePoolConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const confirmResilver = ref(false);
    const showResilverModal = ref(false);
    const resilvered = ref(false);
    const resilvering = ref(false);
    const resilverConfirmComponent = ref();
    const loadResilverConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      resilverConfirmComponent.value = module.default;
    };
    async function resilverThisPool(pool) {
      selectedPool.value = pool;
      await loadResilverConfirmComponent();
      showResilverModal.value = true;
      console.log("preparing to resilver:", selectedPool.value);
    }
    const confirmThisResilver = () => {
      confirmResilver.value = true;
    };
    const updateShowResilverPool = (newVal) => {
      showResilverModal.value = newVal;
    };
    watch(confirmResilver, async (newValue, oldValue) => {
      if (confirmResilver.value == true) {
        resilvered.value = false;
        resilvering.value = true;
        operationRunning.value = resilvering.value;
        console.log("now resilvering:", selectedPool.value);
        try {
          const output = await resilverPool(selectedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Resilver Failed", `Resilver failed to start: ${errorMessage}`, "error", 5e3));
            operationRunning.value = false;
            confirmResilver.value = false;
          } else {
            await getScanStatus();
            confirmResilver.value = false;
            resilvered.value = true;
            resilvering.value = false;
            operationRunning.value = false;
            showResilverModal.value = false;
            pushNotification(new Notification("Resilver Started", "Resilver on " + selectedPool.value.name + " started.", "success", 5e3));
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const upgradeablePool = ref(false);
    const showUpgradeModal = ref(false);
    const confirmUpgrade = ref(false);
    const upgrading = ref(false);
    async function canUpgradePool(poolName) {
      return upgradeablePool.value = await isPoolUpgradable(props.pool.name);
    }
    const upgradeConfirmComponent = ref();
    const loadUpgradeConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      upgradeConfirmComponent.value = module.default;
    };
    async function upgradeThisPool(pool) {
      selectedPool.value = pool;
      await loadUpgradeConfirmComponent();
      showUpgradeModal.value = true;
      console.log("preparing to upgrade:", selectedPool.value);
    }
    const confirmThisUpgrade = () => {
      confirmUpgrade.value = true;
    };
    const updateShowUpgradePool = (newVal) => {
      showUpgradeModal.value = newVal;
    };
    watch(confirmUpgrade, async (newVal, oldVal) => {
      if (confirmUpgrade.value == true) {
        operationRunning.value = true;
        console.log("now upgrading:", selectedPool.value);
        upgrading.value = true;
        try {
          const output = await upgradePool(selectedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Upgrade Failed", `Upgrade failed: ${errorMessage}`, "error", 5e3));
            operationRunning.value = false;
            confirmUpgrade.value = false;
          } else {
            getScanStatus();
            confirmUpgrade.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Upgrade Successful", "Upgrade on " + selectedPool.value.name + " succeeded.", "success", 5e3));
            showUpgradeModal.value = false;
            canUpgradePool(selectedPool.value.name);
          }
          upgrading.value = true;
        } catch (error) {
          console.error(error);
        }
      }
    });
    const showScrubModal = ref(false);
    const confirmScrub = ref(false);
    const starting = ref(false);
    const pausing = ref(false);
    const stopping = ref(false);
    const resuming = ref(false);
    const scrubConfirmComponent = ref();
    const loadScrubConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      scrubConfirmComponent.value = module.default;
    };
    const scrubPauseConfirmComponent = ref();
    const loadScrubPauseConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      scrubPauseConfirmComponent.value = module.default;
    };
    const scrubStopConfirmComponent = ref();
    const loadScrubStopConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      scrubStopConfirmComponent.value = module.default;
    };
    async function scrubThisPool(pool) {
      selectedPool.value = pool;
      await loadScrubConfirmComponent();
      showScrubModal.value = true;
      console.log("preparing to scrub:", selectedPool.value);
    }
    const confirmThisScrub = () => {
      confirmScrub.value = true;
    };
    const updateShowScrubPool = (newVal) => {
      showScrubModal.value = newVal;
    };
    watch(confirmScrub, async (newVal, oldVal) => {
      if (confirmScrub.value == true) {
        operationRunning.value = true;
        console.log("now scrubbing:", selectedPool.value);
        starting.value = true;
        try {
          const output = await scrubPool(selectedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Scrub Failed", `Scrub failed to start: ${errorMessage}`, "error", 5e3));
            operationRunning.value = false;
            confirmScrub.value = false;
          } else {
            getScanStatus();
            confirmScrub.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Scrub Started", "Scrub on " + selectedPool.value.name + " started.", "success", 5e3));
            showScrubModal.value = false;
          }
          starting.value = true;
        } catch (error) {
          console.error(error);
        }
      }
    });
    async function pauseScrub(pool) {
      selectedPool.value = pool;
      await loadScrubPauseConfirmComponent();
      showPauseScrubConfirm.value = true;
      console.log("scrub to pause:", selectedPool.value);
    }
    async function resumeScrub(pool) {
      selectedPool.value = pool;
      resuming.value = true;
      try {
        const output = await scrubPool(selectedPool.value);
        if (output == null || output.error) {
          const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
          pushNotification(new Notification("Scrub Resume Failed", `Scrub failed to resume: ${errorMessage}`, "error", 5e3));
          confirmScrub.value = false;
        } else {
          getScanStatus();
          confirmScrub.value = false;
          pushNotification(new Notification("Scrub Resumed", "Scrub on " + selectedPool.value.name + " resumed.", "success", 5e3));
          showScrubModal.value = false;
        }
      } catch (error) {
        console.error(error);
      }
      resuming.value = false;
    }
    async function stopScrub(pool) {
      selectedPool.value = pool;
      await loadScrubStopConfirmComponent();
      showStopScrubConfirm.value = true;
      console.log("scrub to stop:", selectedPool.value);
    }
    const showPauseScrubConfirm = ref(false);
    const confirmPauseScrub = ref(false);
    const confirmPauseThisScrub = () => {
      confirmPauseScrub.value = true;
    };
    const updateShowPauseScrub = (newVal) => {
      showPauseScrubConfirm.value = newVal;
    };
    watch(confirmPauseScrub, async (newVal, oldVal) => {
      if (confirmPauseScrub.value == true) {
        console.log("now pausing scrub:", selectedPool.value);
        pausing.value = true;
        try {
          const output = await scrubPool(selectedPool.value, "pause");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Scrub Pause Failed", `Scrub failed to pause: ${errorMessage}`, "error", 5e3));
            confirmPauseScrub.value = false;
          } else {
            getScanStatus();
            confirmPauseScrub.value = false;
            pushNotification(new Notification("Scrub Paused", "Scrub on " + selectedPool.value.name + " paused.", "success", 5e3));
            showPauseScrubConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        pausing.value = false;
      }
    });
    const showStopScrubConfirm = ref(false);
    const confirmStopScrub = ref(false);
    const confirmStopThisScrub = () => {
      confirmStopScrub.value = true;
    };
    const updateShowStopScrub = (newVal) => {
      showStopScrubConfirm.value = newVal;
    };
    watch(confirmStopScrub, async (newVal, oldVal) => {
      if (confirmStopScrub.value == true) {
        console.log("now stopping scrub:", selectedPool.value);
        stopping.value = true;
        try {
          const output = await scrubPool(selectedPool.value, "stop");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Scrub Stop Failed", `Scrub failed to stop: ${errorMessage}`, "error", 5e3));
            confirmStopScrub.value = false;
          } else {
            getScanStatus();
            confirmStopScrub.value = false;
            pushNotification(new Notification("Scrub Stopped", "Scrub on " + selectedPool.value.name + " stopped.", "success", 5e3));
            showStopScrubConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        stopping.value = false;
      }
    });
    const showTrimModal = ref(false);
    const confirmTrim = ref(false);
    const secureTRIM = ref(false);
    const startingTrim = ref(false);
    const pausingTrim = ref(false);
    const stoppingTrim = ref(false);
    const resumingTrim = ref(false);
    const trimConfirmComponent = ref();
    const loadTrimConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimConfirmComponent.value = module.default;
    };
    const trimPauseConfirmComponent = ref();
    const loadTrimPauseConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimPauseConfirmComponent.value = module.default;
    };
    const trimStopConfirmComponent = ref();
    const loadTrimStopConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimStopConfirmComponent.value = module.default;
    };
    async function trimThisPool(pool) {
      selectedPool.value = pool;
      await loadTrimConfirmComponent();
      showTrimModal.value = true;
      console.log("preparing to trim:", selectedPool.value);
    }
    const confirmThisTrim = () => {
      confirmTrim.value = true;
    };
    const updateShowTrimPool = (newVal) => {
      showTrimModal.value = newVal;
    };
    watch(confirmTrim, async (newValue, oldValue) => {
      if (confirmTrim.value == true) {
        startingTrim.value = true;
        console.log("now trimming:", selectedPool.value);
        try {
          const output = await trimPool(selectedPool.value, firstOptionToggle.value ? firstOptionToggle.value : false);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Trim Failed", `Trim failed to start: ${errorMessage}`, "error", 5e3));
            confirmTrim.value = false;
          } else {
            getTrimStatus();
            confirmTrim.value = false;
            pushNotification(new Notification("Trim Started", "Trim on " + selectedPool.value.name + " started.", "success", 5e3));
            showTrimModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        startingTrim.value = false;
      }
    });
    async function pauseTrim(pool) {
      selectedPool.value = pool;
      await loadTrimPauseConfirmComponent();
      showPauseTrimConfirm.value = true;
      console.log("trim to pause:", selectedPool.value);
    }
    async function resumeTrim(pool) {
      resumingTrim.value = true;
      try {
        const output = await trimPool(pool);
        if (output == null || output.error) {
          const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
          pushNotification(new Notification("Trim Resume Failed", `Trim failed to resume: ${errorMessage}`, "error", 5e3));
          confirmTrim.value = false;
        } else {
          getTrimStatus();
          confirmTrim.value = false;
          pushNotification(new Notification("Trim Resumed", "Trim on " + selectedPool.value.name + " resumed.", "success", 5e3));
          showTrimModal.value = false;
        }
      } catch (error) {
        console.error(error);
      }
      resumingTrim.value = false;
    }
    async function stopTrim(pool) {
      selectedPool.value = pool;
      await loadTrimStopConfirmComponent();
      showStopTrimConfirm.value = true;
      console.log("trim to stop:", selectedPool.value);
    }
    const showPauseTrimConfirm = ref(false);
    const confirmPauseTrim = ref(false);
    const confirmPauseThisTrim = () => {
      confirmPauseTrim.value = true;
    };
    const updateShowPauseTrim = (newVal) => {
      showPauseTrimConfirm.value = newVal;
    };
    watch(confirmPauseTrim, async (newVal, oldVal) => {
      if (confirmPauseTrim.value == true) {
        console.log("now pausing trim:", selectedPool.value);
        pausingTrim.value = true;
        try {
          const output = await trimPool(selectedPool.value, false, "pause");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Trim Pause Failed", `Trim failed to pause: ${errorMessage}`, "error", 5e3));
            confirmPauseTrim.value = false;
          } else {
            getTrimStatus();
            confirmPauseTrim.value = false;
            pushNotification(new Notification("Trim Paused", "Trim on " + selectedPool.value.name + " paused.", "success", 5e3));
            showPauseTrimConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        pausingTrim.value = false;
      }
    });
    const showStopTrimConfirm = ref(false);
    const confirmStopTrim = ref(false);
    const confirmStopThisTrim = () => {
      confirmStopTrim.value = true;
    };
    const updateShowStopTrim = (newVal) => {
      showStopTrimConfirm.value = newVal;
    };
    watch(confirmStopTrim, async (newVal, oldVal) => {
      if (confirmStopTrim.value == true) {
        console.log("now stopping trim:", selectedPool.value);
        stoppingTrim.value = true;
        try {
          const output = await trimPool(selectedPool.value, false, "stop");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Trim Stop Failed", `Trim failed to stop: ${errorMessage}`, "error", 5e3));
            confirmStopTrim.value = false;
          } else {
            getTrimStatus();
            confirmStopTrim.value = false;
            pushNotification(new Notification("Trim Stopped", "Trim on " + selectedPool.value.name + " stopped.", "success", 5e3));
            showStopTrimConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        stoppingTrim.value = false;
      }
    });
    const showExportModal = ref(false);
    const confirmExport = ref(false);
    const forceUnmount = ref(false);
    const exporting = ref(false);
    const exportConfirmComponent = ref();
    const loadExportConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      exportConfirmComponent.value = module.default;
    };
    async function exportThisPool(pool) {
      selectedPool.value = pool;
      await loadExportConfirmComponent();
      showExportModal.value = true;
      console.log("preparing to export:", selectedPool.value);
    }
    const confirmThisExport = () => {
      confirmExport.value = true;
    };
    const updateShowExportPool = (newVal) => {
      showExportModal.value = newVal;
    };
    watch(confirmExport, async (newVal, oldVal) => {
      if (confirmExport.value == true) {
        exporting.value = true;
        operationRunning.value = true;
        console.log("now exporting:", selectedPool.value);
        try {
          const output = await exportPool(selectedPool.value, firstOptionToggle.value ? firstOptionToggle.value : false);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Export Failed", `Pool failed to export: ${errorMessage}`, "error", 5e3));
            confirmExport.value = false;
          } else {
            pushNotification(new Notification("Export Completed", "Export of pool " + selectedPool.value.name + " completed.", "success", 5e3));
            await refreshAllData();
            confirmExport.value = false;
            showExportModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        exporting.value = false;
        operationRunning.value = false;
      }
    });
    async function clearPoolErrors(poolName) {
      await clearErrors(poolName);
    }
    const showAddVDevModal = ref(false);
    const showAddVDevComponent = ref();
    const loadShowAddVDevComponent = async () => {
      const module = await __vitePreload(() => import("./AddVDevModal.3f2501fb.js"), true ? ["./AddVDevModal.3f2501fb.js","./index.6d4442b8.js","./index.4bb2164e.css","./loadImportables.89a51a80.js","./ExclamationTriangleIcon.be4eb01d.js","./switch.bba63450.js","./AddVDevModal.2b382f5f.css"] : void 0, import.meta.url);
      showAddVDevComponent.value = module.default;
    };
    async function showAddVDev(pool) {
      selectedPool.value = pool;
      console.log("add vdev to:", selectedPool.value);
      await loadShowAddVDevComponent();
      showAddVDevModal.value = true;
    }
    const scanStatus = ref();
    async function getScanStatus() {
      await scanStatus.value.pollScanStatus();
    }
    const trimStatus = ref();
    async function getTrimStatus() {
      await trimStatus.value.pollTrimStatus();
    }
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    const poolID = ref(props.pool.name);
    const scanActivity = computed(() => {
      return scanActivities.value.get(poolID.value);
    });
    const trimActivity = computed(() => {
      return trimActivities.value.get(poolID.value);
    });
    const getIdKey = (name) => `${selectedPool.value}-${name}`;
    provide("show-pool-deets", showPoolDetails);
    provide("confirm-save-pool", confirmSavePool);
    provide("current-pool-config", poolConfig);
    provide("show-vdev-modal", showAddVDevModal);
    provide("show-delete-pool-confirm", showDeletePoolConfirm);
    provide("confirm-delete-pool", confirmDelete);
    provide("show-resilver-modal", showResilverModal);
    provide("confirm-resilver", confirmResilver);
    provide("show-trim-modal", showTrimModal);
    provide("secure-trim", secureTRIM);
    provide("confirm-trim", confirmTrim);
    provide("show-export-modal", showExportModal);
    provide("force-unmount", forceUnmount);
    provide("confirm-export", confirmExport);
    provide("show-vdev-modal", showAddVDevModal);
    provide("show-pool-deets", showPoolDetails);
    provide("modal-confirm-running", operationRunning);
    provide("modal-option-one-toggle", firstOptionToggle);
    provide("modal-option-two-toggle", secondOptionToggle);
    provide("modal-option-three-toggle", thirdOptionToggle);
    provide("modal-option-four-toggle", fourthOptionToggle);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createBaseVNode("button", {
          onDblclick: _cache[15] || (_cache[15] = ($event) => showDetails(props.pool)),
          class: "min-w-96 w-full min-h-96 h-full"
        }, [
          createVNode(_sfc_main$4, {
            bgColor: "bg-default",
            titleSection: true,
            contentSection: true,
            footerSection: true,
            class: "mt-2 mb-4 min-w-96 w-full min-h-96 h-full overflow-visible bg-plugin-header rounded-md border border-default"
          }, {
            title: withCtx(() => [
              createBaseVNode("div", _hoisted_1$2, [
                createBaseVNode("div", _hoisted_2$1, [
                  createBaseVNode("div", {
                    class: normalizeClass(["text-default", unref(truncateText)])
                  }, toDisplayString(props.pool.name), 3),
                  upgradeablePool.value ? (openBlock(), createElementBlock("div", _hoisted_3$1, [
                    createVNode(unref(render), { class: "ml-2 w-5 text-orange-700" }),
                    _cache[17] || (_cache[17] = createBaseVNode("span", { class: "text-orange-700 ml-1" }, "Upgrade Available", -1))
                  ])) : createCommentVNode("", true)
                ]),
                createVNode(unref(ge), {
                  as: "div",
                  class: "relative inline-block text-right"
                }, {
                  default: withCtx(() => [
                    createBaseVNode("div", null, [
                      createVNode(unref(Se), { class: "rounded-full p-1 bg-default text-default hover:text-gray-600" }, {
                        default: withCtx(() => [
                          _cache[18] || (_cache[18] = createBaseVNode("span", { class: "sr-only" }, "Open options", -1)),
                          createVNode(unref(render$1), {
                            class: "w-5",
                            "aria-hidden": "true"
                          })
                        ]),
                        _: 1
                      })
                    ]),
                    createVNode(Transition, {
                      "enter-active-class": "transition ease-out duration-100",
                      "enter-from-class": "transform opacity-0 scale-95",
                      "enter-to-class": "transform opacity-100 scale-100",
                      "leave-active-class": "transition ease-in duration-75",
                      "leave-from-class": "transform opacity-100 scale-100",
                      "leave-to-class": "transform opacity-0 scale-95"
                    }, {
                      default: withCtx(() => [
                        createVNode(unref(Me), { class: "absolute right-0 z-10 -mt-1 w-max origin-top-left rounded-md bg-accent shadow-lg" }, {
                          default: withCtx(() => [
                            createBaseVNode("div", _hoisted_4$1, [
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  createBaseVNode("a", {
                                    href: "#",
                                    onClick: _cache[0] || (_cache[0] = ($event) => showDetails(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Pool Details", 2)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  createBaseVNode("a", {
                                    href: "#",
                                    onClick: _cache[1] || (_cache[1] = ($event) => clearPoolErrors(props.pool.name)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Clear Pool Errors", 2)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  upgradeablePool.value ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[2] || (_cache[2] = ($event) => upgradeThisPool(props.pool)),
                                    class: normalizeClass([active ? "bg-orange-700 text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Upgrade Pool", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  !scanActivity.value.isActive ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[3] || (_cache[3] = ($event) => resilverThisPool(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Resilver Pool", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  !scanActivity.value.isActive ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[4] || (_cache[4] = ($event) => scrubThisPool(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Scrub Pool", 2)) : createCommentVNode("", true),
                                  scanActivity.value.isActive && scanActivity.value.isPaused && scanOperation.value == "SCRUB" ? (openBlock(), createElementBlock("a", {
                                    key: 1,
                                    href: "#",
                                    onClick: _cache[5] || (_cache[5] = ($event) => resumeScrub(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Resume Scrub", 2)) : createCommentVNode("", true),
                                  scanActivity.value.isActive && !scanActivity.value.isPaused && scanOperation.value == "SCRUB" ? (openBlock(), createElementBlock("a", {
                                    key: 2,
                                    href: "#",
                                    onClick: _cache[6] || (_cache[6] = ($event) => pauseScrub(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Pause Scrub", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  scanActivity.value.isActive && scanOperation.value == "SCRUB" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[7] || (_cache[7] = ($event) => stopScrub(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Cancel Scrub", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  !trimActivity.value.isActive && !trimActivity.value.isPaused && _ctx.pool.diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[8] || (_cache[8] = ($event) => trimThisPool(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "TRIM Pool", 2)) : createCommentVNode("", true),
                                  trimActivity.value.isPaused && _ctx.pool.diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                    key: 1,
                                    href: "#",
                                    onClick: _cache[9] || (_cache[9] = ($event) => resumeTrim(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Resume TRIM (Pool)", 2)) : createCommentVNode("", true),
                                  trimActivity.value.isActive && _ctx.pool.diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                    key: 2,
                                    href: "#",
                                    onClick: _cache[10] || (_cache[10] = ($event) => pauseTrim(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Pause TRIM (Pool)", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  trimActivity.value.isActive || trimActivity.value.isPaused && _ctx.pool.diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[11] || (_cache[11] = ($event) => stopTrim(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Cancel TRIM (Pool)", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  createBaseVNode("a", {
                                    href: "#",
                                    onClick: _cache[12] || (_cache[12] = ($event) => showAddVDev(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Add Virtual Device", 2)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  createBaseVNode("a", {
                                    href: "#",
                                    onClick: _cache[13] || (_cache[13] = ($event) => exportThisPool(props.pool)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Export Pool", 2)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  createBaseVNode("a", {
                                    href: "#",
                                    onClick: _cache[14] || (_cache[14] = ($event) => destroyPoolAndUpdate(props.pool)),
                                    class: normalizeClass([active ? "bg-danger text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Destroy Pool", 2)
                                ]),
                                _: 1
                              })
                            ])
                          ]),
                          _: 1
                        })
                      ]),
                      _: 1
                    })
                  ]),
                  _: 1
                })
              ]),
              createBaseVNode("div", _hoisted_5$1, [
                createBaseVNode("div", null, [
                  createBaseVNode("span", {
                    class: normalizeClass(["font-semibold", unref(formatStatus)(props.pool.status)])
                  }, toDisplayString(props.pool.status), 3)
                ]),
                props.pool.status == "ONLINE" ? (openBlock(), createElementBlock("div", _hoisted_6$1, [
                  createVNode(unref(render$2), { class: "aspect-square w-5 text-green-400" })
                ])) : createCommentVNode("", true)
              ]),
              props.pool.properties.refreservationPercent ? (openBlock(), createElementBlock("div", _hoisted_7$1, [
                createBaseVNode("div", _hoisted_8$1, [
                  createBaseVNode("div", {
                    class: normalizeClass([capacityColor.value, "h-6"]),
                    style: normalizeStyle({ width: `${Number(props.pool.properties.capacity)}%` })
                  }, [
                    createBaseVNode("div", _hoisted_9$1, toDisplayString(Number(props.pool.properties.capacity)) + "% Full ", 1)
                  ], 6)
                ])
              ])) : (openBlock(), createElementBlock("div", _hoisted_10$1, [
                createBaseVNode("div", _hoisted_11$1, [
                  createBaseVNode("div", {
                    class: normalizeClass([capacityColor.value, "h-6"]),
                    style: normalizeStyle({ width: `${Number(props.pool.properties.capacity)}%` })
                  }, [
                    createBaseVNode("div", _hoisted_12$1, toDisplayString(Number(props.pool.properties.capacity)) + "% Full ", 1)
                  ], 6)
                ])
              ]))
            ]),
            content: withCtx(() => [
              createBaseVNode("div", _hoisted_13$1, [
                createBaseVNode("p", _hoisted_14, "Used " + toDisplayString(props.pool.properties.allocated), 1),
                createBaseVNode("p", _hoisted_15, "RAW Space Available " + toDisplayString(props.pool.properties.free), 1),
                createBaseVNode("p", _hoisted_16, "Actual Available Space " + toDisplayString(props.pool.properties.available), 1),
                createBaseVNode("p", _hoisted_17, toDisplayString(props.pool.properties.refreservationPercent) + "% Reserved ", 1),
                createBaseVNode("p", _hoisted_18, [
                  createBaseVNode("b", null, "Total " + toDisplayString(props.pool.properties.size), 1)
                ])
              ])
            ]),
            footer: withCtx(() => [
              createBaseVNode("div", _hoisted_19, [
                createBaseVNode("b", _hoisted_20, toDisplayString(`${props.pool.vdevs.length} Virtual Device${props.pool.vdevs.length > 1 ? "s" : ""}:`), 1),
                createBaseVNode("div", {
                  class: normalizeClass(["grid gap-2 p-2 w-full justify-center items-center", {
                    "grid-cols-1": props.pool.vdevs.length === 1,
                    "grid-cols-2": props.pool.vdevs.length === 2,
                    "grid-cols-3": props.pool.vdevs.length === 3,
                    "grid-cols-4": props.pool.vdevs.length >= 4
                  }])
                }, [
                  (openBlock(true), createElementBlock(Fragment, null, renderList(props.pool.vdevs, (vdev) => {
                    return openBlock(), createElementBlock("div", {
                      key: vdev.name,
                      class: "p-2 border border-default rounded-md bg-accent text-center"
                    }, [
                      createBaseVNode("p", _hoisted_21, toDisplayString(vdev.name), 1),
                      createBaseVNode("p", _hoisted_22, "(" + toDisplayString(vdev.type) + ")", 1)
                    ]);
                  }), 128))
                ], 2)
              ]),
              createBaseVNode("div", _hoisted_23, " Errors: " + toDisplayString(props.pool.errorCount), 1),
              createBaseVNode("div", _hoisted_24, [
                createVNode(_sfc_main$3, {
                  pool: props.pool,
                  isTrim: false,
                  isDisk: false,
                  isPoolList: false,
                  isPoolDetail: false,
                  class: "col-span-4",
                  idKey: "scrub-status-box",
                  ref_key: "scanStatus",
                  ref: scanStatus
                }, null, 8, ["pool"])
              ]),
              createBaseVNode("div", _hoisted_25, [
                createVNode(_sfc_main$3, {
                  pool: props.pool,
                  isTrim: true,
                  isDisk: false,
                  isPoolList: false,
                  isPoolDetail: false,
                  class: "col-span-4",
                  idKey: "stats-status-box",
                  ref_key: "trimStatus",
                  ref: trimStatus
                }, null, 8, ["pool"])
              ])
            ]),
            _: 1
          })
        ], 32),
        showPoolDetails.value ? (openBlock(), createElementBlock("div", _hoisted_26, [
          (openBlock(), createBlock(resolveDynamicComponent(poolDetailsComponent.value), {
            showFlag: showPoolDetails.value,
            onClose: updateShowPoolDetails,
            confirm: confirmSavePoolDetails,
            idKey: getIdKey(`show-pool-modal`),
            pool: selectedPool.value
          }, null, 40, ["showFlag", "idKey", "pool"]))
        ])) : createCommentVNode("", true),
        showAddVDevModal.value ? (openBlock(), createElementBlock("div", _hoisted_27, [
          (openBlock(), createBlock(resolveDynamicComponent(showAddVDevComponent.value), {
            onClose: _cache[16] || (_cache[16] = ($event) => showAddVDevModal.value = false),
            idKey: getIdKey(`show-vdev-modal`),
            pool: selectedPool.value,
            marginTop: "mt-28"
          }, null, 40, ["idKey", "pool"]))
        ])) : createCommentVNode("", true),
        showDeletePoolConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_28, [
          (openBlock(), createBlock(resolveDynamicComponent(deleteConfirmComponent.value), {
            showFlag: showDeletePoolConfirm.value,
            onClose: updateShowDestroyPool,
            idKey: "confirm-destroy-pool",
            item: "pool",
            operation: "destroy",
            pool: selectedPool.value,
            confirmOperation: confirmThisDestroy,
            firstOption: "force unmount",
            secondOption: "clear disk labels",
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showResilverModal.value ? (openBlock(), createElementBlock("div", _hoisted_29, [
          (openBlock(), createBlock(resolveDynamicComponent(resilverConfirmComponent.value), {
            showFlag: showResilverModal.value,
            onClose: updateShowResilverPool,
            idKey: "confirm-resilver-pool",
            item: "pool",
            operation: "resilver",
            pool: selectedPool.value,
            confirmOperation: confirmThisResilver,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showTrimModal.value ? (openBlock(), createElementBlock("div", _hoisted_30, [
          (openBlock(), createBlock(resolveDynamicComponent(trimConfirmComponent.value), {
            showFlag: showTrimModal.value,
            onClose: updateShowTrimPool,
            idKey: "confirm-trim-pool",
            item: "pool",
            operation: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmThisTrim,
            firstOption: "secure TRIM",
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showPauseTrimConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_31, [
          (openBlock(), createBlock(resolveDynamicComponent(trimPauseConfirmComponent.value), {
            showFlag: showPauseTrimConfirm.value,
            onClose: updateShowPauseTrim,
            idKey: "confirm-pause-trim",
            item: "pool",
            operation: "pause",
            operation2: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmPauseThisTrim,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showStopTrimConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_32, [
          (openBlock(), createBlock(resolveDynamicComponent(trimStopConfirmComponent.value), {
            showFlag: showStopTrimConfirm.value,
            onClose: updateShowStopTrim,
            idKey: "confirm-stop-trim",
            item: "pool",
            operation: "stop",
            operation2: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmStopThisTrim,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showScrubModal.value ? (openBlock(), createElementBlock("div", _hoisted_33, [
          (openBlock(), createBlock(resolveDynamicComponent(scrubConfirmComponent.value), {
            showFlag: showScrubModal.value,
            onClose: updateShowScrubPool,
            idKey: "confirm-scrub-pool",
            item: "pool",
            operation: "scrub",
            pool: selectedPool.value,
            confirmOperation: confirmThisScrub,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showPauseScrubConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_34, [
          (openBlock(), createBlock(resolveDynamicComponent(scrubPauseConfirmComponent.value), {
            showFlag: showPauseScrubConfirm.value,
            onClose: updateShowPauseScrub,
            idKey: "confirm-pause-scrub",
            item: "pool",
            operation: "pause",
            operation2: "scrub",
            pool: selectedPool.value,
            confirmOperation: confirmPauseThisScrub,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showStopScrubConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_35, [
          (openBlock(), createBlock(resolveDynamicComponent(scrubStopConfirmComponent.value), {
            showFlag: showStopScrubConfirm.value,
            onClose: updateShowStopScrub,
            idKey: "confirm-stop-scrub",
            item: "pool",
            operation: "stop",
            operation2: "scrub",
            pool: selectedPool.value,
            confirmOperation: confirmStopThisScrub,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showExportModal.value ? (openBlock(), createElementBlock("div", _hoisted_36, [
          (openBlock(), createBlock(resolveDynamicComponent(exportConfirmComponent.value), {
            showFlag: showExportModal.value,
            onClose: updateShowExportPool,
            idKey: "confirm-export-pool",
            item: "pool",
            operation: "export",
            pool: selectedPool.value,
            confirmOperation: confirmThisExport,
            firstOption: "force unmount",
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showUpgradeModal.value ? (openBlock(), createElementBlock("div", _hoisted_37, [
          (openBlock(), createBlock(resolveDynamicComponent(upgradeConfirmComponent.value), {
            showFlag: showUpgradeModal.value,
            onClose: updateShowUpgradePool,
            idKey: "confirm-upgrade-pool",
            item: "pool",
            operation: "upgrade",
            pool: selectedPool.value,
            confirmOperation: confirmThisUpgrade,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
const _hoisted_1$1 = {
  role: "status",
  class: "max-w-full min-w-full animate-pulse grid grid-cols-3 auto-rows-max gap-2"
};
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "DashboardLoadingSkeleton",
  props: {
    color: {}
  },
  setup(__props) {
    const props = __props;
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$1, [
        createVNode(_sfc_main$4, {
          bgColor: "bg-default",
          titleSection: true,
          contentSection: true,
          footerSection: true,
          class: normalizeClass(["mt-2", "mb-4", "min-w-96", "min-h-96", "w-full", "h-full", "rounded-md", "border", "border-default", props.color])
        }, null, 8, ["class"]),
        createVNode(_sfc_main$4, {
          bgColor: "bg-default",
          titleSection: true,
          contentSection: true,
          footerSection: true,
          class: normalizeClass(["mt-2", "mb-4", "min-w-96", "min-h-96", "w-full", "h-full", "rounded-md", "border", "border-default", props.color])
        }, null, 8, ["class"]),
        createVNode(_sfc_main$4, {
          bgColor: "bg-default",
          titleSection: true,
          contentSection: true,
          footerSection: true,
          class: normalizeClass(["mt-2", "mb-4", "min-w-96", "min-h-96", "w-full", "h-full", "rounded-md", "border", "border-default", props.color])
        }, null, 8, ["class"]),
        _cache[0] || (_cache[0] = createBaseVNode("span", { class: "sr-only" }, "Loading...", -1))
      ]);
    };
  }
});
const _hoisted_1 = { class: "min-w-full max-w-full max-h-full py-2 pb-4 align-middle sm:px-4 lg:px-6 sm:rounded-lg bg-accent rounded-md border border-default" };
const _hoisted_2 = { name: "pools" };
const _hoisted_3 = {
  key: 0,
  class: "grid grid-flow-col bg-well text-center items-center rounded-md shadow text-default my-2 rounded-b-md ring-1 ring-black ring-opacity-5"
};
const _hoisted_4 = { class: "p-2 flex justify-start mt-1" };
const _hoisted_5 = { class: "mt-2" };
const _hoisted_6 = { class: "p-2 flex justify-start mt-1" };
const _hoisted_7 = { class: "mt-2" };
const _hoisted_8 = { class: "p-2 flex justify-end" };
const _hoisted_9 = {
  key: 1,
  class: "grid grid-flow-col grid-cols-3 bg-well gap-2 justify-items-center rounded-md shadow text-default my-2 rounded-b-md ring-1 ring-black ring-opacity-5"
};
const _hoisted_10 = {
  key: 2,
  class: "grid grid-flow-col grid-cols-3 bg-well rounded-md shadow text-default my-2 rounded-b-md ring-1 ring-black ring-opacity-5"
};
const _hoisted_11 = { class: "p-2 flex justify-end col-start-3" };
const _hoisted_12 = {
  key: 3,
  class: "grid grid-cols-3 auto-rows-max gap-2 mb-2"
};
const _hoisted_13 = {
  key: 4,
  class: "grid grid-cols-3 justify-items-center"
};
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "Dashboard",
  setup(__props) {
    const pools = inject("pools");
    const disks = inject("disks");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      disks.value = [];
      pools.value = [];
      await loadDisksThenPools(disks, pools);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(pools, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(pools, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
    }
    const totalEffectivePoolSpace = computed(() => {
      let totalCapacity = 0;
      pools.value.forEach((pool) => {
        totalCapacity += pool.properties.rawsize;
      });
      return convertBytesToSize(totalCapacity);
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        createBaseVNode("div", _hoisted_2, [
          unref(pools).length > 0 && unref(poolsLoaded) == true ? (openBlock(), createElementBlock("div", _hoisted_3, [
            _cache[0] || (_cache[0] = createBaseVNode("div", { class: "p-2 flex justify-start mt-1" }, [
              createBaseVNode("span", { class: "px-3 font-semibold text-lg mt-1 justify-self-start" }, "Pools")
            ], -1)),
            createBaseVNode("div", _hoisted_4, [
              createBaseVNode("h6", _hoisted_5, toDisplayString(unref(pools).length) + " Pool(s) ", 1)
            ]),
            createBaseVNode("div", _hoisted_6, [
              createBaseVNode("h6", _hoisted_7, " Total Effective Space: " + toDisplayString(totalEffectivePoolSpace.value), 1)
            ]),
            createBaseVNode("div", _hoisted_8, [
              createBaseVNode("button", {
                class: "btn btn-secondary",
                onClick: refreshAllData
              }, [
                createVNode(unref(render$3), {
                  class: "h-5 w-5 m-1",
                  "aria-hidden": "true"
                })
              ])
            ])
          ])) : createCommentVNode("", true),
          unref(poolsLoaded) == false ? (openBlock(), createElementBlock("div", _hoisted_9, [
            createVNode(_sfc_main$5, {
              width: "w-11",
              height: "h-11",
              baseColor: "text-gray-200",
              fillColor: "fill-slate-500",
              class: "col-span-4 my-2"
            })
          ])) : createCommentVNode("", true),
          unref(pools).length < 1 && unref(poolsLoaded) == true ? (openBlock(), createElementBlock("div", _hoisted_10, [
            _cache[1] || (_cache[1] = createBaseVNode("div", { class: "p-2 flex justify-center col-start-2" }, [
              createBaseVNode("span", { class: "font-semibold text-lg mt-1" }, "No Pools Found")
            ], -1)),
            createBaseVNode("div", _hoisted_11, [
              createBaseVNode("button", {
                class: "btn btn-primary",
                onClick: refreshAllData
              }, [
                createVNode(unref(render$3), {
                  class: "h-5 w-5",
                  "aria-hidden": "true"
                })
              ])
            ])
          ])) : createCommentVNode("", true),
          unref(pools).length > 0 && unref(poolsLoaded) == true ? (openBlock(), createElementBlock("div", _hoisted_12, [
            (openBlock(true), createElementBlock(Fragment, null, renderList(unref(pools), (pool, index) => {
              return openBlock(), createElementBlock("div", {
                key: index,
                class: "col-span-1 w-full min-w-full h-full min-h-full"
              }, [
                createVNode(_sfc_main$2, {
                  pool: unref(pools)[index]
                }, null, 8, ["pool"])
              ]);
            }), 128))
          ])) : createCommentVNode("", true),
          unref(poolsLoaded) == false ? (openBlock(), createElementBlock("div", _hoisted_13, [
            createVNode(_sfc_main$1, {
              color: "bg-plugin-header",
              class: "col-span-4"
            })
          ])) : createCommentVNode("", true)
        ])
      ]);
    };
  }
});
export {
  _sfc_main as default
};
