import { d as defineComponent, i as inject, r as ref, b6 as getSizeNumberFromString, V as convertBytesToSize, b7 as getSizeUnitFromString, b8 as getQuotaRefreservUnit, b9 as onOffToBool, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, C as normalizeClass, D as unref, E as toDisplayString, $ as upperCaseWord, A as createVNode, ax as withDirectives, aG as vModelText, aF as vModelSelect, y as createElementBlock, G as createCommentVNode, Z as createTextVNode, aH as _sfc_main$1, ba as configureDataset, p as pushNotification, N as Notification, a as loadDatasets, aW as convertSizeToBytes, aC as isBoolOnOff } from "./index.6d4442b8.js";
import { u as ue } from "./switch.bba63450.js";
const _hoisted_1 = { class: "grid grid-cols-4 gap-2" };
const _hoisted_2 = { class: "mt-2" };
const _hoisted_3 = ["for"];
const _hoisted_4 = ["title"];
const _hoisted_5 = { class: "mt-2" };
const _hoisted_6 = ["for"];
const _hoisted_7 = { class: "mt-2" };
const _hoisted_8 = ["for"];
const _hoisted_9 = { class: "mt-2" };
const _hoisted_10 = ["id"];
const _hoisted_11 = { class: "mt-2" };
const _hoisted_12 = ["for"];
const _hoisted_13 = ["id"];
const _hoisted_14 = { class: "mt-2" };
const _hoisted_15 = ["for"];
const _hoisted_16 = ["id"];
const _hoisted_17 = { class: "mt-2" };
const _hoisted_18 = ["for"];
const _hoisted_19 = { class: "flex flex-row" };
const _hoisted_20 = ["id"];
const _hoisted_21 = ["id"];
const _hoisted_22 = ["id"];
const _hoisted_23 = { class: "flex flex-row justify-between" };
const _hoisted_24 = {
  key: 0,
  class: "mt-2 justify-self-start"
};
const _hoisted_25 = { class: "text-muted" };
const _hoisted_26 = {
  key: 1,
  class: "mt-2 justify-self-end"
};
const _hoisted_27 = { class: "mt-2" };
const _hoisted_28 = ["for"];
const _hoisted_29 = ["id"];
const _hoisted_30 = { class: "mt-2" };
const _hoisted_31 = ["for"];
const _hoisted_32 = { class: "flex flex-row" };
const _hoisted_33 = ["id"];
const _hoisted_34 = ["id"];
const _hoisted_35 = ["id"];
const _hoisted_36 = { class: "flex flex-row justify-between" };
const _hoisted_37 = {
  key: 0,
  class: "mt-2 justify-self-start"
};
const _hoisted_38 = { class: "text-muted" };
const _hoisted_39 = {
  key: 1,
  class: "mt-2 justify-self-end"
};
const _hoisted_40 = { class: "mt-2" };
const _hoisted_41 = ["for"];
const _hoisted_42 = ["id"];
const _hoisted_43 = { class: "mt-2" };
const _hoisted_44 = ["for"];
const _hoisted_45 = ["id"];
const _hoisted_46 = { class: "mt-2" };
const _hoisted_47 = ["for"];
const _hoisted_48 = ["id"];
const _hoisted_49 = { class: "mt-2" };
const _hoisted_50 = ["for"];
const _hoisted_51 = ["id"];
const _hoisted_52 = { class: "mt-2" };
const _hoisted_53 = ["for"];
const _hoisted_54 = ["id"];
const _hoisted_55 = { class: "mt-2" };
const _hoisted_56 = ["for"];
const _hoisted_57 = ["id"];
const _hoisted_58 = { class: "mt-2" };
const _hoisted_59 = ["for"];
const _hoisted_60 = ["id"];
const _hoisted_61 = { class: "mt-2" };
const _hoisted_62 = ["for"];
const _hoisted_63 = ["id"];
const _hoisted_64 = {
  key: 0,
  class: "mt-2"
};
const _hoisted_65 = ["for"];
const _hoisted_66 = { class: "mt-1 block w-full bg-default" };
const _hoisted_67 = { class: "w-full grid grid-rows-2" };
const _hoisted_68 = { class: "w-full row-start-1" };
const _hoisted_69 = { class: "mt-2" };
const _hoisted_70 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_71 = {
  key: 1,
  class: "text-danger"
};
const _hoisted_72 = { class: "button-group-row w-full row-start-2 justify-between mt-2" };
const _hoisted_73 = ["id"];
const _hoisted_74 = ["id"];
const _hoisted_75 = ["id"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "FileSystemConfigModal",
  props: {
    idKey: {},
    filesystem: {}
  },
  setup(__props) {
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const showFSConfig = inject("show-fs-config");
    const datasets = inject("datasets");
    const pools = inject("pools");
    const quotaFeedback = ref("");
    const refreservationFeedback = ref("");
    const saving = ref(false);
    const fileSystemConfig = ref({
      parentFS: props.filesystem.parentFS,
      name: props.filesystem.name,
      id: props.filesystem.id,
      mountpoint: props.filesystem.mountpoint,
      pool: props.filesystem.pool,
      encrypted: props.filesystem.encrypted,
      key_loaded: props.filesystem.key_loaded,
      type: props.filesystem.type,
      inherit: props.filesystem.inherit,
      properties: {
        guid: props.filesystem.properties.guid,
        encryption: props.filesystem.properties.encryption,
        accessTime: props.filesystem.properties.accessTime,
        caseSensitivity: props.filesystem.properties.caseSensitivity,
        compression: props.filesystem.properties.compression,
        deduplication: props.filesystem.properties.deduplication,
        dNodeSize: props.filesystem.properties.dNodeSize,
        extendedAttributes: props.filesystem.properties.extendedAttributes,
        recordSize: props.filesystem.properties.recordSize,
        quota: {
          raw: getSizeNumberFromString(convertBytesToSize(props.filesystem.properties.quota.raw)),
          value: props.filesystem.properties.quota.value,
          unit: getSizeUnitFromString(getQuotaRefreservUnit(props.filesystem.properties.quota.raw))
        },
        usedByDataset: props.filesystem.properties.usedByDataset,
        usedbyRefreservation: props.filesystem.properties.usedbyRefreservation,
        readOnly: props.filesystem.properties.readOnly,
        isReadOnly: onOffToBool(props.filesystem.properties.readOnly),
        available: props.filesystem.properties.available,
        creation: props.filesystem.properties.creation,
        snapshotCount: props.filesystem.properties.snapshotCount,
        mounted: props.filesystem.properties.mounted,
        refreservation: {
          raw: getSizeNumberFromString(convertBytesToSize(props.filesystem.properties.refreservation.raw)),
          value: props.filesystem.properties.refreservation.value,
          unit: getSizeUnitFromString(getQuotaRefreservUnit(props.filesystem.properties.refreservation.raw))
        },
        canMount: props.filesystem.properties.canMount,
        aclInheritance: props.filesystem.properties.aclInheritance,
        aclType: props.filesystem.properties.aclType,
        checksum: props.filesystem.properties.checksum,
        used: props.filesystem.properties.used
      },
      children: props.filesystem.children
    });
    const newChangesToFileSystem = ref({
      name: fileSystemConfig.value.name,
      guid: fileSystemConfig.value.properties.guid,
      casesensitivity: fileSystemConfig.value.properties.caseSensitivity
    });
    const updatedProperties = {
      name: fileSystemConfig.value.name,
      guid: fileSystemConfig.value.properties.guid,
      casesensitivity: fileSystemConfig.value.properties.caseSensitivity
    };
    async function checkForChanges(fileSystemCheck) {
      if (fileSystemCheck.properties.isReadOnly != props.filesystem.properties.isReadOnly) {
        updatedProperties.readonly = isBoolOnOff(fileSystemCheck.properties.isReadOnly);
      }
      if (fileSystemCheck.mountpoint != props.filesystem.mountpoint) {
        updatedProperties.mountpoint = fileSystemCheck.mountpoint;
      }
      if (fileSystemCheck.properties.canMount != props.filesystem.properties.canMount) {
        updatedProperties.canmount = fileSystemCheck.properties.canMount;
      }
      if (fileSystemCheck.properties.recordSize != props.filesystem.properties.recordSize) {
        updatedProperties.record = fileSystemCheck.properties.recordSize;
      }
      if (fileSystemCheck.properties.aclInheritance != props.filesystem.properties.aclInheritance) {
        updatedProperties.aclinherit = fileSystemCheck.properties.aclInheritance;
      }
      if (fileSystemCheck.properties.aclType != props.filesystem.properties.aclType) {
        updatedProperties.acltype = fileSystemCheck.properties.aclType;
      }
      if (fileSystemCheck.properties.accessTime != props.filesystem.properties.accessTime) {
        updatedProperties.atime = fileSystemCheck.properties.accessTime;
      }
      if (fileSystemCheck.properties.deduplication != props.filesystem.properties.deduplication) {
        updatedProperties.dedup = fileSystemCheck.properties.deduplication;
      }
      if (fileSystemCheck.properties.compression != props.filesystem.properties.compression) {
        updatedProperties.compression = fileSystemCheck.properties.compression;
      }
      if (fileSystemCheck.properties.checksum != props.filesystem.properties.checksum) {
        updatedProperties.checksum = fileSystemCheck.properties.checksum;
      }
      if (fileSystemCheck.properties.dNodeSize != props.filesystem.properties.dNodeSize) {
        updatedProperties.dnodesize = fileSystemCheck.properties.dNodeSize;
      }
      if (fileSystemCheck.properties.extendedAttributes != props.filesystem.properties.extendedAttributes) {
        updatedProperties.xattr = fileSystemCheck.properties.extendedAttributes;
      }
      if (Number(fileSystemCheck.properties.quota.raw)) {
        if (convertSizeToBytes(fileSystemCheck.properties.quota.raw + fileSystemCheck.properties.quota.unit) != props.filesystem.properties.quota.raw) {
          updatedProperties.quota = convertSizeToBytes(fileSystemCheck.properties.quota.raw + fileSystemCheck.properties.quota.unit);
        }
      }
      if (Number(fileSystemCheck.properties.refreservation.raw)) {
        if (convertSizeToBytes(fileSystemCheck.properties.refreservation.raw + fileSystemCheck.properties.refreservation.unit) != props.filesystem.properties.refreservation.raw) {
          updatedProperties.refreservation = convertSizeToBytes(fileSystemCheck.properties.refreservation.raw + fileSystemCheck.properties.refreservation.unit);
        }
      }
      const newChanges = {
        ...newChangesToFileSystem.value,
        ...updatedProperties
      };
      newChangesToFileSystem.value = newChanges;
    }
    const fileSystemsLoaded = inject("datasets-loaded");
    async function fsConfigureBtn() {
      if (checkSizes()) {
        console.log("filesystem:", fileSystemConfig.value);
        await checkForChanges(fileSystemConfig.value);
        console.log("newChanges:", newChangesToFileSystem.value);
        try {
          saving.value = true;
          const output = await configureDataset(newChangesToFileSystem.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            console.log("configureFS failed");
            pushNotification(new Notification("Save File System Config Failed", `There was an error saving this file system: ${errorMessage}`, "error", 5e3));
          } else {
            console.log("configureFS succeeded");
            pushNotification(new Notification("File System Config Saved", "Successfully saved this file system's configuration.", "success", 5e3));
            datasets.value = [];
            fileSystemsLoaded.value = false;
            await loadDatasets(datasets);
            fileSystemsLoaded.value = true;
            showFSConfig.value = false;
          }
          saving.value = false;
        } catch (error) {
          console.error(error);
        }
      }
    }
    const checkSizes = () => {
      let result = true;
      quotaFeedback.value = "";
      refreservationFeedback.value = "";
      const parentPool = pools.value.find((pool) => pool.name == fileSystemConfig.value.pool);
      if (!parentPool) {
        console.log("Pool not found", fileSystemConfig.value.pool);
        return;
      }
      if (fileSystemConfig.value.properties.quota.value != "none") {
        if (convertSizeToBytes(fileSystemConfig.value.properties.quota.raw + fileSystemConfig.value.properties.quota.unit) > convertSizeToBytes(parentPool.properties.free)) {
          result = false;
          quotaFeedback.value = "Quota cannot be greater than available space in pool.";
        }
      }
      if (fileSystemConfig.value.properties.refreservation.value != "none") {
        if (convertSizeToBytes(fileSystemConfig.value.properties.refreservation.raw + fileSystemConfig.value.properties.refreservation.unit) > convertSizeToBytes(parentPool.properties.free)) {
          result = false;
          refreservationFeedback.value = "Refreservation cannot be greater than available space in pool.";
        }
      }
      return result;
    };
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: unref(showFSConfig),
        onClose: _cache[20] || (_cache[20] = ($event) => showFSConfig.value = false),
        marginTop: "mt-28",
        width: "w-3/5",
        minWidth: "min-w-3/5",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[21] || (_cache[21] = [
          createBaseVNode("legend", { class: "flex justify-center" }, "Configure File System", -1)
        ])),
        content: withCtx(() => [
          createBaseVNode("div", null, [
            createBaseVNode("div", _hoisted_1, [
              createBaseVNode("div", _hoisted_2, [
                createBaseVNode("label", {
                  for: getIdKey("fs-config-name"),
                  name: "fs-config-name",
                  class: "mt-1 block text-sm leading-6 text-default"
                }, "File System Name", 8, _hoisted_3),
                createBaseVNode("p", {
                  class: normalizeClass(unref(truncateText)),
                  title: props.filesystem.name
                }, toDisplayString(props.filesystem.name), 11, _hoisted_4)
              ]),
              createBaseVNode("div", _hoisted_5, [
                createBaseVNode("label", {
                  for: getIdKey("fs-config-guid"),
                  name: "fs-config-guid",
                  class: "mt-1 block text-sm leading-6 text-default"
                }, "GUID", 8, _hoisted_6),
                createBaseVNode("p", null, toDisplayString(props.filesystem.properties.guid), 1)
              ]),
              createBaseVNode("div", _hoisted_7, [
                createBaseVNode("label", {
                  for: getIdKey("fs-config-case-sensitivity"),
                  name: "fs-config-case-sensitivity",
                  class: "mt-1 block text-sm leading-6 text-default"
                }, "Case Sensitivity", 8, _hoisted_8),
                createBaseVNode("p", null, toDisplayString(unref(upperCaseWord)(props.filesystem.properties.caseSensitivity)), 1)
              ]),
              createBaseVNode("div", _hoisted_9, [
                createBaseVNode("label", {
                  for: "fs-config-readonly",
                  id: getIdKey("fs-config-readonly"),
                  name: "fs-config-readonly",
                  class: "mt-1 block text-sm leading-6 text-default"
                }, "Read Only", 8, _hoisted_10),
                createVNode(unref(ue), {
                  modelValue: fileSystemConfig.value.properties.isReadOnly,
                  "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => fileSystemConfig.value.properties.isReadOnly = $event),
                  id: getIdKey("fs-config-readonly"),
                  class: normalizeClass([fileSystemConfig.value.properties.isReadOnly ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[24] || (_cache[24] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([fileSystemConfig.value.properties.isReadOnly ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([fileSystemConfig.value.properties.isReadOnly ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[22] || (_cache[22] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([fileSystemConfig.value.properties.isReadOnly ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[23] || (_cache[23] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ])
            ]),
            createBaseVNode("div", _hoisted_11, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-mountpoint"),
                name: "fs-config-mountpoint",
                class: "mt-1 block text-sm leading-6 text-default"
              }, "Mountpoint", 8, _hoisted_12),
              withDirectives(createBaseVNode("input", {
                type: "text",
                "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => fileSystemConfig.value.mountpoint = $event),
                name: "fs-config-mountpoint",
                id: getIdKey("fs-config-mountpoint"),
                class: "mt-1 block w-full input-textlike bg-default",
                placeholder: "Mountpoint"
              }, null, 8, _hoisted_13), [
                [vModelText, fileSystemConfig.value.mountpoint]
              ])
            ]),
            createBaseVNode("div", _hoisted_14, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-can-mount"),
                class: "bg-default block text-base leading-6 text-default"
              }, "Can Mount", 8, _hoisted_15),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-can-mount"),
                "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => fileSystemConfig.value.properties.canMount = $event),
                name: "fs-config-can-mount",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[25] || (_cache[25] = [
                createBaseVNode("option", { value: "on" }, "On", -1),
                createBaseVNode("option", { value: "off" }, "Off", -1),
                createBaseVNode("option", { value: "noauto" }, "No Auto", -1)
              ]), 8, _hoisted_16), [
                [vModelSelect, fileSystemConfig.value.properties.canMount]
              ])
            ]),
            createBaseVNode("div", _hoisted_17, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-quota"),
                class: "mb-1 block text-sm font-medium leading-6 text-default"
              }, "Quota", 8, _hoisted_18),
              createBaseVNode("div", _hoisted_19, [
                withDirectives(createBaseVNode("input", {
                  "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => fileSystemConfig.value.properties.quota.raw = $event),
                  id: getIdKey("fs-config-quota-amount"),
                  name: "fs-config-quota-slider",
                  type: "range",
                  min: "0",
                  max: "1000",
                  step: "1",
                  class: "text-default mt-5 w-3/4 h-2 bg-accent rounded-lg appearance-none cursor-pointer"
                }, null, 8, _hoisted_20), [
                  [vModelText, fileSystemConfig.value.properties.quota.raw]
                ]),
                withDirectives(createBaseVNode("input", {
                  "onUpdate:modelValue": _cache[4] || (_cache[4] = ($event) => fileSystemConfig.value.properties.quota.raw = $event),
                  type: "number",
                  name: "fs-config-quota-num",
                  id: getIdKey("fs-config-quota-num"),
                  min: "0",
                  max: "1000",
                  class: "text-default bg-default mt-1 w-fit block py-1.5 px-1.5 ml-1 text-default placeholder:text-muted input-textlike sm:text-sm sm:leading-6"
                }, null, 8, _hoisted_21), [
                  [vModelText, fileSystemConfig.value.properties.quota.raw]
                ]),
                withDirectives(createBaseVNode("select", {
                  "onUpdate:modelValue": _cache[5] || (_cache[5] = ($event) => fileSystemConfig.value.properties.quota.unit = $event),
                  id: getIdKey("fs-config-quota-size"),
                  name: "fs-config-quota-size",
                  class: "block sm:col-span-1 bg-default py-1.5 pl-3 pr-10 text-default input-textlike sm:text-sm sm:leading-6"
                }, _cache[26] || (_cache[26] = [
                  createBaseVNode("option", { value: "kib" }, "KiB", -1),
                  createBaseVNode("option", { value: "mib" }, "MiB", -1),
                  createBaseVNode("option", { value: "gib" }, "GiB", -1),
                  createBaseVNode("option", { value: "tib" }, "TiB", -1)
                ]), 8, _hoisted_22), [
                  [vModelSelect, fileSystemConfig.value.properties.quota.unit]
                ])
              ]),
              createBaseVNode("div", _hoisted_23, [
                fileSystemConfig.value.properties.quota.raw !== null ? (openBlock(), createElementBlock("div", _hoisted_24, [
                  createBaseVNode("p", _hoisted_25, "Used Space: " + toDisplayString(unref(convertBytesToSize)(fileSystemConfig.value.properties.used)), 1)
                ])) : createCommentVNode("", true),
                fileSystemConfig.value.properties.quota.raw === null || !fileSystemConfig.value.properties.quota.raw ? (openBlock(), createElementBlock("div", _hoisted_26, _cache[27] || (_cache[27] = [
                  createBaseVNode("p", { class: "text-muted" }, "There is no quota currently set.", -1)
                ]))) : createCommentVNode("", true)
              ])
            ]),
            createBaseVNode("div", _hoisted_27, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-recordsize"),
                class: "block text-sm font-medium leading-6 text-default"
              }, "Record Size", 8, _hoisted_28),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-recordsize"),
                "onUpdate:modelValue": _cache[6] || (_cache[6] = ($event) => fileSystemConfig.value.properties.recordSize = $event),
                name: "fs-config-recordsize",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[28] || (_cache[28] = [
                createBaseVNode("option", { value: "512" }, "512 B", -1),
                createBaseVNode("option", { value: "4K" }, "4 KiB", -1),
                createBaseVNode("option", { value: "8K" }, "8 KiB", -1),
                createBaseVNode("option", { value: "16K" }, "16 KiB", -1),
                createBaseVNode("option", { value: "32K" }, "32 KiB", -1),
                createBaseVNode("option", { value: "64K" }, "64 KiB", -1),
                createBaseVNode("option", { value: "128K" }, "128 KiB", -1),
                createBaseVNode("option", { value: "256K" }, "256 KiB", -1),
                createBaseVNode("option", { value: "512K" }, "512 KiB", -1),
                createBaseVNode("option", { value: "1M" }, "1 MiB", -1)
              ]), 8, _hoisted_29), [
                [vModelSelect, fileSystemConfig.value.properties.recordSize]
              ])
            ]),
            createBaseVNode("div", _hoisted_30, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-refreservation"),
                class: "mb-1 block text-sm font-medium leading-6 text-default"
              }, "Refreservation", 8, _hoisted_31),
              createBaseVNode("div", _hoisted_32, [
                withDirectives(createBaseVNode("input", {
                  "onUpdate:modelValue": _cache[7] || (_cache[7] = ($event) => fileSystemConfig.value.properties.refreservation.raw = $event),
                  id: getIdKey("fs-config-refreservation-amount"),
                  name: "fs-config-refreservation-slider",
                  type: "range",
                  min: "0",
                  max: "1000",
                  step: "1",
                  class: "text-default mt-5 w-3/4 h-2 bg-accent rounded-lg appearance-none cursor-pointer"
                }, null, 8, _hoisted_33), [
                  [vModelText, fileSystemConfig.value.properties.refreservation.raw]
                ]),
                withDirectives(createBaseVNode("input", {
                  "onUpdate:modelValue": _cache[8] || (_cache[8] = ($event) => fileSystemConfig.value.properties.refreservation.raw = $event),
                  type: "number",
                  name: "fs-config-refreservation-num",
                  id: getIdKey("fs-config-refreservation-num"),
                  min: "0",
                  max: "1000",
                  class: "text-default bg-default mt-1 w-fit block py-1.5 px-1.5 ml-1 text-default placeholder:text-muted input-textlike sm:text-sm sm:leading-6"
                }, null, 8, _hoisted_34), [
                  [vModelText, fileSystemConfig.value.properties.refreservation.raw]
                ]),
                withDirectives(createBaseVNode("select", {
                  "onUpdate:modelValue": _cache[9] || (_cache[9] = ($event) => fileSystemConfig.value.properties.refreservation.unit = $event),
                  id: getIdKey("fs-config-refreservation-size"),
                  name: "fs-config-refreservation-size",
                  class: "block sm:col-span-1 bg-default py-1.5 pl-3 pr-10 text-default input-textlike sm:text-sm sm:leading-6"
                }, _cache[29] || (_cache[29] = [
                  createBaseVNode("option", { value: "kib" }, "KiB", -1),
                  createBaseVNode("option", { value: "mib" }, "MiB", -1),
                  createBaseVNode("option", { value: "gib" }, "GiB", -1),
                  createBaseVNode("option", { value: "tib" }, "TiB", -1)
                ]), 8, _hoisted_35), [
                  [vModelSelect, fileSystemConfig.value.properties.refreservation.unit]
                ])
              ]),
              createBaseVNode("div", _hoisted_36, [
                fileSystemConfig.value.properties.refreservation.raw !== null ? (openBlock(), createElementBlock("div", _hoisted_37, [
                  createBaseVNode("p", _hoisted_38, "Available Space: " + toDisplayString(unref(convertBytesToSize)(fileSystemConfig.value.properties.available)), 1)
                ])) : createCommentVNode("", true),
                fileSystemConfig.value.properties.refreservation.raw === null || !fileSystemConfig.value.properties.refreservation.raw ? (openBlock(), createElementBlock("div", _hoisted_39, _cache[30] || (_cache[30] = [
                  createBaseVNode("p", { class: "text-muted" }, "There is no refreservation currently set.", -1)
                ]))) : createCommentVNode("", true)
              ])
            ]),
            createBaseVNode("div", _hoisted_40, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-acl-inherit"),
                class: "bg-default block text-base leading-6 text-default"
              }, "ACL Inheritance", 8, _hoisted_41),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-acl-inherit"),
                "onUpdate:modelValue": _cache[10] || (_cache[10] = ($event) => fileSystemConfig.value.properties.aclInheritance = $event),
                name: "fs-config-acl-inherit",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[31] || (_cache[31] = [
                createBaseVNode("option", { value: "discard" }, "Discard", -1),
                createBaseVNode("option", { value: "noallow" }, "No Allow", -1),
                createBaseVNode("option", { value: "restricted" }, "Restricted", -1),
                createBaseVNode("option", { value: "passthrough" }, "Passthrough", -1),
                createBaseVNode("option", { value: "passthrough-x" }, "Passthrough-X", -1)
              ]), 8, _hoisted_42), [
                [vModelSelect, fileSystemConfig.value.properties.aclInheritance]
              ])
            ]),
            createBaseVNode("div", _hoisted_43, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-acl-type"),
                class: "bg-default block text-base leading-6 text-default"
              }, "ACL Type", 8, _hoisted_44),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-acl-type"),
                "onUpdate:modelValue": _cache[11] || (_cache[11] = ($event) => fileSystemConfig.value.properties.aclType = $event),
                name: "fs-config-acl-type",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[32] || (_cache[32] = [
                createBaseVNode("option", { value: "off" }, "Off/No ACL", -1),
                createBaseVNode("option", { value: "posix" }, "POSIX ACL", -1)
              ]), 8, _hoisted_45), [
                [vModelSelect, fileSystemConfig.value.properties.aclType]
              ])
            ]),
            createBaseVNode("div", _hoisted_46, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-access-time"),
                class: "bg-default block text-base leading-6 text-default"
              }, "Access Time", 8, _hoisted_47),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-access-time"),
                "onUpdate:modelValue": _cache[12] || (_cache[12] = ($event) => fileSystemConfig.value.properties.accessTime = $event),
                name: "fs-config-access-time",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[33] || (_cache[33] = [
                createBaseVNode("option", { value: "on" }, "On", -1),
                createBaseVNode("option", { value: "off" }, "Off", -1)
              ]), 8, _hoisted_48), [
                [vModelSelect, fileSystemConfig.value.properties.accessTime]
              ])
            ]),
            createBaseVNode("div", _hoisted_49, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-dedup"),
                class: "bg-default block text-base leading-6 text-default"
              }, "Deduplication", 8, _hoisted_50),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-dedup"),
                "onUpdate:modelValue": _cache[13] || (_cache[13] = ($event) => fileSystemConfig.value.properties.deduplication = $event),
                name: "fs-config-dedup",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[34] || (_cache[34] = [
                createBaseVNode("option", { value: "on" }, "On", -1),
                createBaseVNode("option", { value: "off" }, "Off", -1),
                createBaseVNode("option", { value: "edonr,verify" }, "Edon-R + Verify", -1),
                createBaseVNode("option", { value: "sha256" }, "SHA-256", -1),
                createBaseVNode("option", { value: "sha256,verify" }, "SHA-256 + Verify", -1),
                createBaseVNode("option", { value: "sha512" }, "SHA-512", -1),
                createBaseVNode("option", { value: "sha512,verify" }, "SHA-512 + Verify", -1),
                createBaseVNode("option", { value: "skein" }, "Skein", -1),
                createBaseVNode("option", { value: "skein,verify" }, "Skein + Verify", -1),
                createBaseVNode("option", { value: "verify" }, "Verify", -1)
              ]), 8, _hoisted_51), [
                [vModelSelect, fileSystemConfig.value.properties.deduplication]
              ])
            ]),
            createBaseVNode("div", _hoisted_52, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-compression"),
                class: "bg-default block text-base leading-6 text-default"
              }, "Compression", 8, _hoisted_53),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-compression"),
                "onUpdate:modelValue": _cache[14] || (_cache[14] = ($event) => fileSystemConfig.value.properties.compression = $event),
                name: "fs-config-compression",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[35] || (_cache[35] = [
                createBaseVNode("option", { value: "on" }, "On", -1),
                createBaseVNode("option", { value: "off" }, "Off", -1),
                createBaseVNode("option", { value: "gzip" }, "GZIP", -1),
                createBaseVNode("option", { value: "lz4" }, "LZ4", -1),
                createBaseVNode("option", { value: "lzjb" }, "LZJB", -1),
                createBaseVNode("option", { value: "zle" }, "ZLE", -1)
              ]), 8, _hoisted_54), [
                [vModelSelect, fileSystemConfig.value.properties.compression]
              ])
            ]),
            createBaseVNode("div", _hoisted_55, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-checksum"),
                class: "bg-default block text-base leading-6 text-default"
              }, "Checksum", 8, _hoisted_56),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-checksum"),
                "onUpdate:modelValue": _cache[15] || (_cache[15] = ($event) => fileSystemConfig.value.properties.checksum = $event),
                name: "fs-config-checksum",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[36] || (_cache[36] = [
                createBaseVNode("option", { value: "on" }, "On", -1),
                createBaseVNode("option", { value: "off" }, "Off", -1),
                createBaseVNode("option", { value: "edonr" }, "Edon-R", -1),
                createBaseVNode("option", { value: "fletcher2" }, "Fletcher2", -1),
                createBaseVNode("option", { value: "fletcher4" }, "Fletcher4", -1),
                createBaseVNode("option", { value: "noparity" }, "No Parity", -1),
                createBaseVNode("option", { value: "sha256" }, "SHA-256", -1),
                createBaseVNode("option", { value: "sha512" }, "SHA-512", -1),
                createBaseVNode("option", { value: "skein" }, "Skein", -1)
              ]), 8, _hoisted_57), [
                [vModelSelect, fileSystemConfig.value.properties.checksum]
              ])
            ]),
            createBaseVNode("div", _hoisted_58, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-dnode-size"),
                class: "bg-default block text-base leading-6 text-default"
              }, "DNode Size", 8, _hoisted_59),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-dnode-size"),
                "onUpdate:modelValue": _cache[16] || (_cache[16] = ($event) => fileSystemConfig.value.properties.dNodeSize = $event),
                name: "fs-config-dnode-size",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[37] || (_cache[37] = [
                createBaseVNode("option", { value: "1k" }, "1 KiB", -1),
                createBaseVNode("option", { value: "2k" }, "2 KiB", -1),
                createBaseVNode("option", { value: "4k" }, "4 KiB", -1),
                createBaseVNode("option", { value: "8k" }, "8 KiB", -1),
                createBaseVNode("option", { value: "16k" }, "16 KiB", -1),
                createBaseVNode("option", { value: "auto" }, "Auto", -1),
                createBaseVNode("option", { value: "legacy" }, "Legacy", -1)
              ]), 8, _hoisted_60), [
                [vModelSelect, fileSystemConfig.value.properties.dNodeSize]
              ])
            ]),
            createBaseVNode("div", _hoisted_61, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-xattr"),
                class: "bg-default block text-base leading-6 text-default"
              }, "Extended Attributes", 8, _hoisted_62),
              withDirectives(createBaseVNode("select", {
                id: getIdKey("fs-config-xattr"),
                "onUpdate:modelValue": _cache[17] || (_cache[17] = ($event) => fileSystemConfig.value.properties.extendedAttributes = $event),
                name: "fs-config-xattr",
                class: "mt-1 block w-full input-textlike bg-default"
              }, _cache[38] || (_cache[38] = [
                createBaseVNode("option", { value: "on" }, "On", -1),
                createBaseVNode("option", { value: "off" }, "Off", -1),
                createBaseVNode("option", { value: "sa" }, "System Attribute", -1)
              ]), 8, _hoisted_63), [
                [vModelSelect, fileSystemConfig.value.properties.extendedAttributes]
              ])
            ]),
            props.filesystem.encrypted ? (openBlock(), createElementBlock("div", _hoisted_64, [
              createBaseVNode("label", {
                for: getIdKey("fs-config-encryption"),
                name: "fs-config-encryption",
                class: "bg-default block text-base leading-6 text-default"
              }, "Encryption", 8, _hoisted_65),
              createBaseVNode("p", _hoisted_66, toDisplayString(props.filesystem.properties.encryption.toUpperCase()), 1)
            ])) : createCommentVNode("", true)
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_67, [
            createBaseVNode("div", _hoisted_68, [
              createBaseVNode("div", _hoisted_69, [
                quotaFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_70, toDisplayString(quotaFeedback.value), 1)) : createCommentVNode("", true),
                refreservationFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_71, toDisplayString(refreservationFeedback.value), 1)) : createCommentVNode("", true)
              ])
            ]),
            createBaseVNode("div", _hoisted_72, [
              createBaseVNode("button", {
                onClick: _cache[18] || (_cache[18] = ($event) => showFSConfig.value = false),
                id: getIdKey("cancel-configure-btn"),
                name: "cancel-configure-btn",
                class: "mt-1 btn btn-danger object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_73),
              unref(fileSystemsLoaded) && saving.value == false ? (openBlock(), createElementBlock("button", {
                key: 0,
                onClick: _cache[19] || (_cache[19] = ($event) => fsConfigureBtn()),
                id: getIdKey("edit-fs-btn"),
                name: "edit-fs-btn",
                class: "mt-1 btn btn-primary object-right justify-end h-fit"
              }, "Configure", 8, _hoisted_74)) : createCommentVNode("", true),
              unref(fileSystemsLoaded) && saving.value !== false ? (openBlock(), createElementBlock("button", {
                key: 1,
                disabled: "",
                id: getIdKey("edit-fs-spinner"),
                type: "button",
                class: "btn btn-danger object-right justify-end"
              }, _cache[39] || (_cache[39] = [
                createBaseVNode("svg", {
                  "aria-hidden": "true",
                  role: "status",
                  class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                  viewBox: "0 0 100 101",
                  fill: "none",
                  xmlns: "http://www.w3.org/2000/svg"
                }, [
                  createBaseVNode("path", {
                    d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                    fill: "currentColor"
                  }),
                  createBaseVNode("path", {
                    d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                    fill: "text-success"
                  })
                ], -1),
                createTextVNode(" Saving... ")
              ]), 8, _hoisted_75)) : createCommentVNode("", true)
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
