import { d as defineComponent, r as ref, i as inject, c as computed, o as onMounted, w as watch, a1 as detachDisk, p as pushNotification, N as Notification, k as labelClear, a2 as offlineDisk, a3 as onlineDisk, s as scrubPool, a4 as trimDisk, v as provide, x as openBlock, y as createElementBlock, z as createBaseVNode, C as normalizeClass, D as unref, E as toDisplayString, J as formatStatus, A as createVNode, B as withCtx, S as Se, a5 as withModifiers, T as Transition, M as Me, I as be, G as createCommentVNode, H as ge, O as Fragment, P as renderList, Q as createBlock, R as resolveDynamicComponent, l as loadDisksThenPools, a as loadDatasets, b as loadScanObjectGroup, e as loadScanActivities, f as loadDiskStats, h as loadTrimActivities, _ as __vitePreload, a6 as removeVDevFromPool, a7 as setRefreservation, $ as upperCaseWord, g as getCapacityColor, j as destroyPool, m as resilverPool, n as isPoolUpgradable, u as upgradePool, t as trimPool, q as exportPool, Z as createTextVNode, F as render$2, L as normalizeStyle, U as clearErrors } from "./index.6d4442b8.js";
import { _ as _sfc_main$4 } from "./Status.vue_vue_type_script_setup_true_lang.6c19da9d.js";
import { r as render, a as render$3, _ as _sfc_main$5 } from "./LoadingSpinner.vue_vue_type_script_setup_true_lang.0b36469d.js";
import { Q, r as render$1, V, N } from "./disclosure.4723c881.js";
const _hoisted_1$3 = { class: "border-b border-t border-collapse border-default" };
const _hoisted_2$3 = { class: "grid grid-cols-9 grid-flow-cols w-full text-center bg-accent text-default" };
const _hoisted_3$3 = ["title"];
const _hoisted_4$3 = ["title"];
const _hoisted_5$3 = ["title"];
const _hoisted_6$3 = ["title"];
const _hoisted_7$3 = ["title"];
const _hoisted_8$3 = {
  name: "disk-message",
  class: "py-1 -mt-1 col-span-2"
};
const _hoisted_9$3 = {
  name: "disk-",
  class: "col-span-1"
};
const _hoisted_10$3 = { class: "relative py-1 pl-3 pr-4 text-right font-medium sm:pr-6 lg:pr-8" };
const _hoisted_11$3 = { class: "py-1" };
const _hoisted_12$3 = {
  key: 0,
  class: "border border-collapse border-default"
};
const _hoisted_13$3 = { class: "grid grid-cols-9 grid-flow-cols w-full text-center bg-accent text-default" };
const _hoisted_14$3 = ["title"];
const _hoisted_15$2 = { key: 0 };
const _hoisted_16$2 = { key: 1 };
const _hoisted_17$1 = { key: 2 };
const _hoisted_18$1 = { key: 3 };
const _hoisted_19$1 = { key: 4 };
const _hoisted_20$1 = { key: 5 };
const _hoisted_21$1 = { key: 6 };
const _sfc_main$3 = /* @__PURE__ */ defineComponent({
  __name: "DiskElement",
  props: {
    pool: {},
    poolIdx: {},
    vDev: {},
    vDevIdx: {},
    disk: {},
    diskIdx: {}
  },
  setup(__props, { expose: __expose }) {
    const props = __props;
    const selectedPool = ref();
    const selectedDisk = ref();
    const selectedVDev = ref();
    const operationRunning = ref(false);
    const firstOptionToggle = ref(false);
    const secondOptionToggle = ref(false);
    const truncateText = inject("style-truncate-text");
    function getIsTrimmable() {
      selectedPool.value = props.pool;
      if (selectedPool.value.diskType != "HDD") {
        if (props.disk.vDevType == "data" || props.disk.vDevType == "log" || props.disk.vDevType == "special" || props.disk.vDevType == "dedup") {
          return true;
        } else {
          return false;
        }
      } else {
        return false;
      }
    }
    const diskSdName = computed(() => {
      if (!props.disk.sd_path.includes(props.disk.name)) {
        return `(${props.disk.sd_path.replace(/^\/dev\//, "")})`;
      }
    });
    onMounted(() => {
      getIsTrimmable();
    });
    const poolData = inject("pools");
    const diskData = inject("disks");
    const filesystemData = inject("datasets");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      diskData.value = [];
      poolData.value = [];
      filesystemData.value = [];
      await loadDisksThenPools(diskData, poolData);
      await loadDatasets(filesystemData);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(poolData, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(poolData, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
      console.log("DiskElement trimActivities", trimActivities.value);
    }
    const starting = ref(false);
    const scanStatusBox = inject("scan-status-box");
    async function getScanStatus() {
      console.log("scanStatusBox", scanStatusBox.value);
      await scanStatusBox.value.pollScanStatus();
    }
    const diskState = computed(() => {
      const diskArray = poolDiskStats.value[props.pool.name];
      const diskState2 = diskArray.find((disk) => disk.name === props.disk.name);
      if (diskState2) {
        return diskState2.status;
      } else {
        return "MISSING";
      }
    });
    const showDetachDiskModal = ref(false);
    const confirmDetach = ref(false);
    const detaching = ref(false);
    const detachDiskComponent = ref();
    const loadDetachDiskComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      detachDiskComponent.value = module.default;
    };
    async function detachThisDisk(pool, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      await loadDetachDiskComponent();
      showDetachDiskModal.value = true;
      console.log("Preparing to detach:", selectedDisk.value.name, "from:", selectedPool.value.name);
    }
    const confirmThisDetach = () => {
      confirmDetach.value = true;
    };
    const updateShowDetachDisk = (newVal) => {
      showDetachDiskModal.value = newVal;
    };
    watch(confirmDetach, async (newValue, oldValue) => {
      if (confirmDetach.value == true) {
        detaching.value = true;
        operationRunning.value = true;
        console.log("now detaching:", selectedDisk.value.name, "from:", selectedPool.value.name);
        try {
          const output = await detachDisk(selectedPool.value.name, selectedDisk.value.name);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            operationRunning.value = false;
            confirmDetach.value = false;
            pushNotification(new Notification("Detach Disk Failed", `${selectedDisk.value.name} was not detached: ${errorMessage}`, "error", 5e3));
          } else {
            if (secondOptionToggle.value == true) {
              await labelClear(selectedDisk.value);
            }
            await refreshAllData();
            confirmDetach.value = false;
            detaching.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Detach Completed", `${selectedDisk.value.name} was detached from ${selectedPool.value.name}`, "success", 5e3));
            showDetachDiskModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const showOfflineDiskModal = ref(false);
    const confirmOffline = ref(false);
    const offlining = ref(false);
    const offlineDiskComponent = ref();
    const loadOfflineDiskComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      offlineDiskComponent.value = module.default;
    };
    async function offlineThisDisk(pool, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      console.log("selected pool:", selectedPool.value, "selected disk:", selectedDisk.value);
      await loadOfflineDiskComponent();
      showOfflineDiskModal.value = true;
    }
    const confirmThisOffline = () => {
      confirmOffline.value = true;
    };
    const updateShowOfflineDisk = (newVal) => {
      showOfflineDiskModal.value = newVal;
    };
    watch(confirmOffline, async (newVal, oldVal) => {
      if (confirmOffline.value == true) {
        offlining.value = true;
        operationRunning.value = true;
        console.log("now offlining:", selectedDisk.value);
        try {
          const output = await offlineDisk(selectedPool.value.name, selectedDisk.value.name, firstOptionToggle.value, secondOptionToggle.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            operationRunning.value = false;
            confirmOffline.value = false;
            pushNotification(new Notification("Offline Failed", `Offlining of disk ${selectedDisk.value.name} failed: ${errorMessage}`, "error", 5e3));
          } else {
            await refreshAllData();
            confirmOffline.value = false;
            offlining.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Offline Completed", "Offlining of disk " + selectedDisk.value.name + " completed.", "success", 5e3));
            showOfflineDiskModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const showOnlineDiskModal = ref(false);
    const confirmOnline = ref(false);
    const onlining = ref(false);
    const onlineDiskComponent = ref();
    const loadOnlineDiskComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      onlineDiskComponent.value = module.default;
    };
    async function onlineThisDisk(pool, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      console.log("selected pool:", selectedPool.value, "selected disk:", selectedDisk.value);
      await loadOnlineDiskComponent();
      showOnlineDiskModal.value = true;
    }
    const confirmThisOnline = () => {
      confirmOnline.value = true;
    };
    const updateShowOnlineDisk = (newVal) => {
      showOnlineDiskModal.value = newVal;
    };
    watch(confirmOnline, async (newVal, oldVal) => {
      if (confirmOnline.value == true) {
        onlining.value = true;
        operationRunning.value = true;
        console.log("now onlining:", selectedDisk.value);
        try {
          const output = await onlineDisk(selectedPool.value.name, selectedDisk.value.name, firstOptionToggle.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            operationRunning.value = false;
            confirmOnline.value = false;
            pushNotification(new Notification("Online Failed", `Onlining of disk ${selectedDisk.value.name} failed: ${errorMessage}`, "error", 5e3));
          } else {
            if (secondOptionToggle.value == true) {
              starting.value = true;
              try {
                const output2 = await scrubPool(selectedPool.value);
                if (output2 == null || output2.error) {
                  const errorMessage2 = (output2 == null ? void 0 : output2.error) || "Unknown error";
                  pushNotification(new Notification("Scrub Failed", `Scrub on ${selectedDisk.value.name} failed: ${errorMessage2}.`, "error", 5e3));
                } else {
                  await getScanStatus();
                  pushNotification(new Notification("Scrub Started", "Scrub on " + selectedPool.value.name + " started.", "success", 5e3));
                }
              } catch (error) {
                console.error(error);
              }
              starting.value = false;
            }
            onlining.value = false;
            confirmOnline.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Online Completed", "Onlining of disk " + selectedDisk.value.name + " completed.", "success", 5e3));
            showOnlineDiskModal.value = false;
          }
          await refreshAllData();
        } catch (error) {
          console.error(error);
        }
      }
    });
    const showTrimDiskModal = ref(false);
    const confirmTrimDisk = ref(false);
    ref(false);
    const pausingDiskTrim = ref(false);
    const stoppingDiskTrim = ref(false);
    const resumingDiskTrim = ref(false);
    const trimDiskComponent = ref();
    const loadTrimDiskComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimDiskComponent.value = module.default;
    };
    const trimPauseDiskComponent = ref();
    const loadTrimPauseDiskComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimPauseDiskComponent.value = module.default;
    };
    const trimStopDiskComponent = ref();
    const loadTrimStopDiskComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimStopDiskComponent.value = module.default;
    };
    async function trimThisDisk(pool, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      console.log("selected pool:", selectedPool.value, "selected disk:", selectedDisk.value);
      await loadTrimDiskComponent();
      showTrimDiskModal.value = true;
    }
    const confirmThisDiskTrim = () => {
      confirmTrimDisk.value = true;
    };
    const updateShowTrimDisk = (newVal) => {
      showTrimDiskModal.value = newVal;
    };
    watch(confirmTrimDisk, async (newValue, oldValue) => {
      if (confirmTrimDisk.value == true) {
        operationRunning.value = true;
        console.log("now trimming:", selectedPool.value);
        try {
          const output = await trimDisk(selectedPool.value.name, selectedDisk.value.name, firstOptionToggle.value ? firstOptionToggle.value : false);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            confirmTrimDisk.value = false;
            pushNotification(new Notification("Trim Failed", `Trim failed to start: ${errorMessage}`, "error", 5e3));
          } else {
            getDiskTrimStatus();
            confirmTrimDisk.value = false;
            pushNotification(new Notification("Trim Started", "Trim on " + selectedDisk.value.name + " started.", "success", 5e3));
            showTrimDiskModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        operationRunning.value = false;
      }
    });
    async function pauseTrim(pool, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      await loadTrimPauseDiskComponent();
      showPauseTrimConfirm.value = true;
      console.log("trim to pause:", selectedPool.value);
    }
    async function resumeTrim(pool, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      resumingDiskTrim.value = true;
      try {
        const output = await trimDisk(selectedPool.value.name, selectedDisk.value.name);
        if (output == null || output.error) {
          const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
          pushNotification(new Notification("Trim Resume Failed", "Trim failed to resume:${errorMessage}", "error", 5e3));
        } else {
          getDiskTrimStatus();
          pushNotification(new Notification("Trim Resumed", "Trim on " + selectedDisk.value.name + " resumed.", "success", 5e3));
        }
      } catch (error) {
        console.error(error);
      }
      resumingDiskTrim.value = false;
    }
    async function stopTrim(pool, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      await loadTrimStopDiskComponent();
      showStopTrimConfirm.value = true;
      console.log("trim to stop:", selectedPool.value);
    }
    const showPauseTrimConfirm = ref(false);
    const confirmPauseTrim = ref(false);
    const confirmPauseThisTrim = () => {
      confirmPauseTrim.value = true;
    };
    const updateShowPauseTrim = (newVal) => {
      showPauseTrimConfirm.value = newVal;
    };
    watch(confirmPauseTrim, async (newVal, oldVal) => {
      if (confirmPauseTrim.value == true) {
        console.log("now pausing trim:", selectedPool.value);
        pausingDiskTrim.value = true;
        try {
          const output = await trimDisk(selectedPool.value.name, selectedDisk.value.name, false, "pause");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            confirmPauseTrim.value = false;
            pushNotification(new Notification("Trim Pause Failed", `Trim failed to pause: ${errorMessage}`, "error", 5e3));
          } else {
            getDiskTrimStatus();
            confirmPauseTrim.value = false;
            pushNotification(new Notification("Trim Paused", "Trim on " + selectedDisk.value.name + " paused.", "success", 5e3));
            showPauseTrimConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        pausingDiskTrim.value = false;
      }
    });
    const showStopTrimConfirm = ref(false);
    const confirmStopTrim = ref(false);
    const confirmStopThisTrim = () => {
      confirmStopTrim.value = true;
    };
    const updateShowStopTrim = (newVal) => {
      showStopTrimConfirm.value = newVal;
    };
    watch(confirmStopTrim, async (newVal, oldVal) => {
      if (confirmStopTrim.value == true) {
        console.log("now stopping trim:", selectedPool.value);
        stoppingDiskTrim.value = true;
        try {
          const output = await trimDisk(selectedPool.value.name, selectedDisk.value.name, false, "stop");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            confirmStopTrim.value = false;
            pushNotification(new Notification("Trim Stop Failed", `Trim failed to stop: ${errorMessage}`, "error", 5e3));
          } else {
            getDiskTrimStatus();
            confirmStopTrim.value = false;
            pushNotification(new Notification("Trim Stopped", "Trim on " + selectedDisk.value.name + " stopped.", "success", 5e3));
            showStopTrimConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        stoppingDiskTrim.value = false;
      }
    });
    const showReplaceDiskModal = ref(false);
    const replaceDiskComponent = ref();
    const loadReplaceDiskComponent = async () => {
      const module = await __vitePreload(() => import("./ReplaceDiskModal.89d15603.js"), true ? ["./ReplaceDiskModal.89d15603.js","./index.6d4442b8.js","./index.4bb2164e.css","./loadImportables.89a51a80.js","./ExclamationTriangleIcon.be4eb01d.js","./switch.bba63450.js"] : void 0, import.meta.url);
      replaceDiskComponent.value = module.default;
    };
    const updateShowReplaceDisk = (newVal) => {
      showReplaceDiskModal.value = newVal;
    };
    async function replaceThisDisk(pool, vdev, disk) {
      selectedPool.value = pool;
      selectedDisk.value = disk;
      selectedVDev.value = vdev;
      console.log("selected pool:", selectedPool.value, "selectedVDev:", selectedVDev, "selected disk:", selectedDisk.value);
      await loadReplaceDiskComponent();
      showReplaceDiskModal.value = true;
    }
    const trimStatusBox = ref();
    async function getDiskTrimStatus() {
      await trimStatusBox.value.pollTrimStatus();
    }
    const diskID = ref(props.disk.name);
    const trimActivity = computed(() => {
      return trimActivities.value.get(diskID.value);
    });
    __expose({
      getDiskTrimStatus
    });
    provide("modal-confirm-running", operationRunning);
    provide("show-replace-modal", showReplaceDiskModal);
    provide("modal-option-one-toggle", firstOptionToggle);
    provide("modal-option-two-toggle", secondOptionToggle);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createBaseVNode("div", _hoisted_1$3, [
          createBaseVNode("div", _hoisted_2$3, [
            createBaseVNode("div", {
              name: "disk-name",
              class: normalizeClass(["py-1 mt-1 col-span-2", unref(truncateText)]),
              title: props.disk.name
            }, toDisplayString(props.disk.name) + " " + toDisplayString(diskSdName.value), 11, _hoisted_3$3),
            createBaseVNode("div", {
              name: "disk-state",
              class: normalizeClass(["py-1 mt-1 col-span-1 font-semibold", [unref(formatStatus)(diskState.value), unref(truncateText)]]),
              title: diskState.value
            }, toDisplayString(diskState.value), 11, _hoisted_4$3),
            createBaseVNode("div", {
              name: "disk-type",
              class: normalizeClass(["py-1 mt-1 col-span-1", unref(truncateText)]),
              title: props.disk.type
            }, toDisplayString(props.disk.type), 11, _hoisted_5$3),
            createBaseVNode("div", {
              name: "disk-temp",
              class: normalizeClass(["py-1 mt-1 col-span-1", unref(truncateText)]),
              title: props.disk.temp
            }, toDisplayString(props.disk.temp), 11, _hoisted_6$3),
            createBaseVNode("div", {
              name: "disk-capacity",
              class: normalizeClass(["py-1 mt-1 col-span-1", unref(truncateText)]),
              title: props.disk.capacity
            }, toDisplayString(props.disk.capacity), 11, _hoisted_7$3),
            createBaseVNode("div", _hoisted_8$3, [
              createVNode(_sfc_main$4, {
                isTrim: false,
                disk: props.disk,
                pool: props.pool,
                isDisk: true,
                isPoolList: true,
                isPoolDetail: false,
                idKey: "trim-status-box",
                ref_key: "trimStatusBox",
                ref: trimStatusBox,
                isTrimmable: getIsTrimmable()
              }, null, 8, ["disk", "pool", "isTrimmable"])
            ]),
            createBaseVNode("div", _hoisted_9$3, [
              createBaseVNode("div", _hoisted_10$3, [
                createVNode(unref(ge), {
                  as: "div",
                  class: "relative inline-block text-right"
                }, {
                  default: withCtx(() => [
                    createBaseVNode("div", null, [
                      createVNode(unref(Se), {
                        onClick: _cache[0] || (_cache[0] = withModifiers(() => {
                        }, ["stop"])),
                        class: "flex items-center rounded-full bg-accent p-2 hover:text-default focus:outline-none focus:ring-2 focus:ring-slate-500 focus:ring-offset-2 focus:ring-offset-gray-100"
                      }, {
                        default: withCtx(() => [
                          _cache[9] || (_cache[9] = createBaseVNode("span", { class: "sr-only" }, "Open options", -1)),
                          createVNode(unref(render), {
                            class: "w-5",
                            "aria-hidden": "true"
                          })
                        ]),
                        _: 1
                      })
                    ]),
                    createVNode(Transition, {
                      "enter-active-class": "transition ease-out duration-100",
                      "enter-from-class": "transform opacity-0 scale-95",
                      "enter-to-class": "transform opacity-100 scale-100",
                      "leave-active-class": "transition ease-in duration-75",
                      "leave-from-class": "transform opacity-100 scale-100",
                      "leave-to-class": "transform opacity-0 scale-95"
                    }, {
                      default: withCtx(() => [
                        createVNode(unref(Me), { class: "absolute right-0 z-10 w-max origin-top-right rounded-md bg-accent shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none" }, {
                          default: withCtx(() => [
                            createBaseVNode("div", _hoisted_11$3, [
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  props.vDev.disks.length > 1 && diskState.value !== "REMOVED" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[1] || (_cache[1] = ($event) => detachThisDisk(props.pool, props.disk)),
                                    class: normalizeClass([active ? "bg-danger text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Detach Disk", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  diskState.value == "ONLINE" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[2] || (_cache[2] = ($event) => offlineThisDisk(props.pool, props.disk)),
                                    class: normalizeClass([active ? "bg-danger text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Offline Disk", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  diskState.value == "OFFLINE" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[3] || (_cache[3] = ($event) => onlineThisDisk(props.pool, props.disk)),
                                    class: normalizeClass([active ? "bg-green-600 text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Online Disk", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  diskState.value !== "REMOVED" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[4] || (_cache[4] = ($event) => replaceThisDisk(props.pool, props.vDev, props.disk)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Replace Disk", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  !trimActivity.value.isActive && !trimActivity.value.isPaused && props.pool.diskType != "HDD" && getIsTrimmable() && diskState.value !== "REMOVED" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[5] || (_cache[5] = ($event) => trimThisDisk(props.pool, props.disk)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "TRIM Disk", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  trimActivity.value.isPaused && props.pool.diskType != "HDD" && getIsTrimmable() && diskState.value !== "REMOVED" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[6] || (_cache[6] = ($event) => resumeTrim(props.pool, props.disk)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "TRIM Disk", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  trimActivity.value.isActive && props.pool.diskType != "HDD" && getIsTrimmable() && diskState.value !== "REMOVED" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[7] || (_cache[7] = ($event) => pauseTrim(props.pool, props.disk)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Pause TRIM (Disk)", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              }),
                              createVNode(unref(be), { as: "div" }, {
                                default: withCtx(({ active }) => [
                                  trimActivity.value.isActive || trimActivity.value.isPaused && props.pool.diskType != "HDD" && getIsTrimmable() && diskState.value !== "REMOVED" ? (openBlock(), createElementBlock("a", {
                                    key: 0,
                                    href: "#",
                                    onClick: _cache[8] || (_cache[8] = ($event) => stopTrim(props.pool, props.disk)),
                                    class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                  }, "Cancel TRIM (Disk)", 2)) : createCommentVNode("", true)
                                ]),
                                _: 1
                              })
                            ])
                          ]),
                          _: 1
                        })
                      ]),
                      _: 1
                    })
                  ]),
                  _: 1
                })
              ])
            ])
          ]),
          diskState.value == "REPLACING" || diskState.value == "MISSING" ? (openBlock(), createElementBlock("div", _hoisted_12$3, [
            (openBlock(true), createElementBlock(Fragment, null, renderList(props.disk.children, (disk) => {
              return openBlock(), createElementBlock("div", _hoisted_13$3, [
                createBaseVNode("div", {
                  class: normalizeClass(["py-1 mt-1 col-span-3", unref(truncateText)]),
                  title: disk.name
                }, toDisplayString(props.disk.name), 11, _hoisted_14$3),
                _cache[10] || (_cache[10] = createBaseVNode("div", { class: "py-1 mt-1 col-span-3" }, null, -1)),
                _cache[11] || (_cache[11] = createBaseVNode("div", { class: "py-1 mt-1 col-span-3" }, null, -1))
              ]);
            }), 256))
          ])) : createCommentVNode("", true)
        ]),
        showDetachDiskModal.value ? (openBlock(), createElementBlock("div", _hoisted_15$2, [
          (openBlock(), createBlock(resolveDynamicComponent(detachDiskComponent.value), {
            showFlag: showDetachDiskModal.value,
            onClose: updateShowDetachDisk,
            idKey: "confirm-detach-disk",
            item: "disk",
            operation: "detach",
            pool: selectedPool.value,
            disk: selectedDisk.value,
            confirmOperation: confirmThisDetach,
            secondOption: "clear disk labels",
            hasChildren: false
          }, null, 40, ["showFlag", "pool", "disk"]))
        ])) : createCommentVNode("", true),
        showOfflineDiskModal.value ? (openBlock(), createElementBlock("div", _hoisted_16$2, [
          (openBlock(), createBlock(resolveDynamicComponent(offlineDiskComponent.value), {
            showFlag: showOfflineDiskModal.value,
            onClose: updateShowOfflineDisk,
            idKey: "confirm-offline-disk",
            item: "disk",
            operation: "offline",
            pool: selectedPool.value,
            disk: selectedDisk.value,
            confirmOperation: confirmThisOffline,
            firstOption: "forcefully offline",
            secondOption: "temporarily offline until next reboot",
            hasChildren: false
          }, null, 40, ["showFlag", "pool", "disk"]))
        ])) : createCommentVNode("", true),
        showOnlineDiskModal.value ? (openBlock(), createElementBlock("div", _hoisted_17$1, [
          (openBlock(), createBlock(resolveDynamicComponent(onlineDiskComponent.value), {
            showFlag: showOnlineDiskModal.value,
            onClose: updateShowOnlineDisk,
            idKey: "confirm-online-disk",
            item: "disk",
            operation: "online",
            pool: selectedPool.value,
            disk: selectedDisk.value,
            confirmOperation: confirmThisOnline,
            firstOption: "expand devices to use whole disk",
            secondOption: "scrub pool after coming online",
            hasChildren: false
          }, null, 40, ["showFlag", "pool", "disk"]))
        ])) : createCommentVNode("", true),
        showTrimDiskModal.value ? (openBlock(), createElementBlock("div", _hoisted_18$1, [
          (openBlock(), createBlock(resolveDynamicComponent(trimDiskComponent.value), {
            showFlag: showTrimDiskModal.value,
            onClose: updateShowTrimDisk,
            idKey: "confirm-trim-disk",
            item: "disk",
            operation: "trim",
            pool: selectedPool.value,
            disk: selectedDisk.value,
            confirmOperation: confirmThisDiskTrim,
            firstOption: "secure TRIM",
            hasChildren: false
          }, null, 40, ["showFlag", "pool", "disk"]))
        ])) : createCommentVNode("", true),
        showPauseTrimConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_19$1, [
          (openBlock(), createBlock(resolveDynamicComponent(trimPauseDiskComponent.value), {
            showFlag: showPauseTrimConfirm.value,
            onClose: updateShowPauseTrim,
            idKey: "confirm-pause-trim",
            item: "pool",
            operation: "pause",
            operation2: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmPauseThisTrim,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showStopTrimConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_20$1, [
          (openBlock(), createBlock(resolveDynamicComponent(trimStopDiskComponent.value), {
            showFlag: showStopTrimConfirm.value,
            onClose: updateShowStopTrim,
            idKey: "confirm-stop-trim",
            item: "pool",
            operation: "stop",
            operation2: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmStopThisTrim,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showReplaceDiskModal.value ? (openBlock(), createElementBlock("div", _hoisted_21$1, [
          (openBlock(), createBlock(resolveDynamicComponent(replaceDiskComponent.value), {
            showFlag: showReplaceDiskModal.value,
            onClose: updateShowReplaceDisk,
            idKey: "show-replace-modal",
            pool: selectedPool.value,
            vDev: selectedVDev.value,
            disk: selectedDisk.value
          }, null, 40, ["showFlag", "pool", "vDev", "disk"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
const _hoisted_1$2 = { class: "" };
const _hoisted_2$2 = { class: "" };
const _hoisted_3$2 = {
  name: "vdev-chevron",
  class: "p-1 mt-1 col-span-1 flex flex-row justify-center text-center"
};
const _hoisted_4$2 = ["title"];
const _hoisted_5$2 = ["title"];
const _hoisted_6$2 = ["title"];
const _hoisted_7$2 = ["title"];
const _hoisted_8$2 = ["title"];
const _hoisted_9$2 = ["title"];
const _hoisted_10$2 = {
  name: "vdev-menu",
  class: "col-span-1 relative p-1 pl-3 pr-4 text-right font-medium sm:pr-6 lg:pr-8 justify-self-end justify-items-end"
};
const _hoisted_11$2 = { class: "py-1" };
const _hoisted_12$2 = { class: "min-w-full bg-secondary text-default" };
const _hoisted_13$2 = { key: 0 };
const _hoisted_14$2 = { key: 1 };
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "VDevElement",
  props: {
    pool: {},
    poolIdx: {},
    vDev: {},
    vDevIdx: {}
  },
  setup(__props, { expose: __expose }) {
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const selectedPool = ref();
    const selectedVDev = ref();
    const operationRunning = ref(false);
    const poolData = inject("pools");
    const diskData = inject("disks");
    const filesystemData = inject("datasets");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      diskData.value = [];
      poolData.value = [];
      filesystemData.value = [];
      await loadDisksThenPools(diskData, poolData);
      await loadDatasets(filesystemData);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(poolData, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(poolData, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
      console.log("VDevElement trimActivities", trimActivities.value);
    }
    const showRemoveVDevConfirm = ref(false);
    const confirmRemove = ref(false);
    const showRemoveVDevComponent = ref();
    const loadShowRemoveVDevComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      showRemoveVDevComponent.value = module.default;
    };
    async function removeVDev(pool, vDev) {
      selectedPool.value = pool;
      selectedVDev.value = vDev;
      await loadShowRemoveVDevComponent();
      showRemoveVDevConfirm.value = true;
      console.log("preparing to remove:", selectedVDev.value, "from pool:", selectedPool.value);
    }
    const confirmThisRemove = () => {
      confirmRemove.value = true;
    };
    const updateShowRemoveVDev = (newVal) => {
      showRemoveVDevConfirm.value = newVal;
    };
    watch(confirmRemove, async (newValue, oldValue) => {
      if (confirmRemove.value == true) {
        operationRunning.value = true;
        console.log("now removing:", selectedVDev.value, "from pool:", selectedPool.value);
        try {
          const output = await removeVDevFromPool(selectedVDev.value, selectedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Remove Failed", `Failed to remove Virtual Device: ${errorMessage}`, "error", 5e3));
          } else {
            pushNotification(new Notification("Remove Completed", `Removed VDev ${selectedVDev.value.name} from Pool ${selectedPool.value.name}`, "success", 5e3));
            if (props.pool.properties.refreservationRawSize) {
              const output2 = await setRefreservation(props.pool, props.pool.properties.refreservationPercent);
              if (output2 == null || output2.error) {
                const errorMessage = (output2 == null ? void 0 : output2.error) || "Unknown error";
                pushNotification(new Notification("Refreservation Update Failed", `Error updating refreservation: ${errorMessage}`, "error", 5e3));
              } else {
                pushNotification(new Notification("Refreservation Updated", `Refreservation of pool was updated successfully.`, "success", 5e3));
                showRemoveVDevConfirm.value = false;
              }
            } else {
              showRemoveVDevConfirm.value = false;
            }
            confirmRemove.value = false;
            showRemoveVDevConfirm.value = false;
          }
          confirmRemove.value = false;
          await refreshAllData();
        } catch (error) {
          console.error(error);
        }
        await refreshAllData();
        operationRunning.value = false;
      }
    });
    const showAttachDiskModal = ref(false);
    const showAttachDiskComponent = ref();
    const loadShowAttachDiskComponent = async () => {
      const module = await __vitePreload(() => import("./AttachDiskModal.83079d25.js"), true ? ["./AttachDiskModal.83079d25.js","./index.6d4442b8.js","./index.4bb2164e.css","./loadImportables.89a51a80.js","./ExclamationTriangleIcon.be4eb01d.js","./switch.bba63450.js"] : void 0, import.meta.url);
      showAttachDiskComponent.value = module.default;
    };
    const updateShowAttachDisk = (newVal) => {
      showAttachDiskModal.value = newVal;
    };
    async function showAttachDisk(pool, vdev) {
      selectedPool.value = pool;
      selectedVDev.value = vdev;
      console.log("selectedPool:", selectedPool, "selectedVDev:", selectedVDev);
      await loadShowAttachDiskComponent();
      showAttachDiskModal.value = true;
    }
    const diskElement = ref();
    async function getDiskStatus() {
      await diskElement.value[0].getDiskTrimStatus();
    }
    __expose({
      getDiskStatus
    });
    provide("show-attach-modal", showAttachDiskModal);
    provide("modal-confirm-running", operationRunning);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createBaseVNode("div", _hoisted_1$2, [
          createBaseVNode("div", _hoisted_2$2, [
            createVNode(unref(N), { defaultOpen: true }, {
              default: withCtx(({ open }) => [
                createVNode(unref(Q), { class: "grid grid-cols-8 grid-flow-cols w-full text-center bg-primary text-sm text-white" }, {
                  default: withCtx(() => [
                    createBaseVNode("div", _hoisted_3$2, [
                      createVNode(unref(render$1), {
                        class: normalizeClass(["-mt-2 h-10 w-10 text-white transition-all duration-200 transform", { "rotate-90": !open, "rotate-180": open }])
                      }, null, 8, ["class"])
                    ]),
                    createBaseVNode("div", {
                      name: "vdev-name",
                      class: normalizeClass(["p-1 mt-1 col-span-1 text-base text-left", unref(truncateText)]),
                      title: props.vDev.name
                    }, toDisplayString(props.vDev.name), 11, _hoisted_4$2),
                    createBaseVNode("div", {
                      name: "vdev-status",
                      class: normalizeClass(["p-1 mt-1 col-span-1 font-semibold text-base", [unref(formatStatus)(props.vDev.status), unref(truncateText)]]),
                      title: props.vDev.status
                    }, toDisplayString(props.vDev.status), 11, _hoisted_5$2),
                    createBaseVNode("div", {
                      name: "vdev-type",
                      class: normalizeClass(["p-1 mt-1 col-span-1 text-base", unref(truncateText)]),
                      title: unref(upperCaseWord)(props.vDev.type) + " Device"
                    }, toDisplayString(unref(upperCaseWord)(props.vDev.type)) + " Device", 11, _hoisted_6$2),
                    createBaseVNode("div", {
                      name: "vdev-read-err",
                      class: normalizeClass(["p-1 mt-1 col-span-1 text-base", unref(truncateText)]),
                      title: props.vDev.stats.read_errors + " Read Errors"
                    }, toDisplayString(props.vDev.stats.read_errors) + " Read Errors", 11, _hoisted_7$2),
                    createBaseVNode("div", {
                      name: "vdev-write-err",
                      class: normalizeClass(["p-1 mt-1 col-span-1 text-base", unref(truncateText)]),
                      title: props.vDev.stats.write_errors + " Write Errors"
                    }, toDisplayString(props.vDev.stats.write_errors) + " Write Errors", 11, _hoisted_8$2),
                    createBaseVNode("div", {
                      name: "vdev-checksum-err",
                      class: normalizeClass(["p-1 mt-1 col-span-1 text-base", unref(truncateText)]),
                      title: props.vDev.stats.checksum_errors + " Checksum Errors"
                    }, toDisplayString(props.vDev.stats.checksum_errors) + " Checksum Errors", 11, _hoisted_9$2),
                    createBaseVNode("div", _hoisted_10$2, [
                      createVNode(unref(ge), {
                        as: "div",
                        class: "relative inline-block text-right"
                      }, {
                        default: withCtx(() => [
                          createBaseVNode("div", null, [
                            createVNode(unref(Se), {
                              onClick: _cache[0] || (_cache[0] = withModifiers(() => {
                              }, ["stop"])),
                              class: "flex items-center rounded-full bg-primary p-2 hover:text-white focus:outline-none focus:ring-2 focus:ring-slate-500 focus:ring-offset-2 focus:ring-offset-gray-100"
                            }, {
                              default: withCtx(() => [
                                _cache[4] || (_cache[4] = createBaseVNode("span", { class: "sr-only" }, "Open options", -1)),
                                createVNode(unref(render), {
                                  class: "w-5",
                                  "aria-hidden": "true"
                                })
                              ]),
                              _: 1
                            })
                          ]),
                          createVNode(Transition, {
                            "enter-active-class": "transition ease-out duration-100",
                            "enter-from-class": "transform opacity-0 scale-95",
                            "enter-to-class": "transform opacity-100 scale-100",
                            "leave-active-class": "transition ease-in duration-75",
                            "leave-from-class": "transform opacity-100 scale-100",
                            "leave-to-class": "transform opacity-0 scale-95"
                          }, {
                            default: withCtx(() => [
                              createVNode(unref(Me), {
                                onClick: _cache[3] || (_cache[3] = withModifiers(() => {
                                }, ["stop"])),
                                class: "absolute right-0 z-10 w-max origin-top-right rounded-md bg-primary shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none"
                              }, {
                                default: withCtx(() => [
                                  createBaseVNode("div", _hoisted_11$2, [
                                    _ctx.pool.vdevs.length !== 1 && _ctx.vDev !== _ctx.pool.vdevs[0] && !_ctx.vDev.type.includes("raid") ? (openBlock(), createBlock(unref(be), {
                                      key: 0,
                                      as: "div"
                                    }, {
                                      default: withCtx(({ active }) => [
                                        createBaseVNode("a", {
                                          href: "#",
                                          onClick: _cache[1] || (_cache[1] = ($event) => removeVDev(props.pool, props.pool.vdevs[_ctx.vDevIdx])),
                                          class: normalizeClass([active ? "bg-danger text-white" : "text-white", "block px-4 py-2 text-sm"])
                                        }, "Remove Virtual Device", 2)
                                      ]),
                                      _: 1
                                    })) : createCommentVNode("", true),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        createBaseVNode("a", {
                                          href: "#",
                                          onClick: _cache[2] || (_cache[2] = ($event) => showAttachDisk(props.pool, props.vDev)),
                                          class: normalizeClass([active ? "bg-primary text-white" : "text-white", "block px-4 py-2 text-sm"])
                                        }, "Attach Disk", 2)
                                      ]),
                                      _: 1
                                    })
                                  ])
                                ]),
                                _: 1
                              })
                            ]),
                            _: 1
                          })
                        ]),
                        _: 1
                      })
                    ])
                  ]),
                  _: 2
                }, 1024),
                createVNode(unref(V), null, {
                  default: withCtx(() => [
                    createBaseVNode("table", _hoisted_12$2, [
                      createBaseVNode("thead", null, [
                        (openBlock(), createElementBlock("tr", {
                          key: props.vDevIdx,
                          class: "grid grid-cols-9 font-semibold text-white"
                        }, [
                          createBaseVNode("th", {
                            class: normalizeClass(["py-2 col-span-2", unref(truncateText)]),
                            title: "Disk"
                          }, "Disk", 2),
                          createBaseVNode("th", {
                            class: normalizeClass(["py-2 col-span-1", unref(truncateText)]),
                            title: "State"
                          }, "State", 2),
                          createBaseVNode("th", {
                            class: normalizeClass(["py-2 col-span-1", unref(truncateText)]),
                            title: "Type"
                          }, "Type", 2),
                          createBaseVNode("th", {
                            class: normalizeClass(["py-2 col-span-1", unref(truncateText)]),
                            title: "Temperature"
                          }, "Temperature", 2),
                          createBaseVNode("th", {
                            class: normalizeClass(["py-2 col-span-1", unref(truncateText)]),
                            title: "Capacity"
                          }, "Capacity", 2),
                          createBaseVNode("th", {
                            class: normalizeClass(["py-2 col-span-2", unref(truncateText)]),
                            title: "Message"
                          }, "Message", 2),
                          _cache[5] || (_cache[5] = createBaseVNode("th", { class: "relative py-2 pl-3 pr-4 sm:pr-6 lg:pr-8 col-span-1" }, [
                            createBaseVNode("span", { class: "sr-only" })
                          ], -1))
                        ]))
                      ])
                    ]),
                    (openBlock(true), createElementBlock(Fragment, null, renderList(props.vDev.disks, (disk, diskIdx) => {
                      return openBlock(), createElementBlock("div", {
                        key: diskIdx,
                        class: ""
                      }, [
                        createVNode(_sfc_main$3, {
                          pool: unref(poolData)[props.poolIdx],
                          poolIdx: props.poolIdx,
                          vDev: props.vDev,
                          vDevIdx: props.vDevIdx,
                          disk,
                          diskIdx,
                          ref_for: true,
                          ref_key: "diskElement",
                          ref: diskElement
                        }, null, 8, ["pool", "poolIdx", "vDev", "vDevIdx", "disk", "diskIdx"])
                      ]);
                    }), 128))
                  ]),
                  _: 1
                })
              ]),
              _: 1
            })
          ])
        ]),
        showAttachDiskModal.value ? (openBlock(), createElementBlock("div", _hoisted_13$2, [
          (openBlock(), createBlock(resolveDynamicComponent(showAttachDiskComponent.value), {
            showFlag: showAttachDiskModal.value,
            onClose: updateShowAttachDisk,
            idKey: "show-attach-disk-modal",
            pool: selectedPool.value,
            vDev: selectedVDev.value
          }, null, 40, ["showFlag", "pool", "vDev"]))
        ])) : createCommentVNode("", true),
        showRemoveVDevConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_14$2, [
          (openBlock(), createBlock(resolveDynamicComponent(showRemoveVDevComponent.value), {
            showFlag: showRemoveVDevConfirm.value,
            onClose: updateShowRemoveVDev,
            idKey: "confirm-remove-vdev",
            item: "vdev",
            operation: "remove",
            pool: selectedPool.value,
            vdev: selectedVDev.value,
            confirmOperation: confirmThisRemove,
            hasChildren: false
          }, null, 40, ["showFlag", "pool", "vdev"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
const _hoisted_1$1 = { class: "" };
const _hoisted_2$1 = { class: "" };
const _hoisted_3$1 = ["title"];
const _hoisted_4$1 = ["title"];
const _hoisted_5$1 = {
  key: 0,
  title: "Pool was made with a legacy version of ZFS. Upgrade available.",
  class: "flex flex-row justify-between w-fit bg-default rounded-full items-center"
};
const _hoisted_6$1 = ["title"];
const _hoisted_7$1 = {
  name: "pool-percentage",
  class: "py-1 mt-1 col-span-1"
};
const _hoisted_8$1 = ["title"];
const _hoisted_9$1 = { key: 0 };
const _hoisted_10$1 = { class: "w-full bg-well rounded-full h-4 mt-1 text-center relative flex overflow-hidden" };
const _hoisted_11$1 = { class: "absolute inset-0 flex items-center justify-center text-sm font-medium text-default p-0.5 leading-none" };
const _hoisted_12$1 = { key: 1 };
const _hoisted_13$1 = { class: "w-full bg-well rounded-full h-4 mt-1 text-center relative flex overflow-hidden" };
const _hoisted_14$1 = { class: "absolute inset-0 flex items-center justify-center text-sm font-medium text-default p-0.5 leading-none" };
const _hoisted_15$1 = ["title"];
const _hoisted_16$1 = ["title"];
const _hoisted_17 = ["title"];
const _hoisted_18 = {
  name: "pool-message",
  class: "py-1 -mt-1 col-span-2"
};
const _hoisted_19 = {
  name: "pool-menu",
  class: "relative py-1 mt-1 p-3 text-right font-medium sm:pr-6 lg:pr-8"
};
const _hoisted_20 = { class: "py-1" };
const _hoisted_21 = { key: 0 };
const _hoisted_22 = { key: 1 };
const _hoisted_23 = { key: 2 };
const _hoisted_24 = { key: 3 };
const _hoisted_25 = { key: 4 };
const _hoisted_26 = { key: 5 };
const _hoisted_27 = { key: 6 };
const _hoisted_28 = { key: 7 };
const _hoisted_29 = { key: 8 };
const _hoisted_30 = { key: 9 };
const _hoisted_31 = { key: 10 };
const _hoisted_32 = { key: 11 };
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "PoolListElement",
  props: {
    poolIdx: {},
    pool: {}
  },
  setup(__props) {
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const selectedPool = ref();
    const selectedDisk = ref();
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const clearLabels = inject("clear-labels");
    function getIsTrimmable() {
      selectedPool.value = props.pool;
      if (selectedPool.value.diskType != "HDD") {
        if (selectedPool.value.vdevs.some((vdev) => vdev.type == "data" || vdev.type == "log" || vdev.type == "special" || vdev.type == "dedup")) {
          return true;
        } else {
          return false;
        }
      } else {
        return false;
      }
    }
    onMounted(() => {
      getIsTrimmable();
      canUpgradePool(props.pool.name);
    });
    const capacityColor = computed(
      () => getCapacityColor("bg", props.pool.properties.capacity, props.pool.properties.refreservationPercent)
    );
    const operationRunning = ref(false);
    const firstOptionToggle = ref(false);
    const secondOptionToggle = ref(false);
    const thirdOptionToggle = ref(false);
    const fourthOptionToggle = ref(false);
    const showPoolDetails = ref(false);
    const confirmSavePool = ref(false);
    const showPoolDetailsComponent = ref();
    const loadShowPoolDetailsComponent = async () => {
      const module = await __vitePreload(() => import("./PoolDetail.99a3ebbd.js"), true ? ["./PoolDetail.99a3ebbd.js","./index.6d4442b8.js","./index.4bb2164e.css","./Card.vue_vue_type_script_setup_true_lang.ad07e235.js","./switch.bba63450.js"] : void 0, import.meta.url);
      showPoolDetailsComponent.value = module.default;
    };
    async function showPoolModal(pool) {
      selectedPool.value = pool;
      console.log("loading:", selectedPool.value);
      await loadShowPoolDetailsComponent();
      showPoolDetails.value = true;
    }
    const confirmSavePoolDetails = () => {
      confirmSavePool.value = true;
    };
    const updateShowPoolDetails = (newVal) => {
      showPoolDetails.value = newVal;
    };
    watch(confirmSavePool, async (newVal, oldVal) => {
      if (confirmSavePool.value == true) {
        pushNotification(new Notification("Pool Config Saved", "Successfully saved this pool's configuration.", "success", 5e3));
        await refreshAllData();
      }
    });
    const poolData = inject("pools");
    const diskData = inject("disks");
    const filesystemData = inject("datasets");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanOperation = computed(() => {
      return scanObjectGroup.value[props.pool.name].function;
    });
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      diskData.value = [];
      poolData.value = [];
      filesystemData.value = [];
      await loadDisksThenPools(diskData, poolData);
      await loadDatasets(filesystemData);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(poolData, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(poolData, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
      console.log("PoolListElement trimActivities", trimActivities.value);
    }
    const confirmDelete = ref(false);
    const showDeletePoolConfirm = ref(false);
    const hasChildren = ref(false);
    const forceDestroy = ref(false);
    const confirmDeletePoolComponent = ref();
    const loadConfirmDeletePoolComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      confirmDeletePoolComponent.value = module.default;
    };
    async function destroyPoolAndUpdate(pool) {
      operationRunning.value = false;
      selectedPool.value = pool;
      clearLabels.value = false;
      await loadConfirmDeletePoolComponent();
      showDeletePoolConfirm.value = true;
      console.log("preparing to delete:", selectedPool.value);
    }
    const confirmThisDestroy = () => {
      confirmDelete.value = true;
    };
    const updateShowDestroyPool = (newVal) => {
      showDeletePoolConfirm.value = newVal;
    };
    watch(confirmDelete, async (newValue, oldValue) => {
      const poolName = selectedPool.value.name;
      if (confirmDelete.value == true) {
        operationRunning.value = true;
        console.log("now deleting:", selectedPool.value);
        try {
          const output = await destroyPool(selectedPool.value, firstOptionToggle.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            operationRunning.value = false;
            confirmDelete.value = false;
            pushNotification(new Notification("Destroy Pool Failed", selectedPool.value.name + ` was not destroyed: ${errorMessage}`, "error", 5e3));
          } else {
            if (secondOptionToggle.value == true) {
              selectedPool.value.vdevs.forEach((vDev) => {
                vDev.disks.forEach(async (disk) => {
                  selectedDisk.value = disk;
                  await labelClear(selectedDisk.value);
                });
              });
            }
            await refreshAllData();
            confirmDelete.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Pool Destroyed", `${poolName} destroyed.`, "success", 5e3));
            showDeletePoolConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const confirmResilver = ref(false);
    const showResilverModal = ref(false);
    const resilvered = ref(false);
    const confirmResilverPoolComponent = ref();
    const loadConfirmResilverPoolComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      confirmResilverPoolComponent.value = module.default;
    };
    async function resilverThisPool(pool) {
      selectedPool.value = pool;
      await loadConfirmResilverPoolComponent();
      showResilverModal.value = true;
      console.log("preparing to resilver:", selectedPool.value);
    }
    const confirmThisResilver = () => {
      confirmResilver.value = true;
    };
    const updateShowResilverPool = (newVal) => {
      showResilverModal.value = newVal;
    };
    watch(confirmResilver, async (newValue, oldValue) => {
      if (confirmResilver.value == true) {
        resilvered.value = false;
        operationRunning.value = true;
        console.log("now resilvering:", selectedPool.value);
        try {
          const output = await resilverPool(selectedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            confirmResilver.value = false;
            pushNotification(new Notification("Resilver Failed", `Resilver failed to start:${errorMessage}`, "error", 5e3));
            operationRunning.value = false;
          } else {
            getScanStatus();
            confirmResilver.value = false;
            resilvered.value = true;
            operationRunning.value = false;
            showResilverModal.value = false;
            pushNotification(new Notification("Resilver Started", "Resilver on " + selectedPool.value.name + " started.", "success", 5e3));
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const upgradeablePool = ref(false);
    const showUpgradeModal = ref(false);
    const confirmUpgrade = ref(false);
    const upgrading = ref(false);
    async function canUpgradePool(poolName) {
      return upgradeablePool.value = await isPoolUpgradable(props.pool.name);
    }
    const upgradeConfirmComponent = ref();
    const loadUpgradeConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      upgradeConfirmComponent.value = module.default;
    };
    async function upgradeThisPool(pool) {
      selectedPool.value = pool;
      await loadUpgradeConfirmComponent();
      showUpgradeModal.value = true;
      console.log("preparing to upgrade:", selectedPool.value);
    }
    const confirmThisUpgrade = () => {
      confirmUpgrade.value = true;
    };
    const updateShowUpgradePool = (newVal) => {
      showUpgradeModal.value = newVal;
    };
    watch(confirmUpgrade, async (newVal, oldVal) => {
      if (confirmUpgrade.value == true) {
        operationRunning.value = true;
        console.log("now upgrading:", selectedPool.value);
        upgrading.value = true;
        try {
          const output = await upgradePool(selectedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Upgrade Failed", `Upgrade failed: ${errorMessage}`, "error", 5e3));
            operationRunning.value = false;
            confirmUpgrade.value = false;
          } else {
            getScanStatus();
            confirmUpgrade.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Upgrade Successful", "Upgrade on " + selectedPool.value.name + " succeeded.", "success", 5e3));
            showUpgradeModal.value = false;
            canUpgradePool(selectedPool.value.name);
          }
          upgrading.value = true;
        } catch (error) {
          console.error(error);
        }
      }
    });
    const showScrubModal = ref(false);
    const confirmScrub = ref(false);
    const starting = ref(false);
    const pausing = ref(false);
    const stopping = ref(false);
    const resuming = ref(false);
    const scrubConfirmComponent = ref();
    const loadScrubConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      scrubConfirmComponent.value = module.default;
    };
    const scrubPauseConfirmComponent = ref();
    const loadScrubPauseConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      scrubPauseConfirmComponent.value = module.default;
    };
    const scrubStopConfirmComponent = ref();
    const loadScrubStopConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      scrubStopConfirmComponent.value = module.default;
    };
    async function scrubThisPool(pool) {
      selectedPool.value = pool;
      await loadScrubConfirmComponent();
      showScrubModal.value = true;
      console.log("preparing to scrub:", selectedPool.value);
    }
    const confirmThisScrub = () => {
      confirmScrub.value = true;
    };
    const updateShowScrubPool = (newVal) => {
      showScrubModal.value = newVal;
    };
    watch(confirmScrub, async (newVal, oldVal) => {
      if (confirmScrub.value == true) {
        operationRunning.value = true;
        console.log("now scrubbing:", selectedPool.value);
        starting.value = true;
        try {
          const output = await scrubPool(selectedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Scrub Failed", `Scrub failed to start:${errorMessage}`, "error", 5e3));
            operationRunning.value = false;
            confirmScrub.value = false;
          } else {
            getScanStatus();
            confirmScrub.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Scrub Started", "Scrub on " + selectedPool.value.name + " started.", "success", 5e3));
            showScrubModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    async function pauseScrub(pool) {
      selectedPool.value = pool;
      await loadScrubPauseConfirmComponent();
      showPauseScrubConfirm.value = true;
      console.log("scrub to pause:", selectedPool.value);
    }
    async function resumeScrub(pool) {
      resuming.value = true;
      try {
        const output = await scrubPool(selectedPool.value);
        if (output == null || output.error) {
          const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
          pushNotification(new Notification("Scrub Resume Failed", `Scrub failed to resume:${errorMessage}`, "error", 5e3));
          confirmScrub.value = false;
        } else {
          getScanStatus();
          confirmScrub.value = false;
          pushNotification(new Notification("Scrub Resumed", "Scrub on " + selectedPool.value.name + " resumed.", "success", 5e3));
          showScrubModal.value = false;
        }
      } catch (error) {
        console.error(error);
      }
      resuming.value = false;
    }
    async function stopScrub(pool) {
      selectedPool.value = pool;
      await loadScrubStopConfirmComponent();
      showStopScrubConfirm.value = true;
      console.log("scrub to pause:", selectedPool.value);
    }
    const showPauseScrubConfirm = ref(false);
    const confirmPauseScrub = ref(false);
    const confirmPauseThisScrub = () => {
      confirmPauseScrub.value = true;
    };
    const updateShowPauseScrub = (newVal) => {
      showPauseScrubConfirm.value = newVal;
    };
    watch(confirmPauseScrub, async (newVal, oldVal) => {
      if (confirmPauseScrub.value == true) {
        console.log("now pausing scrub:", selectedPool.value);
        pausing.value = true;
        try {
          const output = await scrubPool(selectedPool.value, "pause");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Scrub Pause Failed", `Scrub failed to pause:${errorMessage}`, "error", 5e3));
            confirmPauseScrub.value = false;
          } else {
            getScanStatus();
            confirmPauseScrub.value = false;
            pushNotification(new Notification("Scrub Paused", "Scrub on " + selectedPool.value.name + " paused.", "success", 5e3));
            showPauseScrubConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        pausing.value = false;
      }
    });
    const showStopScrubConfirm = ref(false);
    const confirmStopScrub = ref(false);
    const confirmStopThisScrub = () => {
      confirmStopScrub.value = true;
    };
    const updateShowStopScrub = (newVal) => {
      showStopScrubConfirm.value = newVal;
    };
    watch(confirmStopScrub, async (newVal, oldVal) => {
      if (confirmStopScrub.value == true) {
        console.log("now stopping scrub:", selectedPool.value);
        stopping.value = true;
        try {
          const output = await scrubPool(selectedPool.value, "stop");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Scrub Stop Failed", `Scrub failed to stop:${errorMessage}`, "error", 5e3));
            confirmStopScrub.value = false;
          } else {
            getScanStatus();
            confirmStopScrub.value = false;
            pushNotification(new Notification("Scrub Stopped", "Scrub on " + selectedPool.value.name + " stopped.", "success", 5e3));
            showStopScrubConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        stopping.value = false;
      }
    });
    const showTrimModal = ref(false);
    const confirmTrim = ref(false);
    const secureTRIM = ref(false);
    const startingTrim = ref(false);
    const pausingTrim = ref(false);
    const stoppingTrim = ref(false);
    const resumingTrim = ref(false);
    const trimConfirmComponent = ref();
    const loadTrimConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimConfirmComponent.value = module.default;
    };
    const trimPauseConfirmComponent = ref();
    const loadTrimPauseConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimPauseConfirmComponent.value = module.default;
    };
    const trimStopConfirmComponent = ref();
    const loadTrimStopConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      trimStopConfirmComponent.value = module.default;
    };
    async function trimThisPool(pool) {
      selectedPool.value = pool;
      await loadTrimConfirmComponent();
      showTrimModal.value = true;
      console.log("preparing to trim:", selectedPool.value);
    }
    const confirmThisTrim = () => {
      confirmTrim.value = true;
    };
    const updateShowTrimPool = (newVal) => {
      showTrimModal.value = newVal;
    };
    watch(confirmTrim, async (newValue, oldValue) => {
      if (confirmTrim.value == true) {
        startingTrim.value = true;
        console.log("now trimming:", selectedPool.value);
        try {
          const output = await trimPool(selectedPool.value, firstOptionToggle.value ? firstOptionToggle.value : false);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Trim Failed", `Trim failed to start:${errorMessage}`, "error", 5e3));
            confirmTrim.value = false;
          } else {
            getTrimStatus();
            confirmTrim.value = false;
            pushNotification(new Notification("Trim Started", "Trim on " + selectedPool.value.name + " started.", "success", 5e3));
            showTrimModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        startingTrim.value = false;
      }
    });
    async function pauseTrim(pool) {
      selectedPool.value = pool;
      await loadTrimPauseConfirmComponent();
      showPauseTrimConfirm.value = true;
      console.log("trim to pause:", selectedPool.value);
    }
    async function resumeTrim(pool) {
      resumingTrim.value = true;
      try {
        const output = await trimPool(pool);
        if (output == null || output.error) {
          const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
          pushNotification(new Notification("Trim Resume Failed", `Trim failed to resume:${errorMessage}`, "error", 5e3));
          confirmTrim.value = false;
        } else {
          getTrimStatus();
          confirmTrim.value = false;
          pushNotification(new Notification("Trim Resumed", "Trim on " + selectedPool.value.name + " resumed.", "success", 5e3));
        }
      } catch (error) {
        console.error(error);
      }
      resumingTrim.value = false;
    }
    async function stopTrim(pool) {
      selectedPool.value = pool;
      await loadTrimStopConfirmComponent();
      showStopTrimConfirm.value = true;
      console.log("trim to stop:", selectedPool.value);
    }
    const showPauseTrimConfirm = ref(false);
    const confirmPauseTrim = ref(false);
    const confirmPauseThisTrim = () => {
      confirmPauseTrim.value = true;
    };
    const updateShowPauseTrim = (newVal) => {
      showPauseTrimConfirm.value = newVal;
    };
    watch(confirmPauseTrim, async (newVal, oldVal) => {
      if (confirmPauseTrim.value == true) {
        console.log("now pausing trim:", selectedPool.value);
        pausingTrim.value = true;
        try {
          const output = await trimPool(selectedPool.value, false, "pause");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Trim Pause Failed", `Trim failed to pause:${errorMessage}`, "error", 5e3));
            confirmPauseTrim.value = false;
          } else {
            getTrimStatus();
            confirmPauseTrim.value = false;
            pushNotification(new Notification("Trim Paused", "Trim on " + selectedPool.value.name + " paused.", "success", 5e3));
            showPauseTrimConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        pausingTrim.value = false;
      }
    });
    const showStopTrimConfirm = ref(false);
    const confirmStopTrim = ref(false);
    const confirmStopThisTrim = () => {
      confirmStopTrim.value = true;
    };
    const updateShowStopTrim = (newVal) => {
      showStopTrimConfirm.value = newVal;
    };
    watch(confirmStopTrim, async (newVal, oldVal) => {
      if (confirmStopTrim.value == true) {
        console.log("now stopping trim:", selectedPool.value);
        stoppingTrim.value = true;
        try {
          const output = await trimPool(selectedPool.value, false, "stop");
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Trim Stop Failed", `Trim failed to stop:${errorMessage}`, "error", 5e3));
            confirmStopTrim.value = false;
          } else {
            getTrimStatus();
            confirmStopTrim.value = false;
            pushNotification(new Notification("Trim Stopped", "Trim on " + selectedPool.value.name + " stopped.", "success", 5e3));
            showStopTrimConfirm.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        stoppingTrim.value = false;
      }
    });
    const showExportModal = ref(false);
    const confirmExport = ref(false);
    const forceUnmount = ref(false);
    const exporting = ref(false);
    const exportConfirmComponent = ref();
    const loadExportConfirmComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.a992edd7.js"), true ? ["./UniversalConfirmation.a992edd7.js","./index.6d4442b8.js","./index.4bb2164e.css","./switch.bba63450.js"] : void 0, import.meta.url);
      exportConfirmComponent.value = module.default;
    };
    async function exportThisPool(pool) {
      selectedPool.value = pool;
      await loadExportConfirmComponent();
      showExportModal.value = true;
      console.log("preparing to export:", selectedPool.value);
    }
    const confirmThisExport = () => {
      confirmExport.value = true;
    };
    const updateShowExportPool = (newVal) => {
      showExportModal.value = newVal;
    };
    watch(confirmExport, async (newVal, oldVal) => {
      if (confirmExport.value == true) {
        exporting.value = true;
        operationRunning.value = true;
        console.log("now exporting:", selectedPool.value);
        try {
          const output = await exportPool(selectedPool.value, firstOptionToggle.value ? firstOptionToggle.value : false);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Export Failed", `Pool failed to export:${errorMessage}`, "error", 5e3));
            confirmExport.value = false;
          } else {
            pushNotification(new Notification("Export Completed", "Export of pool " + selectedPool.value.name + " completed.", "success", 5e3));
            await refreshAllData();
            confirmExport.value = false;
            showExportModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
        exporting.value = false;
        operationRunning.value = false;
      }
    });
    async function clearPoolErrors(poolName) {
      await clearErrors(poolName);
      await refreshAllData();
    }
    const showAddVDevModal = ref(false);
    const showAddVDevComponent = ref();
    const loadShowAddVDevComponent = async () => {
      const module = await __vitePreload(() => import("./AddVDevModal.3f2501fb.js"), true ? ["./AddVDevModal.3f2501fb.js","./index.6d4442b8.js","./index.4bb2164e.css","./loadImportables.89a51a80.js","./ExclamationTriangleIcon.be4eb01d.js","./switch.bba63450.js","./AddVDevModal.2b382f5f.css"] : void 0, import.meta.url);
      showAddVDevComponent.value = module.default;
    };
    async function showAddVDev(pool) {
      selectedPool.value = pool;
      console.log(selectedPool);
      await loadShowAddVDevComponent();
      showAddVDevModal.value = true;
    }
    const scanStatusBox = ref();
    const scanActivities = inject("scan-activities");
    async function getScanStatus() {
      console.log("scanStatusBox", scanStatusBox.value);
      await scanStatusBox.value.pollScanStatus();
    }
    const vDevElement = ref();
    const trimActivities = inject("trim-activities");
    async function getTrimStatus() {
      console.log("trimActivity:", trimActivity.value);
      if (vDevElement.value && Array.isArray(vDevElement.value) && vDevElement.value.length > 0) {
        await vDevElement.value[0].getDiskStatus();
      } else {
        console.error("vDevElement is not defined or does not contain an array with elements.");
      }
    }
    const poolID = ref(props.pool.name);
    const scanActivity = computed(() => {
      return scanActivities.value.get(poolID.value);
    });
    const trimActivity = computed(() => {
      return trimActivities.value.get(poolID.value);
    });
    provide("show-pool-deets", showPoolDetails);
    provide("confirm-save-pool", confirmSavePool);
    provide("show-delete-pool-confirm", showDeletePoolConfirm);
    provide("confirm-delete-pool", confirmDelete);
    provide("has-children", hasChildren);
    provide("force-destroy", forceDestroy);
    provide("show-resilver-modal", showResilverModal);
    provide("confirm-resilver", confirmResilver);
    provide("show-trim-modal", showTrimModal);
    provide("secure-trim", secureTRIM);
    provide("confirm-trim", confirmTrim);
    provide("show-export-modal", showExportModal);
    provide("confirm-export", confirmExport);
    provide("force-unmount", forceUnmount);
    provide("show-vdev-modal", showAddVDevModal);
    provide("modal-confirm-running", operationRunning);
    provide("modal-option-one-toggle", firstOptionToggle);
    provide("modal-option-two-toggle", secondOptionToggle);
    provide("modal-option-three-toggle", thirdOptionToggle);
    provide("modal-option-four-toggle", fourthOptionToggle);
    provide("scan-status-box", scanStatusBox);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createBaseVNode("div", _hoisted_1$1, [
          createBaseVNode("div", _hoisted_2$1, [
            createVNode(unref(N), { defaultOpen: false }, {
              default: withCtx(({ open }) => [
                createVNode(unref(Q), { class: "bg-default grid grid-cols-10 grid-flow-cols w-full justify-center text-center" }, {
                  default: withCtx(() => [
                    createBaseVNode("div", {
                      name: "pool-chevron",
                      class: "py-1 mt-1 mr-2 col-span-1 ml-4 justify-self-start",
                      title: unref(poolData)[props.poolIdx].name
                    }, [
                      createVNode(unref(render$1), {
                        class: normalizeClass(["-mt-2 h-10 w-10 text-default transition-all duration-200 transform", { "rotate-90": !open, "rotate-180": open }])
                      }, null, 8, ["class"])
                    ], 8, _hoisted_3$1),
                    createBaseVNode("div", {
                      name: "pool-name",
                      class: normalizeClass(["py-1 mt-1 col-span-1 justify-start text-left flex flex-row", unref(truncateText)]),
                      title: unref(poolData)[props.poolIdx].name
                    }, [
                      createTextVNode(toDisplayString(unref(poolData)[props.poolIdx].name) + " ", 1),
                      upgradeablePool.value ? (openBlock(), createElementBlock("div", _hoisted_5$1, [
                        createVNode(unref(render$2), { class: "ml-2 w-5 text-orange-700" })
                      ])) : createCommentVNode("", true)
                    ], 10, _hoisted_4$1),
                    createBaseVNode("div", {
                      name: "pool-status",
                      class: normalizeClass(["py-1 mt-1 col-span-1 font-semibold", [unref(formatStatus)(unref(poolData)[props.poolIdx].status), unref(truncateText)]]),
                      title: unref(poolData)[props.poolIdx].status
                    }, toDisplayString(unref(poolData)[props.poolIdx].status), 11, _hoisted_6$1),
                    createBaseVNode("div", _hoisted_7$1, [
                      createBaseVNode("div", {
                        class: "w-full bg-well rounded-full text-center",
                        title: unref(poolData)[props.poolIdx].properties.capacity + "%"
                      }, [
                        props.pool.properties.refreservationPercent ? (openBlock(), createElementBlock("div", _hoisted_9$1, [
                          createBaseVNode("div", _hoisted_10$1, [
                            createBaseVNode("div", {
                              class: normalizeClass([capacityColor.value, "h-4"]),
                              style: normalizeStyle({ width: `${props.pool.properties.capacity}%` })
                            }, [
                              createBaseVNode("div", _hoisted_11$1, toDisplayString(props.pool.properties.capacity) + "% ", 1)
                            ], 6)
                          ])
                        ])) : (openBlock(), createElementBlock("div", _hoisted_12$1, [
                          createBaseVNode("div", _hoisted_13$1, [
                            createBaseVNode("div", {
                              class: normalizeClass([capacityColor.value, "h-4"]),
                              style: normalizeStyle({ width: `${props.pool.properties.capacity}%` })
                            }, [
                              createBaseVNode("div", _hoisted_14$1, toDisplayString(props.pool.properties.capacity) + "% ", 1)
                            ], 6)
                          ])
                        ]))
                      ], 8, _hoisted_8$1)
                    ]),
                    createBaseVNode("div", {
                      name: "pool-used",
                      class: normalizeClass(["py-1 mt-1 col-span-1", unref(truncateText)]),
                      title: unref(poolData)[props.poolIdx].properties.allocated
                    }, toDisplayString(unref(poolData)[props.poolIdx].properties.allocated), 11, _hoisted_15$1),
                    createBaseVNode("div", {
                      name: "pool-available",
                      class: normalizeClass(["py-1 mt-1 col-span-1", unref(truncateText)]),
                      title: unref(poolData)[props.poolIdx].properties.available.toString()
                    }, toDisplayString(unref(poolData)[props.poolIdx].properties.available), 11, _hoisted_16$1),
                    createBaseVNode("div", {
                      name: "pool-total",
                      class: normalizeClass(["py-1 mt-1 col-span-1", unref(truncateText)]),
                      title: unref(poolData)[props.poolIdx].properties.size
                    }, toDisplayString(unref(poolData)[props.poolIdx].properties.size), 11, _hoisted_17),
                    createBaseVNode("div", _hoisted_18, [
                      createVNode(_sfc_main$4, {
                        pool: unref(poolData)[props.poolIdx],
                        isDisk: false,
                        isTrim: false,
                        isPoolList: true,
                        isPoolDetail: false,
                        idKey: "scan-status-box",
                        ref_key: "scanStatusBox",
                        ref: scanStatusBox
                      }, null, 8, ["pool"])
                    ]),
                    createBaseVNode("div", _hoisted_19, [
                      createVNode(unref(ge), {
                        as: "div",
                        class: "relative inline-block text-right -mt-1"
                      }, {
                        default: withCtx(() => [
                          createBaseVNode("div", null, [
                            createVNode(unref(Se), {
                              onClick: _cache[0] || (_cache[0] = withModifiers(() => {
                              }, ["stop"])),
                              class: "flex items-center rounded-full bg-default p-2 hover:text-default focus:outline-none focus:ring-2 focus:ring-slate-500 focus:ring-offset-2 focus:ring-offset-gray-100"
                            }, {
                              default: withCtx(() => [
                                _cache[18] || (_cache[18] = createBaseVNode("span", { class: "sr-only" }, "Open options", -1)),
                                createVNode(unref(render), {
                                  class: "w-5",
                                  "aria-hidden": "true"
                                })
                              ]),
                              _: 1
                            })
                          ]),
                          createVNode(Transition, {
                            "enter-active-class": "transition ease-out duration-100",
                            "enter-from-class": "transform opacity-0 scale-95",
                            "enter-to-class": "transform opacity-100 scale-100",
                            "leave-active-class": "transition ease-in duration-75",
                            "leave-from-class": "transform opacity-100 scale-100",
                            "leave-to-class": "transform opacity-0 scale-95"
                          }, {
                            default: withCtx(() => [
                              createVNode(unref(Me), {
                                onClick: _cache[16] || (_cache[16] = withModifiers(() => {
                                }, ["stop"])),
                                class: "absolute right-0 z-10 w-max origin-top-right rounded-md bg-default shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none"
                              }, {
                                default: withCtx(() => [
                                  createBaseVNode("div", _hoisted_20, [
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        createBaseVNode("a", {
                                          href: "#",
                                          onClick: _cache[1] || (_cache[1] = ($event) => showPoolModal(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Pool Details", 2)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        createBaseVNode("a", {
                                          href: "#",
                                          onClick: _cache[2] || (_cache[2] = ($event) => clearPoolErrors(unref(poolData)[props.poolIdx].name)),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Clear Pool Errors", 2)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        upgradeablePool.value ? (openBlock(), createElementBlock("a", {
                                          key: 0,
                                          href: "#",
                                          onClick: _cache[3] || (_cache[3] = ($event) => upgradeThisPool(props.pool)),
                                          class: normalizeClass([active ? "bg-orange-700 text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Upgrade Pool", 2)) : createCommentVNode("", true)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        !scanActivity.value.isActive ? (openBlock(), createElementBlock("a", {
                                          key: 0,
                                          href: "#",
                                          onClick: _cache[4] || (_cache[4] = ($event) => resilverThisPool(props.pool)),
                                          class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Resilver Pool", 2)) : createCommentVNode("", true)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        !scanActivity.value.isActive ? (openBlock(), createElementBlock("a", {
                                          key: 0,
                                          href: "#",
                                          onClick: _cache[5] || (_cache[5] = ($event) => scrubThisPool(props.pool)),
                                          class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Scrub Pool", 2)) : createCommentVNode("", true),
                                        scanActivity.value.isActive && scanActivity.value.isPaused && scanOperation.value == "SCRUB" ? (openBlock(), createElementBlock("a", {
                                          key: 1,
                                          href: "#",
                                          onClick: _cache[6] || (_cache[6] = ($event) => resumeScrub(props.pool)),
                                          class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Resume Scrub", 2)) : createCommentVNode("", true),
                                        scanActivity.value.isActive && !scanActivity.value.isPaused && scanOperation.value == "SCRUB" ? (openBlock(), createElementBlock("a", {
                                          key: 2,
                                          href: "#",
                                          onClick: _cache[7] || (_cache[7] = ($event) => pauseScrub(props.pool)),
                                          class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Pause Scrub", 2)) : createCommentVNode("", true)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        scanActivity.value.isActive && scanOperation.value == "SCRUB" ? (openBlock(), createElementBlock("a", {
                                          key: 0,
                                          href: "#",
                                          onClick: _cache[8] || (_cache[8] = ($event) => stopScrub(props.pool)),
                                          class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Cancel Scrub", 2)) : createCommentVNode("", true)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        !trimActivity.value.isActive && !trimActivity.value.isPaused && unref(poolData)[props.poolIdx].diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                          key: 0,
                                          href: "#",
                                          onClick: _cache[9] || (_cache[9] = ($event) => trimThisPool(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " TRIM Pool", 2)) : createCommentVNode("", true),
                                        trimActivity.value.isPaused && unref(poolData)[props.poolIdx].diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                          key: 1,
                                          href: "#",
                                          onClick: _cache[10] || (_cache[10] = ($event) => resumeTrim(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Resume TRIM (Pool)", 2)) : createCommentVNode("", true),
                                        trimActivity.value.isActive && unref(poolData)[props.poolIdx].diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                          key: 2,
                                          href: "#",
                                          onClick: _cache[11] || (_cache[11] = ($event) => pauseTrim(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Pause TRIM (Pool)", 2)) : createCommentVNode("", true)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        trimActivity.value.isActive || trimActivity.value.isPaused && unref(poolData)[props.poolIdx].diskType != "HDD" && getIsTrimmable() ? (openBlock(), createElementBlock("a", {
                                          key: 0,
                                          href: "#",
                                          onClick: _cache[12] || (_cache[12] = ($event) => stopTrim(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Cancel TRIM (Pool)", 2)) : createCommentVNode("", true)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        createBaseVNode("a", {
                                          href: "#",
                                          onClick: _cache[13] || (_cache[13] = ($event) => showAddVDev(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Add Virtual Device", 2)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        createBaseVNode("a", {
                                          href: "#",
                                          onClick: _cache[14] || (_cache[14] = ($event) => exportThisPool(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-accent text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Export Pool", 2)
                                      ]),
                                      _: 1
                                    }),
                                    createVNode(unref(be), { as: "div" }, {
                                      default: withCtx(({ active }) => [
                                        createBaseVNode("a", {
                                          href: "#",
                                          onClick: _cache[15] || (_cache[15] = ($event) => destroyPoolAndUpdate(unref(poolData)[props.poolIdx])),
                                          class: normalizeClass([active ? "bg-danger text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                        }, " Destroy Pool", 2)
                                      ]),
                                      _: 1
                                    })
                                  ])
                                ]),
                                _: 1
                              })
                            ]),
                            _: 1
                          })
                        ]),
                        _: 1
                      })
                    ])
                  ]),
                  _: 2
                }, 1024),
                createVNode(unref(V), { class: "" }, {
                  default: withCtx(() => [
                    (openBlock(true), createElementBlock(Fragment, null, renderList(unref(poolData)[props.poolIdx].vdevs, (vDev, vDevIdx) => {
                      return openBlock(), createElementBlock("div", {
                        key: vDevIdx,
                        class: ""
                      }, [
                        createVNode(_sfc_main$2, {
                          pool: unref(poolData)[props.poolIdx],
                          poolIdx: props.poolIdx,
                          vDev,
                          vDevIdx,
                          ref_for: true,
                          ref_key: "vDevElement",
                          ref: vDevElement
                        }, null, 8, ["pool", "poolIdx", "vDev", "vDevIdx"])
                      ]);
                    }), 128))
                  ]),
                  _: 1
                })
              ]),
              _: 1
            })
          ])
        ]),
        showPoolDetails.value ? (openBlock(), createElementBlock("div", _hoisted_21, [
          (openBlock(), createBlock(resolveDynamicComponent(showPoolDetailsComponent.value), {
            showFlag: showPoolDetails.value,
            onClose: updateShowPoolDetails,
            confirm: confirmSavePoolDetails,
            pool: selectedPool.value
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showDeletePoolConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_22, [
          (openBlock(), createBlock(resolveDynamicComponent(confirmDeletePoolComponent.value), {
            showFlag: showDeletePoolConfirm.value,
            onClose: updateShowDestroyPool,
            idKey: "confirm-destroy-pool",
            item: "pool",
            operation: "destroy",
            pool: selectedPool.value,
            confirmOperation: confirmThisDestroy,
            firstOption: "force unmount",
            secondOption: "clear disk labels",
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showResilverModal.value ? (openBlock(), createElementBlock("div", _hoisted_23, [
          (openBlock(), createBlock(resolveDynamicComponent(confirmResilverPoolComponent.value), {
            showFlag: showResilverModal.value,
            onClose: updateShowResilverPool,
            idKey: "confirm-resilver-pool",
            item: "pool",
            operation: "resilver",
            pool: selectedPool.value,
            confirmOperation: confirmThisResilver,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showScrubModal.value ? (openBlock(), createElementBlock("div", _hoisted_24, [
          (openBlock(), createBlock(resolveDynamicComponent(scrubConfirmComponent.value), {
            showFlag: showScrubModal.value,
            onClose: updateShowScrubPool,
            idKey: "confirm-scrub-pool",
            item: "pool",
            operation: "scrub",
            pool: selectedPool.value,
            confirmOperation: confirmThisScrub,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showPauseScrubConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_25, [
          (openBlock(), createBlock(resolveDynamicComponent(scrubPauseConfirmComponent.value), {
            showFlag: showPauseScrubConfirm.value,
            onClose: updateShowPauseScrub,
            idKey: "confirm-pause-scrub",
            item: "pool",
            operation: "pause",
            operation2: "scrub",
            pool: selectedPool.value,
            confirmOperation: confirmPauseThisScrub,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showStopScrubConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_26, [
          (openBlock(), createBlock(resolveDynamicComponent(scrubStopConfirmComponent.value), {
            showFlag: showStopScrubConfirm.value,
            onClose: updateShowStopScrub,
            idKey: "confirm-stop-scrub",
            item: "pool",
            operation: "stop",
            operation2: "scrub",
            pool: selectedPool.value,
            confirmOperation: confirmStopThisScrub,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showTrimModal.value ? (openBlock(), createElementBlock("div", _hoisted_27, [
          (openBlock(), createBlock(resolveDynamicComponent(trimConfirmComponent.value), {
            showFlag: showTrimModal.value,
            onClose: updateShowTrimPool,
            idKey: "confirm-trim-pool",
            item: "pool",
            operation: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmThisTrim,
            firstOption: "secure TRIM",
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showPauseTrimConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_28, [
          (openBlock(), createBlock(resolveDynamicComponent(trimPauseConfirmComponent.value), {
            showFlag: showPauseTrimConfirm.value,
            onClose: updateShowPauseTrim,
            idKey: "confirm-pause-trim",
            item: "pool",
            operation: "pause",
            operation2: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmPauseThisTrim,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showStopTrimConfirm.value ? (openBlock(), createElementBlock("div", _hoisted_29, [
          (openBlock(), createBlock(resolveDynamicComponent(trimStopConfirmComponent.value), {
            showFlag: showStopTrimConfirm.value,
            onClose: updateShowStopTrim,
            idKey: "confirm-stop-trim",
            item: "pool",
            operation: "stop",
            operation2: "trim",
            pool: selectedPool.value,
            confirmOperation: confirmStopThisTrim,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showExportModal.value ? (openBlock(), createElementBlock("div", _hoisted_30, [
          (openBlock(), createBlock(resolveDynamicComponent(exportConfirmComponent.value), {
            showFlag: showExportModal.value,
            onClose: updateShowExportPool,
            idKey: "confirm-export-pool",
            item: "pool",
            operation: "export",
            pool: selectedPool.value,
            confirmOperation: confirmThisExport,
            firstOption: "force unmount",
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true),
        showAddVDevModal.value ? (openBlock(), createElementBlock("div", _hoisted_31, [
          (openBlock(), createBlock(resolveDynamicComponent(showAddVDevComponent.value), {
            onClose: _cache[17] || (_cache[17] = ($event) => showAddVDevModal.value = false),
            idKey: "show-vdev-modal",
            pool: selectedPool.value,
            marginTop: "mt-28"
          }, null, 40, ["pool"]))
        ])) : createCommentVNode("", true),
        showUpgradeModal.value ? (openBlock(), createElementBlock("div", _hoisted_32, [
          (openBlock(), createBlock(resolveDynamicComponent(upgradeConfirmComponent.value), {
            showFlag: showUpgradeModal.value,
            onClose: updateShowUpgradePool,
            idKey: "confirm-upgrade-pool",
            item: "pool",
            operation: "upgrade",
            pool: selectedPool.value,
            confirmOperation: confirmThisUpgrade,
            hasChildren: false
          }, null, 40, ["showFlag", "pool"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
const _hoisted_1 = { class: "inline-block min-w-full min-h-full py-4 align-middle sm:px-4 lg:px-6 overflow-visible bg-accent rounded-md border border-default" };
const _hoisted_2 = { class: "flex bg-well justify-between rounded-md p-2 shadow text-default rounded-b-md ring-1 ring-black ring-opacity-5" };
const _hoisted_3 = { class: "button-group-row justify-end" };
const _hoisted_4 = { class: "mt-4 rounded-md max-w-full" };
const _hoisted_5 = { class: "inline-block min-w-full min-h-full shadow align-middle rounded-md border border-default" };
const _hoisted_6 = { class: "whitespace-nowrap text-ellipsis ring-1 ring-black ring-opacity-5 rounded-md" };
const _hoisted_7 = { class: "min-w-full divide-y divide-default rounded-md" };
const _hoisted_8 = { class: "rounded-md" };
const _hoisted_9 = { class: "bg-well rounded-t-md grid grid-cols-10" };
const _hoisted_10 = { class: "" };
const _hoisted_11 = { class: "border border-collapse border-default" };
const _hoisted_12 = {
  key: 0,
  class: ""
};
const _hoisted_13 = {
  key: 0,
  class: "p-2 flex justify-center bg-default"
};
const _hoisted_14 = {
  key: 1,
  class: "p-2 flex bg-default justify-center"
};
const _hoisted_15 = { key: 0 };
const _hoisted_16 = { key: 1 };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "PoolsList",
  setup(__props) {
    const poolData = inject("pools");
    const diskData = inject("disks");
    const filesystemData = inject("datasets");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    const truncateText = inject("style-truncate-text");
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      diskData.value = [];
      poolData.value = [];
      filesystemData.value = [];
      await loadDisksThenPools(diskData, poolData);
      await loadDatasets(filesystemData);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(poolData, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(poolData, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
      console.log("PoolList trimActivities", trimActivities.value);
    }
    const showNewPoolWizard = ref(false);
    const createPoolComponent = ref();
    const loadCreatePoolComponent = async () => {
      const module = await __vitePreload(() => import("./CreatePool.bb305bf1.js"), true ? ["./CreatePool.bb305bf1.js","./index.6d4442b8.js","./index.4bb2164e.css","./loadImportables.89a51a80.js","./ExclamationTriangleIcon.be4eb01d.js","./disclosure.4723c881.js","./switch.bba63450.js"] : void 0, import.meta.url);
      createPoolComponent.value = module.default;
    };
    async function newPoolWizardBtn() {
      await loadCreatePoolComponent();
      showNewPoolWizard.value = true;
    }
    const showImportModal = ref(false);
    const importPoolComponent = ref();
    const loadImportPoolComponent = async () => {
      const module = await __vitePreload(() => import("./ImportPool.c2e8f090.js"), true ? ["./ImportPool.c2e8f090.js","./index.6d4442b8.js","./index.4bb2164e.css","./LoadingSpinner.vue_vue_type_script_setup_true_lang.0b36469d.js","./loadImportables.89a51a80.js","./switch.bba63450.js"] : void 0, import.meta.url);
      importPoolComponent.value = module.default;
    };
    async function importNewPoolBtn() {
      await loadImportPoolComponent();
      showImportModal.value = true;
    }
    provide("show-wizard", showNewPoolWizard);
    provide("show-import-modal", showImportModal);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createBaseVNode("div", _hoisted_1, [
          createBaseVNode("div", _hoisted_2, [
            createBaseVNode("div", { class: "button-group-row justify-start" }, [
              createBaseVNode("button", {
                id: "createPool",
                class: "btn btn-primary",
                onClick: newPoolWizardBtn
              }, "Create Storage Pool"),
              createBaseVNode("button", {
                id: "importPool",
                class: "btn btn-secondary",
                onClick: importNewPoolBtn
              }, "Import Storage Pool")
            ]),
            createBaseVNode("div", _hoisted_3, [
              createBaseVNode("button", {
                id: "refreshPools",
                class: "btn btn-secondary",
                onClick: refreshAllData
              }, [
                createVNode(unref(render$3), { class: "w-5 h-5 m-1" })
              ])
            ])
          ]),
          createBaseVNode("div", _hoisted_4, [
            createBaseVNode("div", _hoisted_5, [
              createBaseVNode("div", _hoisted_6, [
                createBaseVNode("table", _hoisted_7, [
                  createBaseVNode("thead", _hoisted_8, [
                    createBaseVNode("tr", _hoisted_9, [
                      _cache[1] || (_cache[1] = createBaseVNode("th", { class: "relative py-2 rounded-tl-md col-span-1" }, [
                        createBaseVNode("span", { class: "sr-only" })
                      ], -1)),
                      createBaseVNode("th", {
                        class: normalizeClass(["py-2 font-semibold text-default col-span-1 flex flex-row justify-start", unref(truncateText)]),
                        title: "Name"
                      }, "Name", 2),
                      createBaseVNode("th", {
                        class: normalizeClass(["py-2 font-semibold text-default col-span-1", unref(truncateText)]),
                        title: "Status"
                      }, "Status", 2),
                      createBaseVNode("th", {
                        class: normalizeClass(["py-2 font-semibold text-default col-span-1", unref(truncateText)]),
                        title: "Used (%)"
                      }, "Used (%)", 2),
                      createBaseVNode("th", {
                        class: normalizeClass(["py-2 font-semibold text-default col-span-1", unref(truncateText)]),
                        title: "Used"
                      }, "Used", 2),
                      createBaseVNode("th", {
                        class: normalizeClass(["py-2 font-semibold text-default col-span-1", unref(truncateText)]),
                        title: "Available"
                      }, "Available", 2),
                      createBaseVNode("th", {
                        class: normalizeClass(["py-2 font-semibold text-default col-span-1", unref(truncateText)]),
                        title: "Total"
                      }, "Total", 2),
                      createBaseVNode("th", {
                        class: normalizeClass(["py-2 font-semibold text-default col-span-2", unref(truncateText)]),
                        title: "Message"
                      }, "Message", 2),
                      _cache[2] || (_cache[2] = createBaseVNode("th", { class: "relative py-2 sm:pr-6 lg:pr-8 rounded-tr-md col-span-1" }, [
                        createBaseVNode("span", { class: "sr-only" })
                      ], -1))
                    ])
                  ]),
                  createBaseVNode("tbody", _hoisted_10, [
                    createBaseVNode("tr", _hoisted_11, [
                      unref(poolData).length > 0 && unref(poolsLoaded) == true ? (openBlock(), createElementBlock("div", _hoisted_12, [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(unref(poolData), (pool, poolIdx) => {
                          return openBlock(), createElementBlock("div", {
                            key: poolIdx,
                            class: ""
                          }, [
                            createVNode(_sfc_main$1, {
                              poolIdx,
                              pool
                            }, null, 8, ["poolIdx", "pool"])
                          ]);
                        }), 128))
                      ])) : createCommentVNode("", true)
                    ])
                  ])
                ]),
                unref(poolsLoaded) == false ? (openBlock(), createElementBlock("div", _hoisted_13, [
                  createVNode(_sfc_main$5, {
                    width: "w-10",
                    height: "h-10",
                    baseColor: "text-gray-200",
                    fillColor: "fill-slate-500",
                    class: "font-semibold text-lg my-0.5"
                  })
                ])) : createCommentVNode("", true),
                unref(poolData).length < 1 && unref(poolsLoaded) == true ? (openBlock(), createElementBlock("div", _hoisted_14, _cache[3] || (_cache[3] = [
                  createBaseVNode("span", { class: "font-semibold text-lg my-2" }, "No Pools Found", -1)
                ]))) : createCommentVNode("", true)
              ])
            ])
          ])
        ]),
        showNewPoolWizard.value ? (openBlock(), createElementBlock("div", _hoisted_15, [
          (openBlock(), createBlock(resolveDynamicComponent(createPoolComponent.value), {
            onClose: _cache[0] || (_cache[0] = ($event) => showNewPoolWizard.value = false)
          }, null, 32))
        ])) : createCommentVNode("", true),
        showImportModal.value ? (openBlock(), createElementBlock("div", _hoisted_16, [
          (openBlock(), createBlock(resolveDynamicComponent(importPoolComponent.value), { idKey: "import-pool" }))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
export {
  _sfc_main as default
};
