import { d as defineComponent, i as inject, r as ref, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, C as normalizeClass, D as unref, E as toDisplayString, A as createVNode, ax as withDirectives, y as createElementBlock, a0 as convertRawTimestampToString, aG as vModelText, G as createCommentVNode, Z as createTextVNode, aH as _sfc_main$1, bi as renameSnapshot, p as pushNotification, N as Notification } from "./index.6d4442b8.js";
import { u as ue } from "./switch.bba63450.js";
const _hoisted_1 = { class: "grid grid-cols-1" };
const _hoisted_2 = { class: "mt-2 col-span-1" };
const _hoisted_3 = ["for"];
const _hoisted_4 = ["title"];
const _hoisted_5 = { class: "mt-2 col-span-1" };
const _hoisted_6 = { class: "flex flex-row justify-between" };
const _hoisted_7 = ["for"];
const _hoisted_8 = { class: "mt-2 col-span-1" };
const _hoisted_9 = ["for"];
const _hoisted_10 = ["id", "placeholder"];
const _hoisted_11 = ["id"];
const _hoisted_12 = { class: "mt-2 col-span-1" };
const _hoisted_13 = { class: "flex flex-row justify-between" };
const _hoisted_14 = ["for"];
const _hoisted_15 = { class: "w-full grid grid-rows-2" };
const _hoisted_16 = { class: "w-full row-start-1" };
const _hoisted_17 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_18 = { class: "button-group-row justify-between" };
const _hoisted_19 = ["id"];
const _hoisted_20 = { class: "button-group-row" };
const _hoisted_21 = {
  key: 1,
  disabled: "",
  id: "finish",
  type: "button",
  class: "btn btn-primary object-right justify-end"
};
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "RenameSnapshot",
  props: {
    idKey: {},
    snapshot: {}
  },
  setup(__props) {
    const props = __props;
    const showRenameSnapModal = inject("show-rename-snap-modal");
    const datasets = inject("datasets");
    const truncateText = inject("style-truncate-text");
    const renaming = inject("renaming");
    const confirmRename = inject("confirm-rename");
    const nameFeedback = ref("");
    const parentFS = ref(props.snapshot.dataset);
    const newName = ref("");
    const creationDate = ref(false);
    const renameChildSnaps = ref(false);
    async function renameBtn() {
      if (creationDate.value == true) {
        newName.value = convertRawTimestampToString(props.snapshot.properties.creation.rawTimestamp);
      }
      if (nameCheck(newName.value, parentFS.value)) {
        renaming.value = true;
        try {
          const output = await renameSnapshot(props.snapshot.name, newName.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            renaming.value = false;
            pushNotification(new Notification("Rename Dataset Failed", `${props.snapshot.name} was not renamed: ${errorMessage}`, "error", 5e3));
          } else {
            confirmRename.value = true;
            pushNotification(new Notification("Snapshot Renamed", `Renamed snapshot ${props.snapshot.name} to ${newName.value}.`, "success", 5e3));
            renaming.value = false;
            showRenameSnapModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    }
    const nameCheck = (snapshotName, fileSystemParent) => {
      let result = true;
      nameFeedback.value = "";
      if (!creationDate) {
        if (snapshotName == "") {
          result = false;
          nameFeedback.value = "Name cannot be empty.";
        } else if (!snapshotName.match(/^[a-zA-Z0-9]/)) {
          result = false;
          nameFeedback.value = "Name must begin with alphanumeric characters.";
        } else if (snapshotName.match(/^[ ]/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with whitespace.";
        } else if (snapshotName.match(/[ ]$/)) {
          result = false;
          nameFeedback.value = "Name cannot end with whitespace.";
        } else if (!snapshotName.match(/^[a-zA-Z0-9_.:-]*$/)) {
          result = false;
          nameFeedback.value = "Name contains invalid characters.";
        } else if (snapshotNameExists(snapshotName, fileSystemParent, datasets.value)) {
          result = false;
          nameFeedback.value = `Name already exists in this location: ${fileSystemParent}.`;
        }
      } else {
        if (snapshotNameExists(snapshotName, fileSystemParent, datasets.value)) {
          result = false;
          nameFeedback.value = `Name already exists in this location: ${fileSystemParent}.`;
        }
      }
      return result;
    };
    function snapshotNameExists(snapshotName, fileSystemParent, datasets2) {
      const newParentPath = fileSystemParent;
      for (const dataset of datasets2) {
        const existingParentPath = dataset.parentFS;
        const existingDatasetName = dataset.name.split("/").pop();
        if (existingParentPath === newParentPath && existingDatasetName === snapshotName) {
          return true;
        }
      }
      return false;
    }
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: unref(showRenameSnapModal),
        onClose: _cache[6] || (_cache[6] = ($event) => showRenameSnapModal.value = false),
        marginTop: "mt-28",
        width: "w-4/12",
        minWidth: "min-w-4/12",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[7] || (_cache[7] = [
          createBaseVNode("legend", { class: "flex justify-center" }, "Rename Snapshot", -1)
        ])),
        content: withCtx(() => [
          createBaseVNode("div", _hoisted_1, [
            createBaseVNode("div", _hoisted_2, [
              createBaseVNode("label", {
                for: getIdKey("parent-filesystem"),
                class: "block text-sm font-medium leading-6 text-default"
              }, "Parent File System", 8, _hoisted_3),
              createBaseVNode("p", {
                class: normalizeClass(unref(truncateText)),
                title: props.snapshot.dataset
              }, toDisplayString(props.snapshot.dataset), 11, _hoisted_4)
            ]),
            createBaseVNode("div", _hoisted_5, [
              createBaseVNode("div", _hoisted_6, [
                createBaseVNode("label", {
                  for: getIdKey("set-name-creation-date"),
                  class: "mt-2 mr-2 block text-sm font-medium leading-6 text-default"
                }, "Creation Date", 8, _hoisted_7),
                createVNode(unref(ue), {
                  modelValue: creationDate.value,
                  "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => creationDate.value = $event),
                  id: getIdKey("set-name-creation-date"),
                  class: normalizeClass([creationDate.value ? "bg-primary" : "bg-accent", "mt-2 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[10] || (_cache[10] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([creationDate.value ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([creationDate.value ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[8] || (_cache[8] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([creationDate.value ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[9] || (_cache[9] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ])
            ]),
            createBaseVNode("div", _hoisted_8, [
              createBaseVNode("label", {
                for: getIdKey("new-name"),
                class: "mt-1 block text-sm font-medium leading-6 text-default"
              }, "New Name", 8, _hoisted_9),
              creationDate.value ? withDirectives((openBlock(), createElementBlock("input", {
                key: 0,
                disabled: "",
                id: getIdKey("new-name"),
                type: "text",
                "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => newName.value = $event),
                class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default placeholder:text-muted sm:text-sm sm:leading-6",
                placeholder: `${unref(convertRawTimestampToString)(props.snapshot.properties.creation.rawTimestamp)}`
              }, null, 8, _hoisted_10)), [
                [vModelText, newName.value]
              ]) : withDirectives((openBlock(), createElementBlock("input", {
                key: 1,
                id: getIdKey("new-name"),
                type: "text",
                "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => newName.value = $event),
                class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default placeholder:text-muted sm:text-sm sm:leading-6",
                placeholder: "New Name"
              }, null, 8, _hoisted_11)), [
                [vModelText, newName.value]
              ])
            ]),
            createBaseVNode("div", _hoisted_12, [
              createBaseVNode("div", _hoisted_13, [
                createBaseVNode("label", {
                  for: getIdKey("rename-children"),
                  class: "mt-2 mr-2 block text-sm font-medium leading-6 text-default"
                }, "Rename child snapshots with same name", 8, _hoisted_14),
                createVNode(unref(ue), {
                  modelValue: renameChildSnaps.value,
                  "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => renameChildSnaps.value = $event),
                  id: getIdKey("rename-children"),
                  class: normalizeClass([renameChildSnaps.value ? "bg-primary" : "bg-accent", "mt-2 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[13] || (_cache[13] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([renameChildSnaps.value ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([renameChildSnaps.value ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[11] || (_cache[11] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([renameChildSnaps.value ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[12] || (_cache[12] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ])
            ])
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_15, [
            createBaseVNode("div", _hoisted_16, [
              nameFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_17, toDisplayString(nameFeedback.value), 1)) : createCommentVNode("", true)
            ]),
            createBaseVNode("div", _hoisted_18, [
              createBaseVNode("button", {
                onClick: _cache[4] || (_cache[4] = ($event) => showRenameSnapModal.value = false),
                id: getIdKey("confirm-rename-no"),
                name: "rename-button-no",
                class: "btn btn-secondary object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_19),
              createBaseVNode("div", _hoisted_20, [
                !unref(renaming) ? (openBlock(), createElementBlock("button", {
                  key: 0,
                  id: "rename-snapshot-btn",
                  class: "btn btn-primary object-right justify-end h-fit w-full",
                  onClick: _cache[5] || (_cache[5] = ($event) => renameBtn())
                }, "Rename")) : createCommentVNode("", true),
                unref(renaming) ? (openBlock(), createElementBlock("button", _hoisted_21, _cache[14] || (_cache[14] = [
                  createBaseVNode("svg", {
                    "aria-hidden": "true",
                    role: "status",
                    class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                    viewBox: "0 0 100 101",
                    fill: "none",
                    xmlns: "http://www.w3.org/2000/svg"
                  }, [
                    createBaseVNode("path", {
                      d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                      fill: "currentColor"
                    }),
                    createBaseVNode("path", {
                      d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                      fill: "text-success"
                    })
                  ], -1),
                  createTextVNode(" Renaming... ")
                ]))) : createCommentVNode("", true)
              ])
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
