import { d as defineComponent, i as inject, r as ref, c as computed, x as openBlock, y as createElementBlock, A as createVNode, B as withCtx, z as createBaseVNode, C as normalizeClass, D as unref, E as toDisplayString, ax as withDirectives, aZ as withKeys, aG as vModelText, G as createCommentVNode, aF as vModelSelect, Z as createTextVNode, ay as vModelCheckbox, L as normalizeStyle, aH as _sfc_main$1, Q as createBlock, R as resolveDynamicComponent, O as Fragment, p as pushNotification, N as Notification, bj as sendSnapshot, bk as index, _ as __vitePreload, bl as formatRecentSnaps, bm as getRawTimestampFromString, X as convertTimestampToLocal, a0 as convertRawTimestampToString, bn as doesDatasetExist, bo as doesDatasetHaveSnaps, aW as convertSizeToBytes } from "./index.6d4442b8.js";
const _hoisted_1 = { class: "grid grid-cols-2 justify-between" };
const _hoisted_2 = { class: "mt-2 col-span-1" };
const _hoisted_3 = ["for"];
const _hoisted_4 = ["id", "title"];
const _hoisted_5 = { class: "mt-2 col-span-1 justify-self-center" };
const _hoisted_6 = { class: "mt-2 col-span-2" };
const _hoisted_7 = ["for"];
const _hoisted_8 = ["id"];
const _hoisted_9 = {
  key: 0,
  class: "mt-1 text-sm text-danger"
};
const _hoisted_10 = {
  key: 1,
  class: "mt-1 text-sm text-danger"
};
const _hoisted_11 = {
  key: 2,
  class: "mt-1 text-sm text-muted"
};
const _hoisted_12 = {
  key: 3,
  class: "mt-1 text-sm text-danger"
};
const _hoisted_13 = { class: "mt-2 col-span-2" };
const _hoisted_14 = ["for"];
const _hoisted_15 = ["id"];
const _hoisted_16 = { class: "mt-2 col-span-2" };
const _hoisted_17 = ["for"];
const _hoisted_18 = ["id"];
const _hoisted_19 = { class: "mt-2 col-span-2" };
const _hoisted_20 = ["for"];
const _hoisted_21 = ["id"];
const _hoisted_22 = {
  key: 0,
  class: "mt-2 grid grid-cols-4 gap-2 col-span-2"
};
const _hoisted_23 = { class: "col-span-2 grid grid-cols-2 justify-items-center" };
const _hoisted_24 = ["for"];
const _hoisted_25 = ["id"];
const _hoisted_26 = { class: "col-span-2 grid grid-cols-2 justify-items-center" };
const _hoisted_27 = ["for"];
const _hoisted_28 = ["id"];
const _hoisted_29 = { class: "mt-2 grid grid-flow-col col-span-2" };
const _hoisted_30 = ["for"];
const _hoisted_31 = ["id"];
const _hoisted_32 = ["for"];
const _hoisted_33 = ["id"];
const _hoisted_34 = ["for"];
const _hoisted_35 = ["id"];
const _hoisted_36 = { class: "mt-2 col-span-2" };
const _hoisted_37 = {
  key: 0,
  class: "mt-1 text-sm text-danger"
};
const _hoisted_38 = { class: "button-group-row w-full row-start-2 justify-between mt-2" };
const _hoisted_39 = {
  key: 0,
  class: "min-w-max w-full bg-well rounded-full relative flex h-6 mt-3 min-h-min max-h-max overflow-hidden"
};
const _hoisted_40 = { class: "absolute inset-0 flex items-center justify-center text-s font-medium text-default text-center p-1.5 leading-none" };
const _hoisted_41 = ["id"];
const _hoisted_42 = ["id"];
const _hoisted_43 = ["id"];
const _hoisted_44 = ["id"];
const _hoisted_45 = ["id"];
const _hoisted_46 = { key: 0 };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "SendSnapshot",
  props: {
    idKey: {},
    snapshot: {},
    name: {}
  },
  setup(__props) {
    const { BetterCockpitFile } = index;
    const props = __props;
    const pools = inject("pools");
    const datasets = inject("datasets");
    const snapshots = inject("snapshots");
    const showSendDataset = inject("show-send-dataset");
    const sending = inject("sending");
    const confirmSend = inject("confirm-send-snap");
    const sendName = ref(props.name);
    const secondNameIncremental = ref("");
    const destinationName = ref("");
    const destinationHost = ref("");
    const destinationPort = ref("22");
    const sendCompressed = ref(false);
    const sendRaw = ref(false);
    const sendIncremental = ref(false);
    const forceOverwrite = ref(false);
    const lastCommonSnap = ref();
    const mostRecentLocalDestSnap = ref();
    const mostRecentRemoteDestSnap = ref();
    const mostRecentDestSnapMsg = ref("");
    const invalidConfig = ref(false);
    const invalidConfigMsg = ref("");
    const useForceOverwriteMsg = ref("Use 'Force Overwrite' to force a COMPLETE OVERWRITE of Destination File System - including any Encryption.");
    const invalidFlags = ref(false);
    const invalidFlagMsg = ref("");
    const destinationHostUser = ref("");
    const datasetCheckResult = ref();
    const snapSnips = ref([]);
    const sendProgressData = ref([]);
    const mBufferSize = ref(1);
    const mBufferUnit = ref("G");
    const truncateText = inject("style-truncate-text");
    const invalidDest = ref(false);
    const invalidDestMsg = ref("");
    const showTestSSH = ref(false);
    const testSSHComponent = ref();
    const loadTestSSHComponent = async () => {
      const module = await __vitePreload(() => import("./TestSSHModal.6259923c.js"), true ? ["./TestSSHModal.6259923c.js","./index.6d4442b8.js","./index.4bb2164e.css"] : void 0, import.meta.url);
      testSSHComponent.value = module.default;
    };
    async function showTestSSHModal() {
      await loadTestSSHComponent();
      showTestSSH.value = true;
      console.log("test ssh modal triggered");
    }
    const updateShowTestSSH = (newVal) => {
      showTestSSH.value = newVal;
    };
    const sendingData = ref({
      sendName: sendName.value,
      sendIncName: secondNameIncremental.value,
      recvName: destinationName.value,
      recvHost: destinationHost.value,
      recvPort: destinationPort.value,
      sendOpts: {
        compressed: sendCompressed.value,
        raw: sendRaw.value,
        incremental: sendIncremental.value,
        forceOverwrite: forceOverwrite.value
      },
      recvHostUser: destinationHostUser.value,
      mBufferConfig: {
        size: mBufferSize.value,
        unit: mBufferUnit.value
      }
    });
    function handleCheckboxChange(checkbox) {
      if (checkbox === "sendCompressed" && sendCompressed.value) {
        sendRaw.value = false;
      } else if (checkbox === "sendRaw" && sendRaw.value) {
        sendCompressed.value = false;
      }
    }
    const isSendLocal = computed(() => {
      if (destinationHost.value == "") {
        return true;
      } else {
        return false;
      }
    });
    function doesRecvDatasetExist() {
      try {
        return datasets.value.some((dataset) => dataset.name === sendingData.value.recvName);
      } catch (error) {
        console.error("Error checking dataset:", error);
        return false;
      }
    }
    function isRecvDatasetEncrypted() {
      try {
        console.log("isDatasetEncrypted:", datasets.value.find((dataset) => dataset.name === sendingData.value.recvName).encrypted);
        return datasets.value.find((dataset) => dataset.name === sendingData.value.recvName).encrypted;
      } catch (error) {
        console.error("Error checking dataset:", error);
        return false;
      }
    }
    async function doesRemoteDatasetExist() {
      try {
        return await doesDatasetExist(sendingData.value);
      } catch (error) {
        console.error("Error checking dataset", error);
        return false;
      }
    }
    async function doesRemoteDatasetHaveSnaps() {
      try {
        return await doesDatasetHaveSnaps(sendingData.value);
      } catch (error) {
        console.error("Error checking dataset", error);
        return false;
      }
    }
    function doesPoolExist() {
      try {
        const poolName = sendingData.value.recvName.split("/", 1).shift();
        return pools.value.some((pool) => pool.name === poolName);
      } catch (error) {
        console.error("Error checking pool", error);
      }
    }
    async function setSendData() {
      sendingData.value.sendName = sendName.value;
      if (sendCompressed.value && sendRaw.value) {
        invalidFlags.value = true;
        invalidFlagMsg.value = "Cannot have Compressed and Raw selected at the same time.";
      } else {
        invalidConfig.value = false;
        invalidFlags.value = false;
        const sourceDataset = computed(() => {
          const sourceDatasetName = sendName.value.split("@").shift();
          return datasets.value.find((dataset) => dataset.name == sourceDatasetName);
        });
        sendingData.value.recvName = destinationName.value;
        sendingData.value.recvHost = destinationHost.value;
        if (destinationPort.value != "22") {
          sendingData.value.recvPort = destinationPort.value;
        } else {
          sendingData.value.recvPort = "22";
        }
        if (sourceDataset.value.encrypted) {
          sendRaw.value = true;
          sendCompressed.value = false;
          sendingData.value.sendOpts.raw = true;
          sendingData.value.sendOpts.compressed = false;
        } else {
          sendingData.value.sendOpts.raw = sendRaw.value;
          sendingData.value.sendOpts.compressed = sendCompressed.value;
        }
        sendingData.value.sendOpts.forceOverwrite = forceOverwrite.value;
        sendingData.value.recvHostUser = destinationHostUser.value;
        if (isSendLocal.value) {
          if (doesRecvDatasetExist()) {
            if (!isRecvDatasetEncrypted()) {
              lastCommonSnap.value = await checkForLastCommonSnap();
              console.log("local lastCommonSnap:", lastCommonSnap.value);
              if (lastCommonSnap.value !== null && lastCommonSnap.value !== false) {
                sendIncremental.value = true;
                sendingData.value.sendOpts.incremental = sendIncremental.value;
                sendingData.value.sendIncName = lastCommonSnap.value.name;
                invalidConfig.value = false;
              } else if (lastCommonSnap.value === false) {
                sendIncremental.value = false;
                invalidConfig.value = true;
                invalidConfigMsg.value = "Destination already exists (but has no snapshots).";
              } else {
                sendIncremental.value = false;
                sendingData.value.sendIncName = "";
                invalidConfig.value = true;
                invalidConfigMsg.value = "Destination already exists and has been modified since most recent snapshot.";
                mostRecentDestSnapMsg.value = `Most recent snapshot: ${mostRecentLocalDestSnap.value.name}`;
              }
            } else {
              sendIncremental.value = false;
              sendingData.value.sendIncName = "";
              invalidConfig.value = true;
              invalidConfigMsg.value = "Destination is encrypted.";
            }
          } else {
            if (doesPoolExist()) {
              sendIncremental.value = false;
              sendingData.value.sendIncName = "";
            } else {
              console.error("Pool does not exist");
              invalidDest.value = true;
              invalidDestMsg.value = "Destination pool does not exist.";
            }
          }
        } else {
          datasetCheckResult.value = await doesRemoteDatasetExist();
          if (datasetCheckResult.value) {
            const doesRecvHaveSnaps = await doesRemoteDatasetHaveSnaps();
            console.log("doesRecvHaveSnaps:", doesRecvHaveSnaps);
            if (doesRecvHaveSnaps) {
              lastCommonSnap.value = await checkForLastCommonSnap();
              console.log("remote lastCommonSnap:", lastCommonSnap.value);
              if (lastCommonSnap.value !== null && lastCommonSnap.value !== false) {
                sendIncremental.value = true;
                sendingData.value.sendOpts.incremental = sendIncremental.value;
                sendingData.value.sendIncName = lastCommonSnap.value.name;
                invalidConfig.value = false;
              } else if (lastCommonSnap.value === false) {
                sendIncremental.value = false;
                invalidConfig.value = true;
                invalidConfigMsg.value = "Remote destination already exists (but has no snapshots).";
              } else {
                sendIncremental.value = false;
                sendingData.value.sendIncName = "";
                invalidConfig.value = true;
                invalidConfigMsg.value = "Remote destination already exists and has been modified since most recent snapshot.";
                mostRecentDestSnapMsg.value = `Most recent remote snapshot: ${mostRecentRemoteDestSnap.value.name}`;
              }
            } else {
              sendIncremental.value = false;
              sendingData.value.sendIncName = "";
              invalidConfig.value = true;
              invalidConfigMsg.value = "Remote destination already exists.";
            }
          } else {
            sendIncremental.value = false;
            sendingData.value.sendIncName = "";
          }
          sendingData.value.mBufferConfig.size = mBufferSize.value;
          sendingData.value.mBufferConfig.unit = mBufferUnit.value;
        }
      }
    }
    async function checkForLastCommonSnap() {
      try {
        const sortedSnapshots = computed(() => {
          return snapshots.value.sort((a, b) => {
            return b.creationTimestamp.localeCompare(a.creationTimestamp);
          });
        });
        console.log("sortedSnapshots:", sortedSnapshots.value);
        const sourceDataset = computed(() => {
          return sendName.value.split("@").shift();
        });
        console.log("sourceDataset:", sourceDataset.value);
        const sourceDatasetSnaps = computed(() => {
          return sortedSnapshots.value.filter((snapshot) => snapshot.dataset == sourceDataset.value);
        });
        console.log("sourceDatasetSnaps:", sourceDatasetSnaps.value);
        const sourceSnap = computed(() => {
          return sourceDatasetSnaps.value.find((snap) => snap.name == sendName.value);
        });
        console.log("sourceSnap:", sourceSnap.value);
        if (isSendLocal.value) {
          const destinationDatasetSnaps = computed(() => {
            return sortedSnapshots.value.filter((snapshot) => snapshot.dataset == destinationName.value);
          });
          console.log("destinationDatasetSnaps:", destinationDatasetSnaps.value);
          if (destinationDatasetSnaps.value.length === 0) {
            console.log("No destination dataset snapshots found.");
            return false;
          }
          return compareLocalTimestamp(destinationDatasetSnaps.value, sourceDatasetSnaps.value, sourceSnap.value);
        } else {
          await formatRecentSnaps(sendingData.value, snapSnips.value);
          if (snapSnips.value.length === 0) {
            console.log("No destination dataset snapshots found.");
            return false;
          }
          return compareRemoteTimestamp(snapSnips.value, sourceDatasetSnaps.value, sourceSnap.value);
        }
      } catch (error) {
        console.error("Error checking snapshot", error);
        return null;
      }
    }
    function compareLocalTimestamp(destinationDatasetSnaps, sourceDatasetSnaps, sourceSendSnap) {
      mostRecentLocalDestSnap.value = destinationDatasetSnaps[0];
      console.log("local mostRecentLocalDestSnap:", mostRecentLocalDestSnap.value);
      if (mostRecentLocalDestSnap.value.creationTimestamp) {
        console.log("local sourceSendSnap.creationTimestamp:", sourceSendSnap.creationTimestamp);
        if (sourceSendSnap.creationTimestamp) {
          if (Number(mostRecentLocalDestSnap.value.creationTimestamp) < Number(sourceSendSnap.creationTimestamp)) {
            const sourceSnapMatch = computed(() => {
              return sourceDatasetSnaps.find((snap) => snap.guid == mostRecentLocalDestSnap.value.guid);
            });
            console.log("local sourceSnapMatch:", sourceSnapMatch.value);
            return sourceSnapMatch.value;
          } else if (mostRecentLocalDestSnap.value.guid == sourceSendSnap.guid) {
            console.log("sendSnap is the same as mostRecentDestSnap");
            return null;
          } else {
            console.log("invalid local lastCommonSnap match");
            return null;
          }
        }
      } else {
        console.log("no snaps to match");
        return null;
      }
    }
    async function compareRemoteTimestamp(snapSnips2, sourceDatasetSnaps, sourceSendSnap) {
      console.log("snapSnips", snapSnips2);
      if (snapSnips2[0]) {
        mostRecentRemoteDestSnap.value = snapSnips2[0];
        console.log("remote mostRecentRemoteDestSnap:", mostRecentRemoteDestSnap.value);
        console.log("mostRecentRemoteDestSnap.value.creation", Number(getRawTimestampFromString(mostRecentRemoteDestSnap.value.creation)));
        console.log("sourceSendSnap.creationTimestamp", Number(getRawTimestampFromString(convertTimestampToLocal(convertRawTimestampToString(sourceSendSnap.creationTimestamp)))));
        if (mostRecentRemoteDestSnap.value.guid == sourceSendSnap.guid) {
          console.log("sendSnap is the same as mostRecentDestSnap");
          return null;
        } else {
          console.log("comparing snap timestamps:", Number(getRawTimestampFromString(mostRecentRemoteDestSnap.value.creation)) < Number(getRawTimestampFromString(convertTimestampToLocal(convertRawTimestampToString(sourceSendSnap.creationTimestamp)))));
          if (Number(getRawTimestampFromString(mostRecentRemoteDestSnap.value.creation)) < Number(getRawTimestampFromString(convertTimestampToLocal(convertRawTimestampToString(sourceSendSnap.creationTimestamp))))) {
            const sourceSnapMatch = computed(() => {
              const source = sourceDatasetSnaps.find((snap) => snap.guid == mostRecentRemoteDestSnap.value.guid);
              console.log("source", source);
              return source;
            });
            console.log("remote sourceSnapMatch:", sourceSnapMatch.value);
            if (sourceSnapMatch.value == void 0) {
              return null;
            } else {
              return sourceSnapMatch.value;
            }
          } else {
            console.log("invalid remote lastCommonSnap match");
            return null;
          }
        }
      } else {
        console.log("No snap snips to compare");
        return null;
      }
    }
    async function sendBtn() {
      try {
        await setSendData();
        console.log("Sending data:", sendingData.value);
        if (invalidConfig.value || invalidFlags.value || invalidDest.value) {
          if (invalidConfig.value && forceOverwrite.value) {
            await handleSendWithOverwrite();
          } else {
            confirmSend.value = false;
            return;
          }
        } else {
          await handleSend();
        }
      } catch (error) {
        console.error("Error occurred during snapshot send:", error);
        pushNotification(new Notification(
          "Failed Snapshot Send",
          `Failed to send snapshot ${props.snapshot.name} to ${sendingData.value.recvName}: ${error.message}`,
          "error",
          5e3
        ));
      }
    }
    async function handleSend() {
      sending.value = true;
      try {
        await sendAndReadProgress(sendingData.value, sendProgressData.value);
        pushNotification(new Notification(
          "Snapshot Sent",
          `Sent snapshot ${props.snapshot.name} to ${sendingData.value.recvName}.`,
          "success",
          5e3
        ));
        confirmSend.value = true;
        showSendDataset.value = false;
      } finally {
        sending.value = false;
        tracking.value = false;
      }
    }
    async function handleSendWithOverwrite() {
      sending.value = true;
      try {
        invalidConfig.value = false;
        await sendAndReadProgress(sendingData.value, sendProgressData.value);
        pushNotification(new Notification(
          "Snapshot Sent",
          `Sent snapshot ${props.snapshot.name} to ${sendingData.value.recvName} with overwrite.`,
          "success",
          5e3
        ));
        confirmSend.value = true;
        showSendDataset.value = false;
      } finally {
        sending.value = false;
        tracking.value = false;
      }
    }
    const totalSendSize = ref(0);
    const sendProgressAmount = ref(0);
    const tracking = ref(false);
    function getTotalSendSize(contentTotal) {
      return convertSizeToBytes(contentTotal);
    }
    function getSendProgress(contentProgress) {
      return convertSizeToBytes(contentProgress);
    }
    const sendPercentage = computed(() => {
      if (!tracking.value) {
        return 0;
      } else {
        return sendProgressAmount.value / totalSendSize.value * 100;
      }
    });
    async function readSendProgress(sendProgressData2, fileReader) {
      try {
        let fillProgressArray = function(content, sendProgressData3) {
          if (initialRun && nullRun) {
            initialRun = false;
          } else if (!initialRun && nullRun) {
            nullRun = false;
          } else {
            tracking.value = true;
            if (content == null) {
              console.log("error: content null, send data too small to track");
            } else {
              sendProgressData3.push(content);
              totalSendSize.value = getTotalSendSize(content.totalSize);
              sendProgressAmount.value = getSendProgress(content.sent);
              console.log(`content.totalSize: ${content.totalSize}, content.sent: ${content.sent}`);
              console.log(`totalSendSize: ${totalSendSize.value}, sendProgAmount: ${sendProgressAmount.value}`);
            }
          }
        };
        let initialRun = true;
        let nullRun = true;
        fileReader.watch((content) => {
          fillProgressArray(content, sendProgressData2);
          console.log("fileReaderContent:", content);
        }, {});
      } catch (error) {
        console.error("An error occurred loading send progress:", error);
        return null;
      }
    }
    async function sendAndReadProgress(sendingData2, sendProgress) {
      try {
        const fileReader = new BetterCockpitFile("/run/user/0/full_output.json", { syntax: JSON });
        const [snapshotResult, sendProgressData2] = await Promise.all([
          sendSnapshot(sendingData2),
          readSendProgress(sendProgress, fileReader)
        ]);
        console.log("Progress data:", sendProgress);
        console.log("Sent snapshot result:", snapshotResult);
        fileReader.close();
      } catch (error) {
        console.error("An error occurred in sendAndReadProgress:", error);
      }
    }
    const getIdKey = (name) => `${props.idKey}-${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createVNode(_sfc_main$1, {
          isOpen: unref(showSendDataset),
          onClose: _cache[22] || (_cache[22] = ($event) => showSendDataset.value = false),
          marginTop: "mt-28",
          width: "w-5/12",
          minWidth: "min-w-5/12",
          closeOnBackgroundClick: false
        }, {
          title: withCtx(() => _cache[23] || (_cache[23] = [
            createBaseVNode("legend", { class: "flex justify-center" }, "Send Dataset", -1)
          ])),
          content: withCtx(() => [
            createBaseVNode("div", _hoisted_1, [
              createBaseVNode("div", _hoisted_2, [
                createBaseVNode("label", {
                  for: getIdKey("sending-dataset-name"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default"
                }, "Snapshot To Send:", 8, _hoisted_3),
                createBaseVNode("label", {
                  id: getIdKey("sending-dataset-name"),
                  class: normalizeClass(["mt-1 block text-sm font-base leading-6 text-default", unref(truncateText)]),
                  title: sendName.value
                }, toDisplayString(sendName.value), 11, _hoisted_4)
              ]),
              createBaseVNode("div", _hoisted_5, [
                createBaseVNode("button", {
                  id: "test-ssh",
                  class: "mt-3 btn btn-secondary h-fit",
                  onClick: _cache[0] || (_cache[0] = ($event) => showTestSSHModal())
                }, "Test Passwordless SSH")
              ]),
              createBaseVNode("div", _hoisted_6, [
                createBaseVNode("label", {
                  for: getIdKey("receiving-dataset-name"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default"
                }, "Receiving Dataset:", 8, _hoisted_7),
                withDirectives(createBaseVNode("input", {
                  onKeydown: _cache[1] || (_cache[1] = withKeys(() => {
                  }, ["enter"])),
                  onChange: _cache[2] || (_cache[2] = ($event) => doesRecvDatasetExist()),
                  id: getIdKey("receiving-dataset-name"),
                  type: "text",
                  class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default",
                  name: "receiving-dataset-name",
                  "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => destinationName.value = $event),
                  placeholder: "Destination Name Here"
                }, null, 40, _hoisted_8), [
                  [vModelText, destinationName.value]
                ]),
                invalidConfig.value ? (openBlock(), createElementBlock("p", _hoisted_9, toDisplayString(invalidConfigMsg.value), 1)) : createCommentVNode("", true),
                invalidDest.value ? (openBlock(), createElementBlock("p", _hoisted_10, toDisplayString(invalidDestMsg.value), 1)) : createCommentVNode("", true),
                invalidConfig.value ? (openBlock(), createElementBlock("p", _hoisted_11, [
                  createBaseVNode("i", null, toDisplayString(mostRecentDestSnapMsg.value), 1)
                ])) : createCommentVNode("", true),
                invalidConfig.value ? (openBlock(), createElementBlock("p", _hoisted_12, toDisplayString(useForceOverwriteMsg.value), 1)) : createCommentVNode("", true)
              ]),
              createBaseVNode("div", _hoisted_13, [
                createBaseVNode("label", {
                  for: getIdKey("receiving-host-name"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default"
                }, "Receiving Host:", 8, _hoisted_14),
                withDirectives(createBaseVNode("input", {
                  onKeydown: _cache[4] || (_cache[4] = withKeys(() => {
                  }, ["enter"])),
                  id: getIdKey("receiving-host-name"),
                  type: "text",
                  class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default",
                  name: "receiving-host-name",
                  "onUpdate:modelValue": _cache[5] || (_cache[5] = ($event) => destinationHost.value = $event),
                  placeholder: "(Leave empty if sending locally.)"
                }, null, 40, _hoisted_15), [
                  [vModelText, destinationHost.value]
                ])
              ]),
              createBaseVNode("div", _hoisted_16, [
                createBaseVNode("label", {
                  for: getIdKey("receiving-host-user"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default"
                }, "Receiving User:", 8, _hoisted_17),
                withDirectives(createBaseVNode("input", {
                  onKeydown: _cache[6] || (_cache[6] = withKeys(() => {
                  }, ["enter"])),
                  id: getIdKey("receiving-host-user"),
                  type: "text",
                  class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default",
                  name: "receiving-host-user",
                  "onUpdate:modelValue": _cache[7] || (_cache[7] = ($event) => destinationHostUser.value = $event),
                  placeholder: "Destination Host User"
                }, null, 40, _hoisted_18), [
                  [vModelText, destinationHostUser.value]
                ])
              ]),
              createBaseVNode("div", _hoisted_19, [
                createBaseVNode("label", {
                  for: getIdKey("receiving-port"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default"
                }, "Receiving Port:", 8, _hoisted_20),
                withDirectives(createBaseVNode("input", {
                  onKeydown: _cache[8] || (_cache[8] = withKeys(() => {
                  }, ["enter"])),
                  id: getIdKey("receiving-port"),
                  type: "text",
                  class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default",
                  name: "receiving-port",
                  "onUpdate:modelValue": _cache[9] || (_cache[9] = ($event) => destinationPort.value = $event)
                }, null, 40, _hoisted_21), [
                  [vModelText, destinationPort.value]
                ])
              ]),
              destinationHost.value != "" ? (openBlock(), createElementBlock("div", _hoisted_22, [
                createBaseVNode("div", _hoisted_23, [
                  createBaseVNode("label", {
                    for: getIdKey("mbuffer-size"),
                    class: "mt-1 text-sm font-medium leading-6 text-default w-full col-span-1"
                  }, "mBuffer Size:", 8, _hoisted_24),
                  withDirectives(createBaseVNode("input", {
                    onKeydown: _cache[10] || (_cache[10] = withKeys(() => {
                    }, ["enter"])),
                    id: getIdKey("mbuffer-size"),
                    type: "number",
                    class: "input-textlike bg-default mt-1 w-full py-1.5 px-1.5 text-default col-span-1",
                    name: "mbuffer-size",
                    "onUpdate:modelValue": _cache[11] || (_cache[11] = ($event) => mBufferSize.value = $event)
                  }, null, 40, _hoisted_25), [
                    [vModelText, mBufferSize.value]
                  ])
                ]),
                createBaseVNode("div", _hoisted_26, [
                  createBaseVNode("label", {
                    for: getIdKey("mbuffer-unit"),
                    class: "mt-1 text-sm font-medium leading-6 text-default w-full col-span-1"
                  }, "mBuffer Unit:", 8, _hoisted_27),
                  withDirectives(createBaseVNode("select", {
                    id: getIdKey("mbuffer-unit"),
                    name: "mbuffer-unit",
                    class: "text-default bg-default mt-1 w-full input-textlike col-span-1",
                    "onUpdate:modelValue": _cache[12] || (_cache[12] = ($event) => mBufferUnit.value = $event)
                  }, _cache[24] || (_cache[24] = [
                    createBaseVNode("option", { value: "b" }, "b", -1),
                    createBaseVNode("option", { value: "k" }, "k", -1),
                    createBaseVNode("option", { value: "M" }, "M", -1),
                    createBaseVNode("option", { value: "G" }, "G", -1)
                  ]), 8, _hoisted_28), [
                    [vModelSelect, mBufferUnit.value]
                  ])
                ])
              ])) : createCommentVNode("", true),
              createBaseVNode("div", _hoisted_29, [
                createBaseVNode("label", {
                  for: getIdKey("send-compressed-toggle"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default col-span-1"
                }, [
                  _cache[25] || (_cache[25] = createTextVNode(" Send Compressed: ")),
                  withDirectives(createBaseVNode("input", {
                    id: getIdKey("send-compressed-toggle"),
                    "onUpdate:modelValue": _cache[13] || (_cache[13] = ($event) => sendCompressed.value = $event),
                    onChange: _cache[14] || (_cache[14] = ($event) => handleCheckboxChange("sendCompressed")),
                    type: "checkbox",
                    class: "ml-2 w-5 h-5 text-success bg-well border-default rounded focus:ring-green-500 dark:focus:ring-green-600 dark:ring-offset-gray-800 focus:ring-2"
                  }, null, 40, _hoisted_31), [
                    [vModelCheckbox, sendCompressed.value]
                  ])
                ], 8, _hoisted_30),
                createBaseVNode("label", {
                  for: getIdKey("send-raw-toggle"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default col-span-1"
                }, [
                  _cache[26] || (_cache[26] = createTextVNode(" Send Raw: ")),
                  withDirectives(createBaseVNode("input", {
                    id: getIdKey("send-raw-toggle"),
                    "onUpdate:modelValue": _cache[15] || (_cache[15] = ($event) => sendRaw.value = $event),
                    onChange: _cache[16] || (_cache[16] = ($event) => handleCheckboxChange("sendRaw")),
                    type: "checkbox",
                    class: "ml-2 w-5 h-5 text-success bg-well border-default rounded focus:ring-green-500 dark:focus:ring-green-600 dark:ring-offset-gray-800 focus:ring-2"
                  }, null, 40, _hoisted_33), [
                    [vModelCheckbox, sendRaw.value]
                  ])
                ], 8, _hoisted_32),
                invalidConfig.value ? (openBlock(), createElementBlock("label", {
                  key: 0,
                  for: getIdKey("force-overwrite-toggle"),
                  class: "mt-1 block text-sm font-medium leading-6 text-danger col-span-1"
                }, [
                  _cache[27] || (_cache[27] = createTextVNode(" Force Overwrite: ")),
                  withDirectives(createBaseVNode("input", {
                    id: getIdKey("force-overwrite-toggle"),
                    "onUpdate:modelValue": _cache[17] || (_cache[17] = ($event) => forceOverwrite.value = $event),
                    type: "checkbox",
                    class: "ml-2 w-5 h-5 text-success bg-well border-default rounded focus:ring-green-500 dark:focus:ring-green-600 dark:ring-offset-gray-800 focus:ring-2"
                  }, null, 8, _hoisted_35), [
                    [vModelCheckbox, forceOverwrite.value]
                  ])
                ], 8, _hoisted_34)) : createCommentVNode("", true)
              ]),
              createBaseVNode("div", _hoisted_36, [
                invalidFlags.value ? (openBlock(), createElementBlock("p", _hoisted_37, toDisplayString(invalidFlagMsg.value), 1)) : createCommentVNode("", true)
              ])
            ])
          ]),
          footer: withCtx(() => [
            createBaseVNode("div", _hoisted_38, [
              createBaseVNode("button", {
                id: "cancel",
                class: "mt-1 btn btn-danger object-left justify-start h-fit",
                onClick: _cache[18] || (_cache[18] = ($event) => showSendDataset.value = false)
              }, "Cancel"),
              unref(sending) ? (openBlock(), createElementBlock("div", _hoisted_39, [
                tracking.value ? (openBlock(), createElementBlock("div", {
                  key: 0,
                  class: "h-6 min-h-min max-h-max bg-green-600",
                  style: normalizeStyle({ width: `${sendPercentage.value.toFixed(2)}%` })
                }, [
                  createBaseVNode("div", _hoisted_40, toDisplayString(sendPercentage.value.toFixed(2)) + "% ", 1)
                ], 4)) : createCommentVNode("", true)
              ])) : createCommentVNode("", true),
              !unref(sending) && !invalidConfig.value ? (openBlock(), createElementBlock("button", {
                key: 1,
                onClick: _cache[19] || (_cache[19] = ($event) => sendBtn()),
                id: getIdKey("send-btn1"),
                name: "send-btn1",
                class: "mt-1 btn btn-primary object-right justify-end h-fit"
              }, "Send", 8, _hoisted_41)) : createCommentVNode("", true),
              !unref(sending) && invalidConfig.value && !forceOverwrite.value ? (openBlock(), createElementBlock("button", {
                key: 2,
                disabled: "",
                onClick: _cache[20] || (_cache[20] = ($event) => sendBtn()),
                id: getIdKey("send-btn2"),
                name: "send-btn2",
                class: "mt-1 btn btn-primary object-right justify-end h-fit"
              }, "Send", 8, _hoisted_42)) : createCommentVNode("", true),
              !unref(sending) && invalidConfig.value && forceOverwrite.value ? (openBlock(), createElementBlock("button", {
                key: 3,
                onClick: _cache[21] || (_cache[21] = ($event) => sendBtn()),
                id: getIdKey("send-btn3"),
                name: "send-btn3",
                class: "mt-1 btn btn-primary object-right justify-end h-fit"
              }, "Send", 8, _hoisted_43)) : createCommentVNode("", true),
              unref(sending) && !forceOverwrite.value ? (openBlock(), createElementBlock("button", {
                key: 4,
                disabled: "",
                id: getIdKey("sending-progress"),
                type: "button",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, " Sending... ", 8, _hoisted_44)) : createCommentVNode("", true),
              unref(sending) && forceOverwrite.value ? (openBlock(), createElementBlock("button", {
                key: 5,
                disabled: "",
                id: getIdKey("overwriting-progress"),
                type: "button",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, " Overwriting... ", 8, _hoisted_45)) : createCommentVNode("", true)
            ])
          ]),
          _: 1
        }, 8, ["isOpen"]),
        showTestSSH.value ? (openBlock(), createElementBlock("div", _hoisted_46, [
          (openBlock(), createBlock(resolveDynamicComponent(testSSHComponent.value), {
            onClose: updateShowTestSSH,
            idKey: "test-ssh-modal",
            showFlag: showTestSSH.value
          }, null, 40, ["showFlag"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
export {
  _sfc_main as default
};
