import { d as defineComponent, r as ref, i as inject, c as computed, w as watch, X as convertTimestampToLocal, V as convertBytesToSize, Y as convertSecondsToString, o as onMounted, x as openBlock, y as createElementBlock, z as createBaseVNode, C as normalizeClass, E as toDisplayString, D as unref, L as normalizeStyle, Z as createTextVNode, G as createCommentVNode, O as Fragment, P as renderList, $ as upperCaseWord, b as loadScanObjectGroup, f as loadDiskStats, a0 as convertRawTimestampToString } from "./index.6d4442b8.js";
const _hoisted_1 = { key: 0 };
const _hoisted_2 = { key: 0 };
const _hoisted_3 = { key: 0 };
const _hoisted_4 = { class: "grid grid-cols-4 gap-1 justify-items-center w-full" };
const _hoisted_5 = { class: "col-span-4" };
const _hoisted_6 = {
  key: 0,
  class: "col-span-4 grid grid-cols-4 justify-items-center w-full"
};
const _hoisted_7 = { class: "col-span-4 w-full bg-well rounded-full relative flex h-6 min-h-min overflow-hidden" };
const _hoisted_8 = { class: "absolute inset-0 flex items-center justify-center text-s font-medium text-white text-center p-1.5 leading-none" };
const _hoisted_9 = { class: "text-muted col-span-4" };
const _hoisted_10 = {
  key: 0,
  class: "col-span-4"
};
const _hoisted_11 = {
  key: 1,
  class: "col-span-4"
};
const _hoisted_12 = { key: 1 };
const _hoisted_13 = { class: "grid grid-cols-4 gap-1 justify-items-center w-full" };
const _hoisted_14 = {
  key: 0,
  class: "col-span-4"
};
const _hoisted_15 = {
  key: 0,
  class: "col-span-4"
};
const _hoisted_16 = { class: "grid grid-cols-4 justify-items-center w-full whitespace-nowrap text-ellipsis" };
const _hoisted_17 = ["title"];
const _hoisted_18 = { class: "col-span-4" };
const _hoisted_19 = { class: "col-span-4 grid grid-cols-4 justify-items-center w-full" };
const _hoisted_20 = { class: "col-span-4 w-full bg-well rounded-full relative flex h-6 min-h-min overflow-hidden" };
const _hoisted_21 = { class: "absolute inset-0 flex items-center justify-center text-s font-medium text-default text-center p-1.5 leading-none" };
const _hoisted_22 = { class: "text-muted col-span-4" };
const _hoisted_23 = {
  key: 1,
  class: "col-span-4"
};
const _hoisted_24 = ["title"];
const _hoisted_25 = {
  key: 0,
  class: "col-span-4"
};
const _hoisted_26 = { class: "" };
const _hoisted_27 = { class: "text-default col-span-4" };
const _hoisted_28 = ["title"];
const _hoisted_29 = {
  key: 1,
  class: "col-span-4"
};
const _hoisted_30 = { key: 1 };
const _hoisted_31 = { class: "grid grid-cols-2 gap-1 justify-center items-center" };
const _hoisted_32 = {
  key: 0,
  class: "col-span-2"
};
const _hoisted_33 = ["title"];
const _hoisted_34 = { class: "min-w-max w-full bg-well rounded-full relative flex h-3 min-h-min max-h-max overflow-hidden" };
const _hoisted_35 = { class: "absolute inset-0 flex items-center justify-center text-xs font-medium text-white text-center p-0.5 leading-none" };
const _hoisted_36 = ["title"];
const _hoisted_37 = { key: 1 };
const _hoisted_38 = {
  key: 0,
  class: "grid grid-cols-2 gap-1 justify-center items-center"
};
const _hoisted_39 = {
  key: 0,
  class: "col-span-2 flex flex-col items-center justify-center"
};
const _hoisted_40 = {
  key: 2,
  class: "min-w-max w-full bg-well rounded-full relative flex h-3 min-h-min max-h-max overflow-hidden"
};
const _hoisted_41 = { class: "absolute inset-0 flex items-center justify-center text-xs font-medium text-default text-center p-0.5 leading-none" };
const _hoisted_42 = {
  key: 1,
  class: "col-span-2 flex items-center justify-center mt-2"
};
const _hoisted_43 = {
  key: 2,
  class: "col-span-2 flex items-center justify-center mt-2"
};
const _hoisted_44 = {
  key: 1,
  class: "col-span-2 flex items-center justify-center mt-2"
};
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "Status",
  props: {
    pool: {},
    disk: {},
    isPoolList: { type: Boolean },
    isPoolDetail: { type: Boolean },
    isDisk: { type: Boolean },
    isTrim: { type: Boolean },
    isTrimmableDisk: { type: Boolean }
  },
  setup(__props, { expose: __expose }) {
    const props = __props;
    const poolID = ref(props.pool.name);
    const truncateText = inject("style-truncate-text");
    function getIsTrimmable(disk) {
      if (props.pool.vdevs && disk) {
        switch (props.pool.vdevs.find((vdev) => vdev.disks.some((vDevDisk) => vDevDisk.name == disk.name)).type) {
          case "data":
            return true;
          case "log":
            return true;
          case "special":
            return true;
          case "dedup":
            return true;
          default:
            return false;
        }
      }
    }
    const adjustedScanPercentage = computed(() => {
      if (isFinished.value && parseFloat(scanPercentage.value.toFixed(2)) > 90) {
        return 100;
      }
      return parseFloat(scanPercentage.value.toFixed(2));
    });
    const scanObjectGroup = inject("scan-object-group");
    const scanActivities = inject("scan-activities");
    const scanActivity = computed(() => {
      return scanActivities.value.get(poolID.value);
    });
    function getScanStateBool(state) {
      return computed(() => {
        const poolState = scanObjectGroup.value[props.pool.name].state;
        return poolState !== "null" && poolState === state;
      });
    }
    function getScanPauseBool(pause) {
      return computed(() => {
        const poolPause = scanObjectGroup.value[props.pool.name].pause;
        return poolPause !== "null" && poolPause !== pause;
      });
    }
    const isScanning = ref(false);
    const isFinished = ref(false);
    const isCanceled = ref(false);
    const isPaused = ref(false);
    async function getScanComputedProps() {
      isScanning.value = getScanStateBool("SCANNING").value;
      isFinished.value = getScanStateBool("FINISHED").value;
      isCanceled.value = getScanStateBool("CANCELED").value;
      isPaused.value = getScanPauseBool("None").value;
    }
    async function setScanActivity(activity) {
      await getScanComputedProps();
      activity.isActive = isScanning.value;
      activity.isPaused = isPaused.value;
      activity.isFinished = isFinished.value;
      activity.isCanceled = isCanceled.value;
    }
    const scanIntervalID = inject("scan-interval");
    const scanning = ref(false);
    async function scanNow() {
      await loadScanObjectGroup(scanObjectGroup);
    }
    async function pollScanStatus() {
      await scanNow();
      await setScanActivity(scanActivity.value);
      if (scanActivity.value.isActive) {
        if (!scanActivity.value.isPaused) {
          scanning.value = true;
        } else if (scanActivity.value.isPaused) {
          scanning.value = false;
        }
      } else if (scanActivity.value.isCanceled) {
        scanning.value = false;
      } else if (scanActivity.value.isFinished) {
        scanning.value = false;
      }
    }
    function startScanInterval() {
      if (!scanIntervalID.value) {
        scanIntervalID.value = setInterval(pollScanStatus, 3e3);
        console.log("----scan interval set----", scanIntervalID.value);
      }
    }
    function stopScanInterval() {
      if (scanIntervalID.value) {
        clearInterval(scanIntervalID.value);
        console.log("----scan interval cleared----", scanIntervalID.value);
        scanIntervalID.value = null;
      }
    }
    watch(scanning, (newVal, oldVal) => {
      if (scanning.value) {
        startScanInterval();
      } else if (!scanning.value) {
        stopScanInterval();
      }
    }, { immediate: true });
    const scanFunction = computed(() => {
      switch (scanObjectGroup.value[props.pool.name].function) {
        case "RESILVER":
          return "Resilvering";
        case "SCRUB":
          return "Scrubbing";
        case "NONE":
          return "N/A";
        default:
          return;
      }
    });
    const stateMessage = computed(() => {
      if (scanObjectGroup.value[props.pool.name].state === null) {
        return `No scrub/resilver data found.`;
      } else {
        if (scanObjectGroup.value[props.pool.name] && scanObjectGroup.value[props.pool.name].pause !== "None") {
          return `${scanFunction.value} paused at  ${scanObjectGroup.value[props.pool.name].pause}`;
        } else {
          if (scanObjectGroup.value[props.pool.name]) {
            switch (scanObjectGroup.value[props.pool.name].state) {
              case "SCANNING":
                return `${scanFunction.value} started at ${convertTimestampToLocal(scanObjectGroup.value[props.pool.name].start_time)}`;
              case "FINISHED":
                return `${scanFunction.value} finished at ${convertTimestampToLocal(scanObjectGroup.value[props.pool.name].end_time)}`;
              case "CANCELED":
                return `${scanFunction.value} canceled at ${convertTimestampToLocal(scanObjectGroup.value[props.pool.name].end_time)}`;
              case "NONE":
                return "N/A";
              default:
                return "";
            }
          }
        }
      }
    });
    const miniStateMsg = computed(() => {
      if (scanObjectGroup.value[props.pool.name] && scanObjectGroup.value[props.pool.name].state === null) {
        return `No scrub/resilver data found.`;
      } else {
        if (scanObjectGroup.value[props.pool.name] && scanObjectGroup.value[props.pool.name].pause !== "None") {
          return `${scanFunction.value} Paused (${parseFloat(scanPercentage.value.toFixed(1))}%)`;
        } else {
          switch (scanObjectGroup.value[props.pool.name].state) {
            case "SCANNING":
              return `${scanFunction.value}... (${parseFloat(scanPercentage.value.toFixed(1))}%)`;
            case "FINISHED":
              return `${scanFunction.value} Complete`;
            case "CANCELED":
              return `${scanFunction.value} Canceled (${parseFloat(scanPercentage.value.toFixed(1))}%)`;
            case "NONE":
              return "N/A";
            default:
              return "";
          }
        }
      }
    });
    const displayStateMessage = computed(() => {
      if (props.pool.statusCode !== "OK") {
        return `${props.pool.statusDetail}`;
      } else {
        return stateMessage.value;
      }
    });
    const displayMiniStateMsg = computed(() => {
      if (props.pool.statusCode !== "OK") {
        return `${props.pool.statusDetail}`;
      } else {
        return miniStateMsg.value;
      }
    });
    const scanPercentage = computed(() => {
      return scanObjectGroup.value[props.pool.name].percentage;
    });
    const amountProcessed = computed(() => {
      return convertBytesToSize(scanObjectGroup.value[props.pool.name].bytes_issued);
    });
    const amountTotal = computed(() => {
      return convertBytesToSize(scanObjectGroup.value[props.pool.name].bytes_processed);
    });
    const timeRemaining = computed(() => {
      return convertSecondsToString(scanObjectGroup.value[props.pool.name].total_secs_left);
    });
    function stateMessageClass() {
      if (scanObjectGroup.value[props.pool.name] && scanObjectGroup.value[props.pool.name].pause === "None") {
        switch (scanObjectGroup.value[props.pool.name].state) {
          case "SCANNING":
            return "text-default";
          case "FINISHED":
            return "text-success";
          case "CANCELED":
            return "text-danger";
          case "NONE":
            return "text-muted";
          default:
            return "text-default";
        }
      } else {
        return "text-orange-600";
      }
    }
    function progressBarClass() {
      if (scanObjectGroup.value[props.pool.name] && scanObjectGroup.value[props.pool.name].pause === "None") {
        switch (scanObjectGroup.value[props.pool.name].state) {
          case "SCANNING":
            return "bg-blue-600";
          case "FINISHED":
            return "bg-green-600";
          case "CANCELED":
            return "bg-danger";
          case "NONE":
            return "text-muted";
          default:
            return "text-default";
        }
      } else {
        return "bg-orange-600";
      }
    }
    const poolDiskStats = inject("pool-disk-stats");
    const trimActivities = inject("trim-activities");
    const trimActivity = computed(() => {
      if (props.disk) {
        return trimActivities.value.get(props.disk.name);
      } else {
        return trimActivities.value.get(poolID.value);
      }
    });
    const selectedDisk = computed(() => {
      return poolDiskStats.value[props.pool.name].find((disk) => disk.name == props.disk.name);
    });
    const isTrimActive = computed(() => {
      return poolDiskStats.value[props.pool.name].some((disk) => disk.stats.trim_notsup !== 1 && disk.stats.trim_state === 1);
    });
    const isTrimCanceled = computed(() => {
      return poolDiskStats.value[props.pool.name].some((disk) => disk.stats.trim_notsup !== 1 && disk.stats.trim_state === 2);
    });
    const isTrimSuspended = computed(() => {
      return poolDiskStats.value[props.pool.name].some((disk) => disk.stats.trim_notsup !== 1 && disk.stats.trim_state === 3);
    });
    const isTrimFinished = computed(() => {
      return poolDiskStats.value[props.pool.name].some((disk) => disk.stats.trim_notsup !== 1 && disk.stats.trim_state === 4);
    });
    async function setTrimActivity(activity) {
      if (activity) {
        activity.isActive = isTrimActive.value;
        activity.isPaused = isTrimSuspended.value;
        activity.isFinished = isTrimFinished.value;
        activity.isCanceled = isTrimCanceled.value;
      }
    }
    const diskStatsIntervalID = inject("disk-stats-interval");
    const checkingDiskStats = ref(false);
    async function checkDiskStats() {
      await loadDiskStats(poolDiskStats);
    }
    async function pollTrimStatus() {
      await checkDiskStats();
      await setTrimActivity(trimActivity.value);
      switch (checkActivityState(trimActivity.value)) {
        case "active":
          checkingDiskStats.value = true;
          break;
        case "paused":
          checkingDiskStats.value = false;
          break;
        case "canceled":
          checkingDiskStats.value = false;
          break;
        case "finished":
          checkingDiskStats.value = false;
          break;
      }
    }
    function checkActivityState(activity) {
      if (activity.isActive) {
        return "active";
      } else if (activity.isPaused) {
        return "paused";
      } else if (activity.isCanceled) {
        return "canceled";
      } else if (activity.isFinished) {
        return "finished";
      }
    }
    function startDiskStatsInterval() {
      if (!diskStatsIntervalID.value) {
        diskStatsIntervalID.value = setInterval(pollTrimStatus, 3e3);
        console.log("****trim interval set****", diskStatsIntervalID.value);
      }
    }
    function stopDiskStatsInterval() {
      if (diskStatsIntervalID.value) {
        clearInterval(diskStatsIntervalID.value);
        console.log("****trim interval cleared****", diskStatsIntervalID.value);
        diskStatsIntervalID.value = null;
      }
    }
    watch(checkingDiskStats, (newVal, oldVal) => {
      if (checkingDiskStats.value) {
        startDiskStatsInterval();
      } else if (!checkingDiskStats.value) {
        stopDiskStatsInterval();
      }
    }, { immediate: true });
    function getTrimTimestamp(disk) {
      return convertTimestampToLocal(convertRawTimestampToString(disk.stats.trim_action_time));
    }
    function getTrimPercentage(disk) {
      if (disk.stats.trim_state == 4) {
        return 100;
      } else {
        return disk.stats.trim_bytes_done / disk.stats.trim_bytes_est * 100;
      }
    }
    function handleTrimPercentage(percentage) {
      if (percentage <= 0) {
        return 0;
      } else if (percentage >= 99.95) {
        return 100;
      } else if (percentage > 0 && percentage < 99.5) {
        return percentage;
      } else {
        return 0;
      }
    }
    function getTrimmedAmount(disk) {
      return convertBytesToSize(disk.stats.trim_bytes_done);
    }
    function getTrimmedTotal(disk) {
      return convertBytesToSize(disk.stats.trim_bytes_est);
    }
    function trimMessage(disk) {
      switch (getTrimState(disk.stats.trim_state)) {
        case "none":
          return `Trim Information N/A`;
        case "active":
          return `Trim ${getTrimState(disk.stats.trim_state)}, started at ${getTrimTimestamp(disk)}`;
        case "canceled":
          return `Trim ${getTrimState(disk.stats.trim_state)}`;
        case "suspended":
          return `Trim is ${getTrimState(disk.stats.trim_state)}`;
        case "finished":
          return `Trim ${getTrimState(disk.stats.trim_state)} at ${getTrimTimestamp(disk)}`;
      }
    }
    function getTrimState(state_num) {
      switch (state_num) {
        case 0:
          return "none";
        case 1:
          return "active";
        case 2:
          return "canceled";
        case 3:
          return "suspended";
        case 4:
          return "finished";
      }
    }
    function trimMessageClass(disk) {
      switch (getTrimState(disk.stats.trim_state)) {
        case "none":
          return ``;
        case "active":
          return "text-default";
        case "canceled":
          return "text-danger";
        case "suspended":
          return "text-orange-600";
        case "finished":
          return "text-success";
      }
    }
    function trimProgressBarClass(disk) {
      switch (getTrimState(disk.stats.trim_state)) {
        case "none":
          return ``;
        case "active":
          return "bg-blue-600";
        case "canceled":
          return "bg-danger";
        case "suspended":
          return "bg-orange-600";
        case "finished":
          return "bg-green-600";
      }
    }
    onMounted(() => {
      pollScanStatus();
      pollTrimStatus();
    });
    __expose({
      pollScanStatus,
      pollTrimStatus
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", null, [
        !_ctx.isDisk ? (openBlock(), createElementBlock("div", _hoisted_1, [
          !_ctx.isPoolList ? (openBlock(), createElementBlock("div", _hoisted_2, [
            !_ctx.isTrim ? (openBlock(), createElementBlock("div", _hoisted_3, [
              createBaseVNode("div", _hoisted_4, [
                createBaseVNode("span", {
                  class: normalizeClass(["col-span-4 mt-0.5 font-semibold", stateMessageClass()])
                }, toDisplayString(displayStateMessage.value), 3),
                createBaseVNode("div", _hoisted_5, [
                  unref(scanObjectGroup)[props.pool.name].state !== null ? (openBlock(), createElementBlock("div", _hoisted_6, [
                    createBaseVNode("div", _hoisted_7, [
                      createBaseVNode("div", {
                        class: normalizeClass([progressBarClass(), "h-6 min-h-min w-full"]),
                        style: normalizeStyle({ width: `${adjustedScanPercentage.value}%` })
                      }, [
                        createBaseVNode("div", _hoisted_8, toDisplayString(adjustedScanPercentage.value) + "% ", 1)
                      ], 6)
                    ]),
                    createBaseVNode("span", _hoisted_9, [
                      createTextVNode(toDisplayString(amountProcessed.value) + " of " + toDisplayString(amountTotal.value) + " processed. ", 1),
                      _cache[0] || (_cache[0] = createBaseVNode("br", null, null, -1))
                    ]),
                    isScanning.value && !isPaused.value && !isCanceled.value && !isFinished.value ? (openBlock(), createElementBlock("span", _hoisted_10, " Completes in " + toDisplayString(timeRemaining.value) + ". ", 1)) : createCommentVNode("", true),
                    isScanning.value && isPaused.value && !isCanceled.value && !isFinished.value ? (openBlock(), createElementBlock("span", _hoisted_11, " Resume to continue or cancel to stop. ")) : createCommentVNode("", true)
                  ])) : createCommentVNode("", true)
                ])
              ])
            ])) : createCommentVNode("", true),
            _ctx.isTrim ? (openBlock(), createElementBlock("div", _hoisted_12, [
              createBaseVNode("div", _hoisted_13, [
                (openBlock(true), createElementBlock(Fragment, null, renderList(unref(poolDiskStats)[props.pool.name], (disk, idx) => {
                  return openBlock(), createElementBlock("div", {
                    key: idx,
                    class: "col-span-4"
                  }, [
                    disk.stats.trim_notsup === 0 && getIsTrimmable(disk) ? (openBlock(), createElementBlock("div", _hoisted_14, [
                      isTrimActive.value || isTrimSuspended.value || isTrimFinished.value || isTrimCanceled.value ? (openBlock(), createElementBlock("div", _hoisted_15, [
                        createBaseVNode("div", _hoisted_16, [
                          createBaseVNode("span", {
                            class: normalizeClass(["col-span-4 font-semibold", [trimMessageClass(disk), unref(truncateText)]])
                          }, toDisplayString(trimMessage(disk)), 3),
                          createBaseVNode("span", {
                            class: normalizeClass(["col-span-4", trimMessageClass(disk)]),
                            title: disk.name
                          }, " Disk: " + toDisplayString(disk.name) + " (" + toDisplayString(unref(upperCaseWord)(props.pool.vdevs.find((vdev) => vdev.disks.some((vDevDisk) => vDevDisk.name == disk.name)).type)) + ") ", 11, _hoisted_17)
                        ]),
                        createBaseVNode("div", _hoisted_18, [
                          createBaseVNode("div", _hoisted_19, [
                            createBaseVNode("div", _hoisted_20, [
                              createBaseVNode("div", {
                                class: normalizeClass([trimProgressBarClass(disk), "h-6 min-h-min w-full"]),
                                style: normalizeStyle({ width: `${handleTrimPercentage(parseFloat(getTrimPercentage(disk).toFixed(2)))}%` })
                              }, [
                                createBaseVNode("div", _hoisted_21, toDisplayString(handleTrimPercentage(parseFloat(getTrimPercentage(disk).toFixed(2)))) + "% ", 1)
                              ], 6)
                            ])
                          ]),
                          createBaseVNode("span", _hoisted_22, [
                            createTextVNode(toDisplayString(getTrimmedAmount(disk)) + " of " + toDisplayString(getTrimmedTotal(disk)) + " processed. ", 1),
                            _cache[1] || (_cache[1] = createBaseVNode("br", null, null, -1))
                          ])
                        ])
                      ])) : createCommentVNode("", true)
                    ])) : createCommentVNode("", true),
                    disk.stats.trim_notsup === 0 && !getIsTrimmable(disk) ? (openBlock(), createElementBlock("div", _hoisted_23, [
                      createBaseVNode("span", {
                        class: normalizeClass(["col-span-4 font-base text-default", unref(truncateText)]),
                        title: disk.name
                      }, " Trim not suppported on " + toDisplayString(disk.name) + " (" + toDisplayString(unref(upperCaseWord)(props.pool.vdevs.find((vdev) => vdev.disks.some((vDevDisk) => vDevDisk.name == disk.name)).type)) + ") ", 11, _hoisted_24)
                    ])) : createCommentVNode("", true)
                  ]);
                }), 128)),
                unref(poolDiskStats)[props.pool.name].some((disk) => disk.stats.trim_notsup == 1) ? (openBlock(), createElementBlock("div", _hoisted_25, [
                  createBaseVNode("div", _hoisted_26, [
                    createBaseVNode("span", _hoisted_27, [
                      _cache[2] || (_cache[2] = createTextVNode(" Trim not supported on disks: ")),
                      _cache[3] || (_cache[3] = createBaseVNode("br", null, null, -1)),
                      createBaseVNode("div", {
                        class: normalizeClass([unref(poolDiskStats)[props.pool.name].filter((disk) => disk.stats.trim_notsup === 1).length < 5 ? `grid-cols-${unref(poolDiskStats)[props.pool.name].filter((disk) => disk.stats.trim_notsup === 1).length}` : "grid-cols-4", "grid col-span-4 gap-1 mt-1 justify-center"])
                      }, [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(unref(poolDiskStats)[props.pool.name].filter((disk) => disk.stats.trim_notsup === 1), (disk, idx) => {
                          return openBlock(), createElementBlock("span", {
                            title: disk.name,
                            class: normalizeClass([unref(truncateText), ""])
                          }, toDisplayString(disk.name), 11, _hoisted_28);
                        }), 256))
                      ], 2)
                    ])
                  ])
                ])) : createCommentVNode("", true),
                isTrimSuspended.value ? (openBlock(), createElementBlock("div", _hoisted_29, " Resume to continue or cancel to stop. ")) : createCommentVNode("", true)
              ])
            ])) : createCommentVNode("", true)
          ])) : createCommentVNode("", true),
          _ctx.isPoolList ? (openBlock(), createElementBlock("div", _hoisted_30, [
            createBaseVNode("div", _hoisted_31, [
              unref(scanObjectGroup)[props.pool.name].state !== null ? (openBlock(), createElementBlock("div", _hoisted_32, [
                createBaseVNode("div", {
                  class: normalizeClass([[stateMessageClass(), unref(truncateText)], "font-semibold text-sm"]),
                  title: displayMiniStateMsg.value
                }, toDisplayString(displayMiniStateMsg.value), 11, _hoisted_33),
                createBaseVNode("div", _hoisted_34, [
                  createBaseVNode("div", {
                    class: normalizeClass([progressBarClass(), "h-3"]),
                    style: normalizeStyle({ width: `${parseFloat(scanPercentage.value.toFixed(2))}%` })
                  }, [
                    createBaseVNode("div", _hoisted_35, toDisplayString(amountProcessed.value) + "/" + toDisplayString(amountTotal.value), 1)
                  ], 6)
                ])
              ])) : createCommentVNode("", true),
              unref(scanObjectGroup)[props.pool.name].state === null ? (openBlock(), createElementBlock("div", {
                key: 1,
                class: normalizeClass(["col-span-2 mt-2", unref(truncateText)]),
                title: displayMiniStateMsg.value
              }, [
                createBaseVNode("span", {
                  class: normalizeClass(stateMessageClass())
                }, toDisplayString(displayMiniStateMsg.value), 3)
              ], 10, _hoisted_36)) : createCommentVNode("", true)
            ])
          ])) : createCommentVNode("", true)
        ])) : createCommentVNode("", true),
        _ctx.isDisk ? (openBlock(), createElementBlock("div", _hoisted_37, [
          selectedDisk.value ? (openBlock(), createElementBlock("div", _hoisted_38, [
            selectedDisk.value.stats.trim_notsup === 0 && getIsTrimmable(_ctx.disk) ? (openBlock(), createElementBlock("div", _hoisted_39, [
              getTrimState(selectedDisk.value.stats.trim_state) !== "none" ? (openBlock(), createElementBlock("span", {
                key: 0,
                class: normalizeClass([[trimMessageClass(selectedDisk.value), unref(truncateText)], "font-semibold text-sm"])
              }, " Trim " + toDisplayString(unref(upperCaseWord)(getTrimState(selectedDisk.value.stats.trim_state))) + " (" + toDisplayString(handleTrimPercentage(parseFloat(getTrimPercentage(selectedDisk.value).toFixed(2)))) + "%) ", 3)) : createCommentVNode("", true),
              getTrimState(selectedDisk.value.stats.trim_state) == "none" ? (openBlock(), createElementBlock("span", {
                key: 1,
                class: normalizeClass([[trimMessageClass(selectedDisk.value), unref(truncateText)], "mt-2"])
              }, " No Trim Activity ", 2)) : createCommentVNode("", true),
              getTrimState(selectedDisk.value.stats.trim_state) !== "none" ? (openBlock(), createElementBlock("div", _hoisted_40, [
                createBaseVNode("div", {
                  class: normalizeClass([trimProgressBarClass(selectedDisk.value), "h-3"]),
                  style: normalizeStyle({ width: `${handleTrimPercentage(parseFloat(getTrimPercentage(selectedDisk.value).toFixed(2)))}%` })
                }, [
                  createBaseVNode("div", _hoisted_41, toDisplayString(getTrimmedAmount(selectedDisk.value)) + "/" + toDisplayString(getTrimmedTotal(selectedDisk.value)), 1)
                ], 6)
              ])) : createCommentVNode("", true)
            ])) : createCommentVNode("", true),
            selectedDisk.value.stats.trim_notsup === 1 ? (openBlock(), createElementBlock("div", _hoisted_42, [
              createBaseVNode("span", {
                class: normalizeClass(["text-muted", unref(truncateText)])
              }, " Trim not suppported (" + toDisplayString(props.disk.type) + "). ", 3)
            ])) : createCommentVNode("", true),
            selectedDisk.value.stats.trim_notsup === 0 && !getIsTrimmable(_ctx.disk) ? (openBlock(), createElementBlock("div", _hoisted_43, [
              createBaseVNode("span", {
                class: normalizeClass(["text-muted", unref(truncateText)])
              }, " Trim not suppported (" + toDisplayString(unref(upperCaseWord)(props.pool.vdevs.find((vdev) => vdev.disks.some((vDevDisk) => vDevDisk.name == selectedDisk.value.name)).type)) + "). ", 3)
            ])) : createCommentVNode("", true)
          ])) : createCommentVNode("", true),
          !selectedDisk.value ? (openBlock(), createElementBlock("div", _hoisted_44, [
            createBaseVNode("span", {
              class: normalizeClass(["text-muted", unref(truncateText)])
            }, " Disk is missing or being replaced. ", 2)
          ])) : createCommentVNode("", true)
        ])) : createCommentVNode("", true)
      ]);
    };
  }
});
export {
  _sfc_main as _
};
