import { d as defineComponent, r as ref, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, ax as withDirectives, aZ as withKeys, aG as vModelText, y as createElementBlock, E as toDisplayString, G as createCommentVNode, Z as createTextVNode, aH as _sfc_main$1, bq as testSSH } from "./index.6d4442b8.js";
const _hoisted_1 = ["for"];
const _hoisted_2 = ["id"];
const _hoisted_3 = {
  key: 0,
  class: "text-success mt-2"
};
const _hoisted_4 = {
  key: 1,
  class: "text-danger mt-2"
};
const _hoisted_5 = { class: "w-full grid grid-rows-1" };
const _hoisted_6 = { class: "button-group-row mt-2 justify-between" };
const _hoisted_7 = ["id"];
const _hoisted_8 = ["id"];
const _hoisted_9 = ["id"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "TestSSHModal",
  props: {
    idKey: {},
    showFlag: { type: Boolean }
  },
  emits: ["close"],
  setup(__props, { emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const showFlag = ref(props.showFlag);
    const updateShowFlag = () => {
      if (props.showFlag != showFlag.value) {
        showFlag.value = props.showFlag;
      }
    };
    const closeModal = () => {
      emit("close");
    };
    const sshTarget = ref("");
    const testing = ref(false);
    const resultMsg = ref("");
    const result = ref(false);
    async function confirmTest(sshTarget2) {
      testing.value = true;
      resultMsg.value = "";
      result.value = await testSSH(sshTarget2);
      if (result.value) {
        resultMsg.value = "Connection Successful!";
      } else {
        resultMsg.value = `Connection Failed: Could not resolve hostname ${sshTarget2}: Name or service not known.`;
      }
      testing.value = false;
    }
    const getIdKey = (name) => `${props.idKey}-${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: showFlag.value,
        onClose: updateShowFlag,
        marginTop: "mt-60",
        width: "w-96",
        minWidth: "min-w-min",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[3] || (_cache[3] = [
          createBaseVNode("legend", { class: "flex justify-center" }, "Test Passwordless SSH Connection", -1)
        ])),
        content: withCtx(() => [
          createBaseVNode("label", {
            for: getIdKey("ssh-test"),
            class: "mt-1 block text-sm font-medium leading-6 text-default"
          }, "SSH Target:", 8, _hoisted_1),
          withDirectives(createBaseVNode("input", {
            onKeydown: _cache[0] || (_cache[0] = withKeys(() => {
            }, ["enter"])),
            id: getIdKey("ssh-test"),
            type: "text",
            class: "input-textlike bg-default mt-1 block w-full py-1.5 px-1.5 text-default",
            name: "ssh-target",
            "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => sshTarget.value = $event),
            placeholder: "user@hostname or just hostname"
          }, null, 40, _hoisted_2), [
            [vModelText, sshTarget.value]
          ]),
          result.value ? (openBlock(), createElementBlock("p", _hoisted_3, toDisplayString(resultMsg.value), 1)) : createCommentVNode("", true),
          !result.value ? (openBlock(), createElementBlock("p", _hoisted_4, toDisplayString(resultMsg.value), 1)) : createCommentVNode("", true)
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_5, [
            createBaseVNode("div", _hoisted_6, [
              createBaseVNode("button", {
                onClick: closeModal,
                id: getIdKey("confirm-no"),
                name: "button-no",
                class: "mt-1 btn btn-secondary object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_7),
              !testing.value ? (openBlock(), createElementBlock("button", {
                key: 0,
                onClick: _cache[2] || (_cache[2] = ($event) => confirmTest(sshTarget.value)),
                id: getIdKey("confirm-yes-A"),
                name: "button-yes-A",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, "Test", 8, _hoisted_8)) : createCommentVNode("", true),
              testing.value ? (openBlock(), createElementBlock("button", {
                key: 1,
                disabled: "",
                id: getIdKey("confirm-spinner"),
                type: "button",
                class: "btn btn-danger object-right justify-end h-fit"
              }, _cache[4] || (_cache[4] = [
                createBaseVNode("svg", {
                  "aria-hidden": "true",
                  role: "status",
                  class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                  viewBox: "0 0 100 101",
                  fill: "none",
                  xmlns: "http://www.w3.org/2000/svg"
                }, [
                  createBaseVNode("path", {
                    d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                    fill: "currentColor"
                  }),
                  createBaseVNode("path", {
                    d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                    fill: "text-success"
                  })
                ], -1),
                createTextVNode(" Testing... ")
              ]), 8, _hoisted_9)) : createCommentVNode("", true)
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
