import { d as defineComponent, i as inject, r as ref, w as watch, c as computed, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, E as toDisplayString, D as unref, $ as upperCaseWord, y as createElementBlock, C as normalizeClass, Z as createTextVNode, G as createCommentVNode, O as Fragment, P as renderList, A as createVNode, aP as isRef, aH as _sfc_main$1 } from "./index.6d4442b8.js";
import { u as ue } from "./switch.bba63450.js";
const _hoisted_1 = { class: "flex justify-center" };
const _hoisted_2 = { class: "grid grid-flow-row mt-3 text-center" };
const _hoisted_3 = ["title"];
const _hoisted_4 = ["title"];
const _hoisted_5 = ["title"];
const _hoisted_6 = ["title"];
const _hoisted_7 = {
  key: 2,
  class: "text-default row-start-1"
};
const _hoisted_8 = {
  key: 3,
  class: "text-default text-left items-center divide-y divide-default row-start-2 p-2 bg-accent overflow-y-auto max-h-96"
};
const _hoisted_9 = { key: 4 };
const _hoisted_10 = {
  key: 0,
  class: "w-full"
};
const _hoisted_11 = { class: "font-medium text-sm grid grid-flow-row justify-items-center justify-center" };
const _hoisted_12 = { class: "justify-self-center text-default" };
const _hoisted_13 = { class: "grid grid-rows-2" };
const _hoisted_14 = { class: "flex flex-row justify-between" };
const _hoisted_15 = ["for"];
const _hoisted_16 = { class: "flex flex-row justify-between" };
const _hoisted_17 = ["for"];
const _hoisted_18 = { key: 1 };
const _hoisted_19 = { class: "text-danger font-medium grid grid-rows-3 row-span-3 row-start-2 justify-items-center gap-0.5" };
const _hoisted_20 = { class: "text-danger row-start-2" };
const _hoisted_21 = { class: "text-default row-start-3" };
const _hoisted_22 = { class: "text-danger" };
const _hoisted_23 = { key: 5 };
const _hoisted_24 = {
  key: 6,
  class: "flex flex-row justify-between mt-1"
};
const _hoisted_25 = ["for"];
const _hoisted_26 = {
  key: 7,
  class: "flex flex-row justify-between mt-1"
};
const _hoisted_27 = ["for"];
const _hoisted_28 = { class: "w-full grid grid-rows-1" };
const _hoisted_29 = { class: "button-group-row justify-between" };
const _hoisted_30 = ["id"];
const _hoisted_31 = ["id"];
const _hoisted_32 = ["id"];
const _hoisted_33 = ["id"];
const _hoisted_34 = ["id"];
const _hoisted_35 = ["id"];
const _hoisted_36 = ["id"];
const _hoisted_37 = ["id"];
const _hoisted_38 = ["id"];
const _hoisted_39 = ["id"];
const _hoisted_40 = ["id"];
const _hoisted_41 = ["id"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "UniversalConfirmation",
  props: {
    showFlag: { type: Boolean },
    idKey: {},
    item: {},
    operation: {},
    operation2: {},
    confirmOperation: {},
    pool: {},
    vdev: {},
    disk: {},
    filesystem: {},
    snapshot: {},
    snapshots: {},
    firstOption: {},
    secondOption: {},
    hasChildren: { type: Boolean }
  },
  emits: ["close"],
  setup(__props, { emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const operationRunning = inject("modal-confirm-running");
    const showFlag = ref(props.showFlag);
    const closeModal = () => {
      option1Toggle.value = false;
      option2Toggle.value = false;
      emit("close");
    };
    const truncateText = inject("style-truncate-text");
    const option1 = props.firstOption;
    const option1Toggle = inject("modal-option-one-toggle");
    const option2 = props.secondOption;
    const option2Toggle = inject("modal-option-two-toggle");
    const destroyChildrenToggle = inject("modal-option-three-toggle");
    const destroyAllDependentsToggle = inject("modal-option-four-toggle");
    const operating = ref("");
    switch (props.operation) {
      case "destroy":
        operating.value = "Destroying...";
        break;
      case "trim":
        operating.value = "Trimming...";
        break;
      case "resilver":
        operating.value = "Resilvering...";
        break;
      case "scrub":
        operating.value = "Scrubbing...";
        break;
      case "remove":
        operating.value = "Removing...";
        break;
      case "detach":
        operating.value = "Detaching...";
        break;
      case "unmount":
        operating.value = "Unmounting...";
        break;
      case "export":
        operating.value = "Exporting...";
        break;
      case "pause":
        operating.value = "Pausing...";
        break;
      case "stop":
        operating.value = "Stopping...";
        break;
    }
    watch([destroyAllDependentsToggle], (newVal, oldVal) => {
      if (destroyAllDependentsToggle.value == true) {
        destroyChildrenToggle.value = false;
      }
    });
    watch([destroyChildrenToggle], (newVal, oldVal) => {
      if (destroyChildrenToggle.value == true) {
        destroyAllDependentsToggle.value = false;
      }
    });
    const hasChildrenButtonRender = computed(() => {
      return destroyChildrenToggle.value || destroyAllDependentsToggle.value;
    });
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: showFlag.value,
        onClose: _cache[14] || (_cache[14] = ($event) => closeModal()),
        marginTop: "mt-56",
        width: "w-96",
        minWidth: "min-w-min",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => [
          createBaseVNode("legend", _hoisted_1, toDisplayString(unref(upperCaseWord)(props.operation)) + " " + toDisplayString(unref(upperCaseWord)(props.item)), 1)
        ]),
        content: withCtx(() => [
          createBaseVNode("div", _hoisted_2, [
            !_ctx.operation2 && props.item !== "snapshots" ? (openBlock(), createElementBlock("p", {
              key: 0,
              class: normalizeClass(["text-default row-start-1", unref(truncateText)]),
              title: props[props.item].name
            }, [
              createTextVNode("Are you sure you wish to " + toDisplayString(props.operation) + " ", 1),
              createBaseVNode("b", {
                class: normalizeClass(unref(truncateText)),
                title: props[props.item].name
              }, toDisplayString(props[props.item].name), 11, _hoisted_4),
              _cache[15] || (_cache[15] = createTextVNode("?"))
            ], 10, _hoisted_3)) : createCommentVNode("", true),
            _ctx.operation2 && props.item !== "snapshots" ? (openBlock(), createElementBlock("p", {
              key: 1,
              class: normalizeClass(["text-default row-start-1", unref(truncateText)]),
              title: props[props.item].name
            }, [
              createTextVNode("Are you sure you wish to " + toDisplayString(props.operation) + " " + toDisplayString(props.operation2) + " on ", 1),
              createBaseVNode("b", {
                class: normalizeClass(unref(truncateText)),
                title: props[props.item].name
              }, toDisplayString(props[props.item].name), 11, _hoisted_6),
              _cache[16] || (_cache[16] = createTextVNode("?"))
            ], 10, _hoisted_5)) : createCommentVNode("", true),
            props.item == "snapshots" ? (openBlock(), createElementBlock("p", _hoisted_7, "Are you sure you wish to destroy these snapshots?")) : createCommentVNode("", true),
            props.item == "snapshots" ? (openBlock(), createElementBlock("div", _hoisted_8, [
              (openBlock(true), createElementBlock(Fragment, null, renderList(props.snapshots, (snapshot, idx) => {
                return openBlock(), createElementBlock("p", { key: idx }, toDisplayString(snapshot), 1);
              }), 128))
            ])) : createCommentVNode("", true),
            props.operation == "destroy" && props.hasChildren ? (openBlock(), createElementBlock("div", _hoisted_9, [
              props.item == "filesystem" ? (openBlock(), createElementBlock("div", _hoisted_10, [
                createBaseVNode("div", _hoisted_11, [
                  _cache[18] || (_cache[18] = createBaseVNode("p", { class: "justify-self-center text-danger font-medium mt-3" }, "WARNING!!!", -1)),
                  createBaseVNode("p", _hoisted_12, [
                    createTextVNode("This " + toDisplayString(props.item) + " ", 1),
                    _cache[17] || (_cache[17] = createBaseVNode("span", { class: "text-danger" }, "has children.", -1))
                  ]),
                  _cache[19] || (_cache[19] = createBaseVNode("p", { class: "justify-self-center grid grid-flow-row justify-center justify-items-center text-default w-full" }, [
                    createTextVNode("If you wish to destroy, use either "),
                    createBaseVNode("br"),
                    createBaseVNode("span", { class: "text-danger" }, "Destroy all children"),
                    createTextVNode(" or "),
                    createBaseVNode("br"),
                    createBaseVNode("span", { class: "text-danger" }, "Destroy all dependents.")
                  ], -1))
                ]),
                createBaseVNode("div", _hoisted_13, [
                  createBaseVNode("div", _hoisted_14, [
                    createBaseVNode("label", {
                      for: getIdKey("destroy-children"),
                      class: "mt-2 mr-2 block text-sm font-medium text-default"
                    }, "Destroy all children", 8, _hoisted_15),
                    createVNode(unref(ue), {
                      modelValue: unref(destroyChildrenToggle),
                      "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => isRef(destroyChildrenToggle) ? destroyChildrenToggle.value = $event : null),
                      id: getIdKey("destroy-children"),
                      class: normalizeClass([unref(destroyChildrenToggle) ? "bg-primary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                    }, {
                      default: withCtx(() => [
                        _cache[22] || (_cache[22] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                        createBaseVNode("span", {
                          class: normalizeClass([unref(destroyChildrenToggle) ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                        }, [
                          createBaseVNode("span", {
                            class: normalizeClass([unref(destroyChildrenToggle) ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                            "aria-hidden": "true"
                          }, _cache[20] || (_cache[20] = [
                            createBaseVNode("svg", {
                              class: "h-3 w-3 text-muted",
                              fill: "none",
                              viewBox: "0 0 12 12"
                            }, [
                              createBaseVNode("path", {
                                d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                                stroke: "currentColor",
                                "stroke-width": "2",
                                "stroke-linecap": "round",
                                "stroke-linejoin": "round"
                              })
                            ], -1)
                          ]), 2),
                          createBaseVNode("span", {
                            class: normalizeClass([unref(destroyChildrenToggle) ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                            "aria-hidden": "true"
                          }, _cache[21] || (_cache[21] = [
                            createBaseVNode("svg", {
                              class: "h-3 w-3 text-primary",
                              fill: "currentColor",
                              viewBox: "0 0 12 12"
                            }, [
                              createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                            ], -1)
                          ]), 2)
                        ], 2)
                      ]),
                      _: 1
                    }, 8, ["modelValue", "id", "class"])
                  ]),
                  createBaseVNode("div", _hoisted_16, [
                    createBaseVNode("label", {
                      for: getIdKey("destroy-dependents"),
                      class: "mt-2 mr-2 block text-sm font-medium text-default"
                    }, "Destroy all dependents (children + clones)", 8, _hoisted_17),
                    createVNode(unref(ue), {
                      modelValue: unref(destroyAllDependentsToggle),
                      "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => isRef(destroyAllDependentsToggle) ? destroyAllDependentsToggle.value = $event : null),
                      id: getIdKey("destroy-dependents"),
                      class: normalizeClass([unref(destroyAllDependentsToggle) ? "bg-primary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                    }, {
                      default: withCtx(() => [
                        _cache[25] || (_cache[25] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                        createBaseVNode("span", {
                          class: normalizeClass([unref(destroyAllDependentsToggle) ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                        }, [
                          createBaseVNode("span", {
                            class: normalizeClass([unref(destroyAllDependentsToggle) ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                            "aria-hidden": "true"
                          }, _cache[23] || (_cache[23] = [
                            createBaseVNode("svg", {
                              class: "h-3 w-3 text-muted",
                              fill: "none",
                              viewBox: "0 0 12 12"
                            }, [
                              createBaseVNode("path", {
                                d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                                stroke: "currentColor",
                                "stroke-width": "2",
                                "stroke-linecap": "round",
                                "stroke-linejoin": "round"
                              })
                            ], -1)
                          ]), 2),
                          createBaseVNode("span", {
                            class: normalizeClass([unref(destroyAllDependentsToggle) ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                            "aria-hidden": "true"
                          }, _cache[24] || (_cache[24] = [
                            createBaseVNode("svg", {
                              class: "h-3 w-3 text-primary",
                              fill: "currentColor",
                              viewBox: "0 0 12 12"
                            }, [
                              createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                            ], -1)
                          ]), 2)
                        ], 2)
                      ]),
                      _: 1
                    }, 8, ["modelValue", "id", "class"])
                  ])
                ])
              ])) : createCommentVNode("", true),
              props.item == "snapshot" ? (openBlock(), createElementBlock("div", _hoisted_18, [
                createBaseVNode("div", _hoisted_19, [
                  _cache[28] || (_cache[28] = createBaseVNode("p", { class: "text-danger font-medium row-start-1 mt-3" }, "WARNING!!!", -1)),
                  createBaseVNode("p", _hoisted_20, "This " + toDisplayString(props.item) + " has dependent clones.", 1),
                  createBaseVNode("p", _hoisted_21, [
                    createTextVNode("If you wish to " + toDisplayString(props.operation) + ", use ", 1),
                    _cache[26] || (_cache[26] = createBaseVNode("br", null, null, -1)),
                    createBaseVNode("span", _hoisted_22, toDisplayString(unref(upperCaseWord)(unref(option2))), 1),
                    _cache[27] || (_cache[27] = createTextVNode("."))
                  ])
                ])
              ])) : createCommentVNode("", true)
            ])) : createCommentVNode("", true),
            props.operation == "rollback" && props.item == "snapshot" ? (openBlock(), createElementBlock("div", _hoisted_23, _cache[29] || (_cache[29] = [
              createBaseVNode("legend", { class: "text-danger font-medium" }, "All data that has changed since the snapshot will be discarded.", -1)
            ]))) : createCommentVNode("", true),
            props.firstOption ? (openBlock(), createElementBlock("div", _hoisted_24, [
              createBaseVNode("label", {
                for: getIdKey("option-one"),
                class: "mt-1.5 mr-2 block text-sm font-medium text-default"
              }, toDisplayString(unref(upperCaseWord)(unref(option1))), 9, _hoisted_25),
              createVNode(unref(ue), {
                modelValue: unref(option1Toggle),
                "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => isRef(option1Toggle) ? option1Toggle.value = $event : null),
                id: getIdKey("option-one"),
                class: normalizeClass([unref(option1Toggle) ? "bg-primary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
              }, {
                default: withCtx(() => [
                  _cache[32] || (_cache[32] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                  createBaseVNode("span", {
                    class: normalizeClass([unref(option1Toggle) ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                  }, [
                    createBaseVNode("span", {
                      class: normalizeClass([unref(option1Toggle) ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[30] || (_cache[30] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-muted",
                        fill: "none",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", {
                          d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                          stroke: "currentColor",
                          "stroke-width": "2",
                          "stroke-linecap": "round",
                          "stroke-linejoin": "round"
                        })
                      ], -1)
                    ]), 2),
                    createBaseVNode("span", {
                      class: normalizeClass([unref(option1Toggle) ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[31] || (_cache[31] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-primary",
                        fill: "currentColor",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                      ], -1)
                    ]), 2)
                  ], 2)
                ]),
                _: 1
              }, 8, ["modelValue", "id", "class"])
            ])) : createCommentVNode("", true),
            props.secondOption ? (openBlock(), createElementBlock("div", _hoisted_26, [
              createBaseVNode("label", {
                for: getIdKey("option-two"),
                class: "mt-1.5 mr-2 block text-sm font-medium leading-6 text-default"
              }, toDisplayString(unref(upperCaseWord)(unref(option2))), 9, _hoisted_27),
              createVNode(unref(ue), {
                modelValue: unref(option2Toggle),
                "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => isRef(option2Toggle) ? option2Toggle.value = $event : null),
                id: getIdKey("option-two"),
                class: normalizeClass([unref(option2Toggle) ? "bg-primary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
              }, {
                default: withCtx(() => [
                  _cache[35] || (_cache[35] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                  createBaseVNode("span", {
                    class: normalizeClass([unref(option2Toggle) ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                  }, [
                    createBaseVNode("span", {
                      class: normalizeClass([unref(option2Toggle) ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[33] || (_cache[33] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-muted",
                        fill: "none",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", {
                          d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                          stroke: "currentColor",
                          "stroke-width": "2",
                          "stroke-linecap": "round",
                          "stroke-linejoin": "round"
                        })
                      ], -1)
                    ]), 2),
                    createBaseVNode("span", {
                      class: normalizeClass([unref(option2Toggle) ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                      "aria-hidden": "true"
                    }, _cache[34] || (_cache[34] = [
                      createBaseVNode("svg", {
                        class: "h-3 w-3 text-primary",
                        fill: "currentColor",
                        viewBox: "0 0 12 12"
                      }, [
                        createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                      ], -1)
                    ]), 2)
                  ], 2)
                ]),
                _: 1
              }, 8, ["modelValue", "id", "class"])
            ])) : createCommentVNode("", true)
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_28, [
            createBaseVNode("div", _hoisted_29, [
              createBaseVNode("button", {
                onClick: closeModal,
                id: getIdKey("confirm-no"),
                name: "button-no",
                class: "mt-1 btn btn-secondary object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_30),
              props.item == "filesystem" && !unref(operationRunning) && !_ctx.hasChildren ? (openBlock(), createElementBlock("button", {
                key: 0,
                onClick: _cache[4] || (_cache[4] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-A1"),
                name: "button-yes-A",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_31)) : createCommentVNode("", true),
              props.item == "filesystem" && !unref(operationRunning) && _ctx.hasChildren && !hasChildrenButtonRender.value ? (openBlock(), createElementBlock("button", {
                key: 1,
                disabled: "",
                onClick: _cache[5] || (_cache[5] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-C1"),
                name: "button-yes-C",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_32)) : createCommentVNode("", true),
              props.item == "filesystem" && !unref(operationRunning) && _ctx.hasChildren && hasChildrenButtonRender.value ? (openBlock(), createElementBlock("button", {
                key: 2,
                onClick: _cache[6] || (_cache[6] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-B1"),
                name: "button-yes-B",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_33)) : createCommentVNode("", true),
              props.item == "snapshot" && !unref(operationRunning) && _ctx.hasChildren && !unref(option2Toggle) ? (openBlock(), createElementBlock("button", {
                key: 3,
                disabled: "",
                onClick: _cache[7] || (_cache[7] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-C2"),
                name: "button-yes-C",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_34)) : createCommentVNode("", true),
              props.item == "snapshot" && !unref(operationRunning) && _ctx.hasChildren && unref(option2Toggle) ? (openBlock(), createElementBlock("button", {
                key: 4,
                onClick: _cache[8] || (_cache[8] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-B2"),
                name: "button-yes-B",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_35)) : createCommentVNode("", true),
              props.item == "snapshot" && !unref(operationRunning) && !_ctx.hasChildren ? (openBlock(), createElementBlock("button", {
                key: 5,
                onClick: _cache[9] || (_cache[9] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-B2"),
                name: "button-yes-B",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_36)) : createCommentVNode("", true),
              props.item != "snapshot" && props.item != "snapshots" && props.item != "filesystem" && !unref(operationRunning) && !_ctx.hasChildren && !unref(option1) ? (openBlock(), createElementBlock("button", {
                key: 6,
                onClick: _cache[10] || (_cache[10] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-A3"),
                name: "button-yes-A",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_37)) : createCommentVNode("", true),
              props.item != "snapshot" && props.item != "snapshots" && props.item != "filesystem" && !unref(operationRunning) && _ctx.hasChildren && !unref(option1) ? (openBlock(), createElementBlock("button", {
                key: 7,
                disabled: "",
                onClick: _cache[11] || (_cache[11] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-C3"),
                name: "button-yes-C",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_38)) : createCommentVNode("", true),
              props.item != "snapshot" && props.item != "snapshots" && props.item != "filesystem" && !unref(operationRunning) && unref(option1) ? (openBlock(), createElementBlock("button", {
                key: 8,
                onClick: _cache[12] || (_cache[12] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-B3"),
                name: "button-yes-B",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_39)) : createCommentVNode("", true),
              props.item == "snapshots" && !unref(operationRunning) ? (openBlock(), createElementBlock("button", {
                key: 9,
                onClick: _cache[13] || (_cache[13] = (...args) => _ctx.confirmOperation && _ctx.confirmOperation(...args)),
                id: getIdKey("confirm-yes-B3"),
                name: "button-yes-B3",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.operation)), 9, _hoisted_40)) : createCommentVNode("", true),
              unref(operationRunning) ? (openBlock(), createElementBlock("button", {
                key: 10,
                disabled: "",
                id: getIdKey("confirm-spinner"),
                type: "button",
                class: "btn btn-danger object-right justify-end h-fit"
              }, [
                _cache[36] || (_cache[36] = createBaseVNode("svg", {
                  "aria-hidden": "true",
                  role: "status",
                  class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                  viewBox: "0 0 100 101",
                  fill: "none",
                  xmlns: "http://www.w3.org/2000/svg"
                }, [
                  createBaseVNode("path", {
                    d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                    fill: "currentColor"
                  }),
                  createBaseVNode("path", {
                    d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                    fill: "text-success"
                  })
                ], -1)),
                createTextVNode(" " + toDisplayString(operating.value), 1)
              ], 8, _hoisted_41)) : createCommentVNode("", true)
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
